/* Cet exemple libre provenait du Magazine Dream/Login n69		*/
/* Alain Thellier l'a beaucoup amelior en Aout 2008			*/
/* Cet exemple montre comment en utilisant la 				*/
/* super-fonction glDrawElements() on peut tracer un objet+texture*/
/* avec OpenGL/StormMesa de la plus simple faon			*/

/* This Free Source example come from Dream/Login Magazine #69	*/
/* Alain Thellier enhanced it a lot in August 2008			*/
/* This example show how to use the						*/
/* super-function glDrawElements() to draw a textured object	*/
/* with OpenGL/StormMesa the simplest way					*/

#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <inline/gl.h>
#include <inline/glut.h>

static GLfloat xRot = 0.0;
static GLfloat yRot = 0.0;
static GLfloat zRot = 0.0;
GLuint textureID,windowID;
unsigned char *texture=NULL;

#include "StarShip.h"

static void DrawObject(void)
{
	glBindTexture(GL_TEXTURE_2D, textureID);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);

	glInterleavedArrays(GL_T2F_V3F, 0, coordinates);
	glDrawElements(GL_TRIANGLES, PI3NB, GL_UNSIGNED_INT, indices);

	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
}

static void DisplayFunc(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
	glRotatef(zRot, 0.0f, 0.0f, 1.0f);
		DrawObject();
	glPopMatrix();
	glutSwapBuffers();
}


static void IdleFunc(void)
{
	xRot -= 0.60;	yRot += 0.40;	zRot += 0.20;
	if(xRot<0.0) xRot+=360.0; if(360.0<=xRot) xRot-=360.0;
	if(yRot<0.0) yRot+=360.0; if(360.0<=yRot) yRot-=360.0;
	if(zRot<0.0) zRot+=360.0; if(360.0<=zRot) zRot-=360.0;
	glutPostRedisplay();
}

static void ReshapeFunc(GLsizei width, GLsizei height)
{
	GLfloat h = (GLfloat) height / (GLfloat) width;

	glViewport(0, 0,  width,  height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
/*	glFrustum(-1.0, 1.0, -h, h, 0.0, 1.0);  */
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0, 0.0,0.0);
}

void VisibilityFunc(int vis)
{
	if (vis == GLUT_VISIBLE)
		glutIdleFunc(IdleFunc);
	else
		glutIdleFunc(NULL);
}

void KeyboardFunc(unsigned char key,int x, int y)
{
   switch (key)
	{
      case 27:
	      glutDestroyWindow(windowID);
		free(texture);
	      exit(1);
 	default:
      	break;
    }
}

int LoadFile(unsigned char *buffer, char* name,long bufferSize)
{
	FILE *fp;
	long size;

	fp = fopen(name,"rb");
	if(fp == NULL)
	{
		printf("Cant open file !\n");
		return 0;
	}

	size = fread(buffer,bufferSize,1,fp);
	if(size ==0 )
	{
		printf("Cant read file !\n");
		return 0;
	}
	fclose(fp);

	return 1;
}



void STACK_glTexImage2D( GLenum target, GLint level, GLint internalFormat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels )
{
/*GCC patch :  here will have enough registers to call the glTexImage2D function */
	glTexImage2D(target,level,internalFormat,width,height,border,format,type,pixels);      
}

GLuint  LoadTexture(char* name,int size,int bits)
{
unsigned long textureSize = size*size*bits/8;

	texture = (unsigned char *) malloc(textureSize);
	if(texture==NULL)
		{
	      glutDestroyWindow(windowID);
	      exit(1);
		}
	LoadFile(texture,name,textureSize);
	glGenTextures(1,&textureID);
	glBindTexture(GL_TEXTURE_2D, textureID);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
STACK_glTexImage2D(GL_TEXTURE_2D,0,bits/8,size,size,0,GL_RGB,GL_UNSIGNED_BYTE, texture);
	glEnable(GL_TEXTURE_2D);
	return(textureID);
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	windowID=glutCreateWindow("StarShip Demo (Esc to exit)");

	LoadTexture(TEXNAME,TEXSIZE,24);

	glDisable(GL_BLEND);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glFrontFace(GL_CW);

	glutDisplayFunc(DisplayFunc);
	glutReshapeFunc(ReshapeFunc);
	glutVisibilityFunc(VisibilityFunc);
	glutKeyboardFunc(KeyboardFunc);

	glutMainLoop();
	return 0;
}
