/* Cet exemple libre provient du Magazine Dream/Login 69	*/
/* Il a t modifi par Alain Thellier en 2008			*/

#include <stdio.h>
#include <stdlib.h>
#include <gl/glut.h>

static GLfloat xRot = 0.0;
static GLfloat yRot = 0.0;
static GLfloat zRot = 0.0;
GLuint textureNumber;
unsigned char *texture=NULL;
unsigned long textureSize = 256*256*24/8; 

GLfloat coordinates[] = {
			0.0, 0.0, -20.0,  20.0,  20.0,
			0.0, 1.0, -20.0, -20.0,  20.0,  
			1.0, 1.0,  20.0, -20.0,  20.0,
			1.0, 0.0,  20.0,  20.0,  20.0, 	
			0.0, 0.0,  20.0,  20.0, -20.0,
			0.0, 1.0,  20.0, -20.0, -20.0, 
			1.0, 1.0, -20.0, -20.0, -20.0,
			1.0, 0.0, -20.0,  20.0, -20.0, 	
			0.0, 0.0, -20.0,  20.0,  20.0,
			0.0, 1.0,  20.0,  20.0,  20.0,  
			1.0, 1.0,  20.0,  20.0, -20.0,
			1.0, 0.0, -20.0,  20.0, -20.0, 	
			0.0, 0.0, -20.0, -20.0, -20.0,
			0.0, 1.0,  20.0, -20.0, -20.0,  
			1.0, 1.0,  20.0, -20.0,  20.0,
			1.0, 0.0, -20.0, -20.0,  20.0, 	
			0.0, 0.0, -20.0,  20.0, -20.0,
			0.0, 1.0, -20.0, -20.0, -20.0, 
			1.0, 1.0, -20.0, -20.0,  20.0,
			1.0, 0.0, -20.0,  20.0,  20.0, 	
			0.0, 0.0,  20.0,  20.0,  20.0,
			0.0, 1.0,  20.0, -20.0,  20.0, 
			1.0, 1.0,  20.0, -20.0, -20.0,
			1.0, 0.0,  20.0,  20.0, -20.0	
			};

GLuint indices[24] = { 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23 };

static void DrawCube(void)
{
	glBindTexture(GL_TEXTURE_2D, textureNumber);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);

	glInterleavedArrays(GL_T2F_V3F, 0, coordinates);
	glDrawElements(GL_QUADS, 24, GL_UNSIGNED_INT, indices);

	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
}


static void DisplayFunc(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
	glRotatef(zRot, 0.0f, 0.0f, 1.0f);
		DrawCube();
	glPopMatrix();
	glutSwapBuffers();
}


static void IdleFunc(void)
{
	zRot += 5.0;
	zRot = ((int)zRot % 360);
	xRot -= 3.0;
	xRot = ((int)xRot % 360);
	yRot += 2.0;
	yRot = ((int)yRot % 360);

	glutPostRedisplay();
}


static void ReshapeFunc(GLsizei width, GLsizei height)
{
	GLfloat h = (GLfloat) height / (GLfloat) width;

	glViewport(0, 0,  width,  height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1.0,1.0,1.0,1.0,0.0,1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0, 0.0, -150.0);
}

void VisibilityFunc(int vis)
{
	if (vis == GLUT_VISIBLE)
		glutIdleFuncFunc(IdleFuncFunc);
	else
		glutIdleFuncFunc(NULL);
}


int LoadTexture(unsigned char *texture, char* FileName)
{
	FILE *fp;
	long size;

	fp = fopen(FileName, "rb");
	if(fp == NULL)
	{
		printf("Impossible d'ouvrir le fichier !\n");
		return 0;
	}

	size = fread(texture,textureSize,1,fp);
	if(size ==0 )
	{
		return 0;
	}
	fclose(fp);

	return 1;
}


main(int argc, char *argv[])
{
	glutInit(&argc, argv);

	texture = (unsigned char *) malloc(textureSize);
	if(texture==NULL)
	exit(1);

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	glutCreateWindow("OpenGL Demo");

	LoadTexture(texture,"texture.raw");
	glGenTextures(1,&textureNumber);
	glBindTexture(GL_TEXTURE_2D, textureNumber);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	//glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	//glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, texture);
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 256, 256, GL_RGB, GL_UNSIGNED_BYTE, texture);
	glEnable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);	
	glEnable(GL_BLEND);					
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
	glColor4f(1.0f, 1.0f, 1.0f, 0.5);
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

	glutDisplayFunc(DisplayFunc);
	glutReshapeFunc(ReshapeFunc);
	glutVisibilityFunc(VisibilityFunc);
/*	free(texture); */
	glutMainLoop();
	return 0;
}
