/* Cet exemple libre provient du Magazine Dream/Login 69		*/
/* Il a ete modifie par Alain Thellier en Aout 2008			*/
/* Cet exemple montre comment en utilisant la 				*/
/* super-fonction glDrawElements() on peut tracer un objet+texture*/
/* avec OpenGL/StormMesa de la plus simple faon			*/

/* This Free Source example come from Dream/Login Magazine #69	*/
/* Alain Thellier modified it in August 2008				*/
/* This example show how to use the						*/
/* super-fonction glDrawElements() to draw a textured object	*/
/* with OpenGL/StormMesa the simplest way					*/

#include <stdio.h>
#include <stdlib.h>
#include <gl/glut.h>

static GLfloat xRot = 0.0;
static GLfloat yRot = 0.0;
static GLfloat zRot = 0.0;
GLuint textureID,windowID;

unsigned char *texture=NULL;

GLfloat coordinates[] = {
			0.0, 0.0, -20.0,  20.0,  20.0,
			0.0, 1.0, -20.0, -20.0,  20.0,
			1.0, 1.0,  20.0, -20.0,  20.0,
			1.0, 0.0,  20.0,  20.0,  20.0,
			0.0, 0.0,  20.0,  20.0, -20.0,
			0.0, 1.0,  20.0, -20.0, -20.0,
			1.0, 1.0, -20.0, -20.0, -20.0,
			1.0, 0.0, -20.0,  20.0, -20.0,
			0.0, 0.0, -20.0,  20.0,  20.0,
			0.0, 1.0,  20.0,  20.0,  20.0,
			1.0, 1.0,  20.0,  20.0, -20.0,
			1.0, 0.0, -20.0,  20.0, -20.0,
			0.0, 0.0, -20.0, -20.0, -20.0,
			0.0, 1.0,  20.0, -20.0, -20.0,
			1.0, 1.0,  20.0, -20.0,  20.0,
			1.0, 0.0, -20.0, -20.0,  20.0,
			0.0, 0.0, -20.0,  20.0, -20.0,
			0.0, 1.0, -20.0, -20.0, -20.0,
			1.0, 1.0, -20.0, -20.0,  20.0,
			1.0, 0.0, -20.0,  20.0,  20.0,
			0.0, 0.0,  20.0,  20.0,  20.0,
			0.0, 1.0,  20.0, -20.0,  20.0,
			1.0, 1.0,  20.0, -20.0, -20.0,
			1.0, 0.0,  20.0,  20.0, -20.0
			};

GLuint indices[24] = { 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23 };

static void DrawObject(void)
{
	glBindTexture(GL_TEXTURE_2D, textureID);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);

	glInterleavedArrays(GL_T2F_V3F, 0, coordinates);
	glDrawElements(GL_QUADS, 24, GL_UNSIGNED_INT, indices);

	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
}

static void DisplayFunc(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
	glRotatef(zRot, 0.0f, 0.0f, 1.0f);
		DrawObject();
	glPopMatrix();
	glutSwapBuffers();
}


static void IdleFunc(void)
{
	xRot -= 3.0;
	xRot = ((int)xRot % 360);
	yRot += 2.0;
	yRot = ((int)yRot % 360);
	zRot += 1.0;
	zRot = ((int)zRot % 360);
	glutPostRedisplay();
}

static void ReshapeFunc(GLsizei width, GLsizei height)
{
	GLfloat h = (GLfloat) height / (GLfloat) width;

	glViewport(0, 0,  width,  height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1.0, 1.0, -h, h, 2.0, 300.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0, 0.0, -150.0);
}

void VisibilityFunc(int vis)
{
	if (vis == GLUT_VISIBLE)
		glutIdleFunc(IdleFunc);
	else
		glutIdleFunc(NULL);
}

void KeyboardFunc(unsigned char key,int x, int y)
{
   switch (key)
	{
      case 27:
	      glutDestroyWindow(windowID);
		free(texture);
	      exit(1);
 	default:
      	break;
    }
}

int LoadFile(unsigned char *buffer, char* name,long bufferSize)
{
	FILE *fp;
	long size;

	fp = fopen(name,"rb");
	if(fp == NULL)
	{
		printf("Cant open file !\n");
		return 0;
	}

	size = fread(buffer,bufferSize,1,fp);
	if(size ==0 )
	{
		printf("Cant read file !\n");
		return 0;
	}
	fclose(fp);

	return 1;
}

int LoadTexture(char* name,int size,int bits)
{
unsigned long textureSize = size*size*bits/8;

	texture = (unsigned char *) malloc(textureSize);
	if(texture==NULL)
		{
	      glutDestroyWindow(windowID);
	      exit(1);
		}
	LoadFile(texture,name,textureSize);
	glGenTextures(1,&textureID);
	glBindTexture(GL_TEXTURE_2D, textureID);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,bits/8,size,size,0,GL_RGB,GL_UNSIGNED_BYTE, texture);
	glEnable(GL_TEXTURE_2D);
}

main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	windowID=glutCreateWindow("OpenGL Demo (Esc to exit)");

	LoadTexture("texture.raw",128,24);

	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glEnable(GL_BLEND);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glFrontFace(GL_CCW);

	glutDisplayFunc(DisplayFunc);
	glutReshapeFunc(ReshapeFunc);
	glutVisibilityFunc(VisibilityFunc);
	glutKeyboardFunc(KeyboardFunc);

	glutMainLoop();
	return 0;
}
