/* OpenGL Sample #1 Star scrolling with parallaxs from AmiDARK - 2009*/
/* Enhancements from Alain Thellier */

#define STARCOUNT  300
#define STARSIZE   6.0
#define STARSPEED  0.0002

#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

struct star3D {float x,y,size,speed,r,g,b;};
#define NLOOP(nbre) for(n=0;n<nbre;n++)
struct star3D Stars[STARCOUNT];
int windowID;
int n;

void KeyboardFunc(unsigned char key,int x, int y)
{
   switch (key)
	{
      case 27:
	glutDestroyWindow(windowID);	/* clean up before exiting */ 
	exit(1);
	default:
      break;
	}
}

/*	WHAT WE WANT TO DISPLAY ON SCREEN MUST BE ADDED IN THIS FUNCTION */
void IdleFunc( void )
{

	glClearColor( 0.0, 0.0, 0.2, 0.0);	/* Set backdrop as black */
	glClear(GL_COLOR_BUFFER_BIT );	/* Clear the backdrop with glClearColor color */
	NLOOP(STARCOUNT)
	{
	Stars[n].x-= Stars[n].speed ;
	if ( Stars[n].x<=0.0 )
		{
		Stars[n].x= 1.0;
		Stars[n].y= (float)rand()/(RAND_MAX+1.0);
		}
	glPointSize(Stars[n].size);
	glEnable(GL_POINT_SMOOTH);
	glBegin(GL_POINTS) ;
	glColor3f(Stars[n].r,Stars[n].g,Stars[n].b);
	glVertex3f( Stars[n].x, Stars[n].y, 0.0 );
	glEnd() ;
	}

	glFlush();
	glutSwapBuffers();
 }

/* SOME INITIALIZATIONS HERE */
void My_glInit( void )
{
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity() ;
	glOrtho( 0.0, 1.0, 0.0, 1.0, 0.0, 1.0 );
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glColor3f(1.0,1.0,1.0);

 }

/* MAIN C PROCEDURE STARTUP-SEQUENCE IS HERE */
int main(int argc, char** argv)
{
float z;

	NLOOP(STARCOUNT)
	{
	Stars[n].x= (float)rand()/(RAND_MAX+1.0);
	Stars[n].y= (float)rand()/(RAND_MAX+1.0);
	z= (float)rand()/(RAND_MAX+1.0);
	Stars[n].speed= STARSPEED / (z+0.001);	/* avoid divide by 0 */
	Stars[n].size = STARSIZE  * (1.0 - z);	/* smaller with distance */
	Stars[n].r=Stars[n].g=Stars[n].size/STARSIZE; 		/* more or less blue */
	Stars[n].b=1.0;
	}

	glutInit(&argc, argv);	/* Initialize Glut */
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE );	/* Define display mode properties 	*/
	glutInitWindowSize( 640, 480 );	 					/* define the sizes of the window to create */
	glutInitWindowPosition( 300, 300 );
	windowID=glutCreateWindow("AmiDARK Test Window");			/* Create the final rendering window */


	My_glInit();
	glutDisplayFunc( IdleFunc );
	glutIdleFunc( IdleFunc );
	glutKeyboardFunc(KeyboardFunc);
	glutMainLoop();

	return 0;
 }
