/* WazpTest.c: a simple demo to test Wazp3D/Warp3D/StormMesa effects */

/* WazpTest.c: une demo simple pour tester les effets Wazp3D/Warp3D/StormMesa */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/glut.h>


#include "WazpTest.h"
/*=================================================================*/
struct menu3D{
	unsigned char  name[25];
	unsigned char name2[30];
	unsigned long id;			/* id of submenu */
	void *var;				/* if menu then change that variable */
	unsigned long val;		/* with that value */
};
/*=================================================================*/
#define OFF 0
#define ON  1
#define MAXMENU 16
struct menu3D Menus[MAXMENU];
unsigned char MenusCount;

unsigned long TextureON=OFF ;
unsigned long BlendON=OFF ;
unsigned long LightingON=OFF ;
unsigned long FogMode=OFF ;
unsigned long TexEnvMode=GL_REPLACE;
unsigned long ShadeMode=GL_SMOOTH;

static GLfloat yRot = 180.0;
float fx;
int MouseDrag=OFF;
GLuint textureID,windowID,menusID;
unsigned char *texture=NULL;
void MenuFunc(int id);
/*=================================================================*/
void AddMenu(unsigned char *name,void *var,short val)
{
struct menu3D *M;
unsigned long *Lvar;
short on;

	if(var==NULL) return;
	if(MenusCount==MAXMENU) return;
	M=&Menus[MenusCount];
	strcpy(M->name,name);
	strcpy(M->name2,"");
	M->var  =var;
	M->val  =val;
	Lvar=M->var;
	on=(*Lvar==M->val);
	if(on)
		strcat(M->name2,"[x] "); 	/* checkbox */
	else
		strcat(M->name2,"[_] ");
	strcat(M->name2,M->name);
	MenusCount++;
}

/*==================================================================*/
void DoGlutMenus()
{
struct menu3D *M;
short n;

	M=&Menus[0];
	menusID=glutCreateMenu(MenuFunc);
	for(n=0;n<MenusCount;n++)
	{
	glutAddMenuEntry(M[n].name2,n);
	}
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}
/*==================================================================*/
void MakeMenus()
{
	MenusCount=0;
	AddMenu("Texture: Off",&TextureON,OFF);
	AddMenu("Texture: On",&TextureON,ON);

	AddMenu("Blend: Off",&BlendON,OFF);
	AddMenu("Blend: On",&BlendON,ON);

	AddMenu("Lighting: Off",&LightingON,OFF);
	AddMenu("Lighting: On",&LightingON,ON);

	AddMenu("Fog: Off",&FogMode,0);
	AddMenu("Fog: GL_LINEAR",&FogMode,GL_LINEAR);
	AddMenu("Fog: GL_EXP",&FogMode,GL_EXP);
	AddMenu("Fog: GL_EXP2",&FogMode,GL_EXP2);

	AddMenu("TexEnv: GL_REPLACE",&TexEnvMode,GL_REPLACE);
	AddMenu("TexEnv: GL_MODULATE",&TexEnvMode,GL_MODULATE);
	AddMenu("TexEnv: GL_DECAL",&TexEnvMode,GL_DECAL);
	AddMenu("TexEnv: GL_BLEND",&TexEnvMode,GL_BLEND);

	AddMenu("Shade: GL_SMOOTH",&ShadeMode,GL_SMOOTH);
	AddMenu("Shade: GL_FLAT",&ShadeMode,GL_FLAT);
	DoGlutMenus();
}
/*==================================================================*/
void MenuFunc(int id)
{
struct menu3D *M;
unsigned long *Lvar;
short change;

	M=&Menus[id];
	Lvar=M->var;
	change=(*Lvar!=M->val);
	*Lvar=M->val;

	if(change)
	{
/* if menu change then destroy old menus and remake updated menus */
		glutDestroyMenu (menusID);
		MakeMenus();
	}
}
/*==================================================================*/
void ChangeDisplay()
{
float FogColor[4];
float ambient[4];

	ambient[0] =255.0/255.0;
	ambient[1] =200.0/255.0;
	ambient[2] =000.0/255.0;
	ambient[3] =255.0/255.0;
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,ambient);
	if(LightingON==ON) glEnable(GL_LIGHTING); else glDisable(GL_LIGHTING);
	if(TextureON==ON) glEnable(GL_TEXTURE_2D); else glDisable(GL_TEXTURE_2D);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,TexEnvMode);
	glShadeModel(ShadeMode);

	if(BlendON==ON) glEnable(GL_BLEND); else glDisable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	glFogi (GL_FOG_MODE,FogMode);
	FogColor[0]=128.0/255.0;
	FogColor[1]=173.0/255.0;
	FogColor[2]=192.0/255.0;
	FogColor[3]=255.0/255.0;
	glFogfv(GL_FOG_COLOR  ,FogColor);
	glFogf (GL_FOG_START  ,0.25);
	glFogf (GL_FOG_END    ,0.75);
	glFogf (GL_FOG_DENSITY,0.95);
	if(FogMode!=0) glEnable(GL_FOG);	else	glDisable(GL_FOG);
}
/*==================================================================*/
static void DrawObject(void)
{
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);

	glTexCoordPointer(2, GL_FLOAT, 5*4,&points[0]);
	glVertexPointer(  3, GL_FLOAT, 5*4,&points[2]);
	glColorPointer(4,GL_UNSIGNED_BYTE,4*1,RGBA);

	glBindTexture(GL_TEXTURE_2D, textureID);
	glDrawElements(GL_TRIANGLES, trianglesCount*3, GL_UNSIGNED_INT, indices);

	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
}
/*==================================================================*/
static void DisplayFunc(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	ChangeDisplay();
	glPushMatrix();
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
		DrawObject();
	glPopMatrix();
	glutSwapBuffers();
}
/*==================================================================*/
static void IdleFunc(void)
{
	if(MouseDrag==ON)
		yRot = 360.0 - fx * 180.0;	/* follow mouse */
	if(yRot<0.0) yRot+=360.0; if(360.0<=yRot) yRot-=360.0;
	glutPostRedisplay();
}
/*==================================================================*/
static void ReshapeFunc(GLsizei width, GLsizei height)
{
	GLfloat h = (GLfloat) height / (GLfloat) width;

	glViewport(0, 0,  width,  height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
/*	glFrustum(-1.0, 1.0, -h, h, 0.0, 1.0); */
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0, 0.0,0.0);
}
/*==================================================================*/
void VisibilityFunc(int vis)
{
	if (vis == GLUT_VISIBLE)
		glutIdleFunc(IdleFunc);
	else
		glutIdleFunc(NULL);
}
/*==================================================================*/
void KeyboardFunc(unsigned char key,int x, int y)
{
   switch (key)
	{
      case 27:
	      glutDestroyWindow(windowID);
		free(texture);
	      exit(1);
 	default:
      	break;
    }
}
/*=================================================================*/
void MouseFunc(int button,int state,int x,int y)
{
	if (button == GLUT_LEFT_BUTTON)
	{
	if (state==GLUT_DOWN)
		{MouseDrag=ON;}
	if (state==GLUT_UP)
		{MouseDrag=OFF;}
 	}
}
/*=================================================================*/
void MotionFunc(int x,int y)
{
int large;

	large=glutGet(GLUT_WINDOW_WIDTH);
	fx=2.0*(float)x /(float)large - 1.0;
	if (1.0 <  fx  ) fx= 1.0;
	if (fx   < -1.0) fx=-1.0;
}
/*==================================================================*/
void CreateTex32(unsigned char *RGBA,unsigned long size)
{
unsigned short x,y,lim;


	lim=size/2;
	for(x=0;x<size;x++)
	for(y=0;y<size;y++)
	{

	if(y<lim)
	{
	RGBA[0]=(x*y)/8;
	RGBA[1]=(x*y)/8;
	RGBA[2]=(x*y)/8;
	RGBA[3]=255;
	}
	else
	{
	RGBA[0]=255;
	RGBA[1]=255;
	RGBA[2]=255;
	RGBA[3]=(x*y)/8;
	}

	RGBA+=4;
	}

}
/*==================================================================*/
GLuint  LoadTexture(char* name,int size,int bits)
{
unsigned long textureSize = size*size*bits/8;

	texture = (unsigned char *) malloc(textureSize);
	if(texture==NULL)
		{
	      glutDestroyWindow(windowID);
	      exit(1);
		}
	CreateTex32(texture,size);
	glGenTextures(1,&textureID);
	glBindTexture(GL_TEXTURE_2D, textureID);
	glTexImage2D(GL_TEXTURE_2D,0,bits/8,size,size,0,GL_RGBA,GL_UNSIGNED_BYTE, texture);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	return(textureID);
}
/*==================================================================*/
int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE );
	windowID=glutCreateWindow("WazpTest Demo (Esc to exit)");

	LoadTexture("",256,32);

	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glClearColor(0.1f, 0.1f, 0.5f, 1.0f);
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glFrontFace(GL_CCW);
	glEnable(GL_CULL_FACE);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);

	glutDisplayFunc(DisplayFunc);
	glutReshapeFunc(ReshapeFunc);
	glutVisibilityFunc(VisibilityFunc);
	glutKeyboardFunc(KeyboardFunc);
	glutMouseFunc(MouseFunc);
	glutMotionFunc(MotionFunc);

	MakeMenus();
	glutMainLoop();
	return 0;
}
/*==================================================================*/
