/* WazpTest.c: a simple demo to test Wazp3D/Warp3D/StormMesa effects */

/* WazpTest.c: une demo simple pour tester les effets Wazp3D/Warp3D/StormMesa */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <GL/glut.h>


#include "WazpTest.h"
/*=================================================================*/
struct menu3D{
	unsigned char  name[25];
	unsigned char name2[30];
	unsigned long id;			/* id of submenu */
	void *var;				/* if menu then change that variable */
	unsigned long val;		/* with that value */
};
/*=================================================================*/
#define OFF 0
#define ON  1
#define MAXMENU 100
struct menu3D Menus[MAXMENU];
unsigned char MenusCount;

unsigned long TextureON=ON ;
unsigned long BlendON=OFF ;
unsigned long LightingON=OFF ;
unsigned long FogMode=OFF ;
unsigned long TexEnvMode=GL_REPLACE;
unsigned long ShadeMode=GL_SMOOTH;
unsigned long PerspectiveON=ON ;
unsigned long SizeON=ON;
unsigned long Persp=150 ;

GLfloat aspect = 1.0;


static GLfloat yRot = 180.0;
static GLfloat xyzSize = -1.0;
float fx,fy;
int MouseDrag=OFF;
GLuint textureID,windowID,menusID;
unsigned char *textures[1];
GLuint texturesID[1];
void MenuFunc(int id);

/*==========================================================================*/
void pf(float x)		/* emulate printf() from a float %f */
{
long high,low;

	high=(long)(x);
	x=(x-(float)high);
	if(x<0.0) x=-x;
	low =(long)(1000000.0*x);
	printf("%ld.%ld ",high,low);
}
#define  VARF(var) {printf(" " #var "="); pf(var); printf("\n"); }
/*=================================================================*/
void CloseAll(void)
{
	glutDestroyWindow(windowID);
	if(textures[0]!=NULL) free(textures[0]);
	exit(1);
}
/*=================================================================*/
void AddMenu(unsigned char *name,void *var,short val)
{
struct menu3D *M;
unsigned long *Lvar;
short on;

	if(var==NULL) return;
	if(MenusCount==MAXMENU) return;
	M=&Menus[MenusCount];
	strcpy(M->name,name);
	strcpy(M->name2,"");
	M->var  =var;
	M->val  =val;
	Lvar=M->var;
	on=(*Lvar==M->val);
	if(on)
		strcat(M->name2,"[x] "); 	/* checkbox */
	else
		strcat(M->name2,"[_] ");
	strcat(M->name2,M->name);
	MenusCount++;
}

/*==================================================================*/
void DoGlutMenus()
{
struct menu3D *M;
short n;

	M=&Menus[0];
	menusID=glutCreateMenu(MenuFunc);
	for(n=0;n<MenusCount;n++)
	{
	glutAddMenuEntry(M[n].name2,n);
	}
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}
/*==================================================================*/
void MakeMenus()
{
	MenusCount=0;
	AddMenu("Texture: Off",&TextureON,OFF);
	AddMenu("Texture: On",&TextureON,ON);

	AddMenu("Blend: Off",&BlendON,OFF);
	AddMenu("Blend: On",&BlendON,ON);

	AddMenu("Lighting: Off",&LightingON,OFF);
	AddMenu("Lighting: On",&LightingON,ON);

	AddMenu("Fog: Off",&FogMode,0);
	AddMenu("Fog: GL_LINEAR",&FogMode,GL_LINEAR);
	AddMenu("Fog: GL_EXP",&FogMode,GL_EXP);
	AddMenu("Fog: GL_EXP2",&FogMode,GL_EXP2);

	AddMenu("TexEnv: GL_REPLACE",&TexEnvMode,GL_REPLACE);
	AddMenu("TexEnv: GL_MODULATE",&TexEnvMode,GL_MODULATE);
	AddMenu("TexEnv: GL_DECAL",&TexEnvMode,GL_DECAL);
	AddMenu("TexEnv: GL_BLEND",&TexEnvMode,GL_BLEND);

	AddMenu("Shade: GL_SMOOTH",&ShadeMode,GL_SMOOTH);
	AddMenu("Shade: GL_FLAT",&ShadeMode,GL_FLAT);

	AddMenu("Perspective: Off",&PerspectiveON,OFF);
	AddMenu("Perspective: On",&PerspectiveON,ON);

	AddMenu("Mouse: Do Rot.",&SizeON,OFF);
	AddMenu("Mouse: Do Size",&SizeON,ON);


	AddMenu("Persp: 10",&Persp,10);
	AddMenu("Persp: 20",&Persp,20);
	AddMenu("Persp: 30",&Persp,30);
	AddMenu("Persp: 40",&Persp,40);
	AddMenu("Persp: 50",&Persp,50);
	AddMenu("Persp: 70",&Persp,70);
	AddMenu("Persp: 80",&Persp,80);
	AddMenu("Persp: 90",&Persp,90);
	AddMenu("Persp: 100",&Persp,100);
	AddMenu("Persp: 110",&Persp,110);
	AddMenu("Persp: 120",&Persp,120);
	AddMenu("Persp: 140",&Persp,140);
	AddMenu("Persp: 150",&Persp,150);
	AddMenu("Persp: 160",&Persp,160);
	AddMenu("Persp: 170",&Persp,170);


	DoGlutMenus();
}
/*==================================================================*/
void MenuFunc(int id)
{
struct menu3D *M;
unsigned long *Lvar;
short change;

	M=&Menus[id];
	Lvar=M->var;
	change=(*Lvar!=M->val);
	*Lvar=M->val;

	if(change)
	{
/* if menu change then destroy old menus and remake updated menus */
		glutDestroyMenu (menusID);
		MakeMenus();
	}
}
/*==================================================================*/
/*
fovy 		view angle, in degrees, in the y direction.
aspect 	aspect ratio is the ratio of width to height.
zNear 	z near clipping plane (always positive).
zFar 		z far clipping plane (always positive).
*/
/*==================================================================*/
void mygluPerspective( float fovy, float aspect,float zNear, float zFar )
{
	GLfloat xmin, xmax, ymin, ymax,t;

	t=tan( fovy * 3.1416 / 360.0 );
	ymax = zNear * t;
	ymin = -ymax;

	xmin = ymin * aspect;
	xmax = ymax * aspect;

/*
printf("mygluPerspective------------\n");

VARF(fovy);
VARF(aspect);
VARF(t);

VARF(xmin );
VARF(xmax );
VARF(ymin );
VARF(ymax );
VARF(zNear);
VARF(zFar );
*/
	glFrustum( (GLdouble) xmin, (GLdouble)xmax, (GLdouble)ymin, (GLdouble)ymax, (GLdouble)zNear, (GLdouble)zFar );
}
/*==================================================================*/
void ChangeDisplay()
{
float FogColor[4];
float ambient[4];
GLfloat width,height;

	ambient[0] =255.0/255.0;
	ambient[1] =200.0/255.0;
	ambient[2] =000.0/255.0;
	ambient[3] =255.0/255.0;
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,ambient);
	if(LightingON==ON) glEnable(GL_LIGHTING); else glDisable(GL_LIGHTING);
	if(TextureON==ON) glEnable(GL_TEXTURE_2D); else glDisable(GL_TEXTURE_2D);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,TexEnvMode);
	glShadeModel(ShadeMode);

	if(BlendON==ON) glEnable(GL_BLEND); else glDisable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	glFogi (GL_FOG_MODE,FogMode);
	FogColor[0]=128.0/255.0;
	FogColor[1]=173.0/255.0;
	FogColor[2]=192.0/255.0;
	FogColor[3]=255.0/255.0;
	glFogfv(GL_FOG_COLOR  ,FogColor);
	glFogf (GL_FOG_START  ,0.25);
	glFogf (GL_FOG_END	 ,0.75);
	glFogf (GL_FOG_DENSITY,0.95);
	if(FogMode!=0) glEnable(GL_FOG);	else	glDisable(GL_FOG);

	width=glutGet(GLUT_WINDOW_WIDTH);
	height=glutGet(GLUT_WINDOW_HEIGHT);
	aspect=width/height;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	if(PerspectiveON==ON)
		mygluPerspective((float)Persp,aspect,0.01,1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0,0.0,0.5);
	glScalef(xyzSize,xyzSize,xyzSize);
}
/*==================================================================*/
static void DrawObject(void)
{
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);

	glTexCoordPointer(2, GL_FLOAT, 5*4,&points[0]);
	glVertexPointer(  3, GL_FLOAT, 5*4,&points[2]);
	glColorPointer(4,GL_UNSIGNED_BYTE,4*1,RGBA);

	glBindTexture(GL_TEXTURE_2D, texturesID[0]);
	glDrawElements(GL_TRIANGLES, trianglesCount*3, GL_UNSIGNED_INT, indices);

	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
}
/*==================================================================*/
static void DisplayFunc(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	ChangeDisplay();

	DrawObject();

	glutSwapBuffers();
}
/*==================================================================*/
static void IdleFunc(void)
{
	if(MouseDrag==ON)
	{
	if(SizeON==ON)
		xyzSize	= fy;
	if(SizeON==OFF)
		yRot		= 360.0 - fx * 180.0;	/* follow mouse */
	VARF(xyzSize);
	VARF(yRot);
	}

	if(yRot<0.0) 	yRot+=360.0;
	if(360.0<=yRot) 	yRot-=360.0;
	glutPostRedisplay();
}
/*==================================================================*/
static void ReshapeFunc(GLsizei width, GLsizei height)
{
	aspect=(GLfloat)width/(GLfloat)height;
	glViewport(0, 0,  width,  height);
}
/*==================================================================*/
void VisibilityFunc(int vis)
{
	if (vis == GLUT_VISIBLE)
		glutIdleFunc(IdleFunc);
	else
		glutIdleFunc(NULL);
}
/*==================================================================*/
void KeyboardFunc(unsigned char key,int x, int y)
{
	switch (key)
	{
	case 27:
			CloseAll();
 	default:
			break;
	 }
}
/*=================================================================*/
void MouseFunc(int button,int state,int x,int y)
{
	if (button == GLUT_LEFT_BUTTON)
	{
	if (state==GLUT_DOWN)
		{MouseDrag=ON;}
	if (state==GLUT_UP)
		{MouseDrag=OFF;}
 	}
}
/*=================================================================*/
void MotionFunc(int x,int y)
{
int large,high;

	large=glutGet(GLUT_WINDOW_WIDTH);
	fx=2.0*(float)x /(float)large - 1.0;
	if (1.0 <  fx  ) fx= 1.0;
	if (fx   < -1.0) fx=-1.0;
	high=glutGet(GLUT_WINDOW_HEIGHT);
	fy=2.0*(float)y /(float)high - 1.0;
	if (1.0 <  fy  ) fy= 1.0;
	if (fy   < -1.0) fy=-1.0;
}
/*==================================================================*/
void CreateTex32(unsigned char *RGBA,unsigned long size)
{
unsigned short x,y,lim;


	lim=size/2;
	for(x=0;x<size;x++)
	for(y=0;y<size;y++)
	{

	if(y<lim)
	{
	RGBA[0]=(x*y)/8;
	RGBA[1]=(x*y)/8;
	RGBA[2]=(x*y)/8;
	RGBA[3]=255;
	}
	else
	{
	RGBA[0]=255;
	RGBA[1]=255;
	RGBA[2]=255;
	RGBA[3]=(x*y)/8;
	}

	RGBA+=4;
	}

}
/*=================================================================*/
int LoadFile(unsigned char *buffer, char* name,long bufferSize)
{
	FILE *fp;
	long size;

	fp = fopen(name,"rb");
	if(fp == NULL)
	{
		printf("Cant open file !\n");
		return 0;
	}

	size = fread(buffer,bufferSize,1,fp);
	if(size ==0 )
	{
		printf("Cant read file !\n");
		return 0;
	}
	fclose(fp);
	return 1;
}
/*=================================================================*/
void  LoadTexture(char* filename,int t)
{
int high,large,bits,size,n;
unsigned long textureSize;
char fullfilename[256];
char texname[40];
GLenum format;
#define NLOOP(nbre) for(n=0;n<nbre;n++)


	strcpy(fullfilename,filename);
	size=strlen(filename);
	NLOOP(size)
		if(filename[size-n-1]=='/')
			{filename=&filename[size-n]; break;}	/* standardize filename = without path */
	NLOOP(size)
		if(filename[size-n-1]=='\\')
			{filename=&filename[size-n]; break;}	/* standardize filename = without path */

	size=strlen(filename);
	NLOOP(size)
		{
			if(filename[n]=='X') filename[n]=' ';
			if(filename[n]=='_') filename[n]=' ';
			if(filename[n]=='.') filename[n]=0;
		}
	sscanf(filename, "%s %d  %d %d", texname, &large,&high,&bits);

	printf("<%s> <%s> %d X %d X %d bits\n",fullfilename,texname, large,high,bits);

	textureSize = high*large*bits/8;
	if (bits==32)
		format=GL_RGBA; else format=GL_RGB;
	textures[t] = (unsigned char *) malloc(textureSize);
	if(textures[t]==NULL)
	      CloseAll();

	LoadFile(textures[t],fullfilename,textureSize);
	glGenTextures(1,&texturesID[t]);
	glBindTexture(GL_TEXTURE_2D,texturesID[t]);
	glTexImage2D(GL_TEXTURE_2D,0,bits/8,large,high,0,format,GL_UNSIGNED_BYTE, textures[t]);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glEnable(GL_TEXTURE_2D);
}
/*==================================================================*/
int main(int argc, char *argv[])
{
char filename[256];


	glutInit(&argc, argv);
	if (argc == 2)			/* if was called with a filename argument */
		strcpy(filename,argv[1]);
	else
		strcpy(filename,"Texture2_256X256X24.RAW");

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE );
	glutInitWindowSize(600,600);
	windowID=glutCreateWindow("WazpTest Demo (Esc to exit)");

	LoadTexture(filename,0);

	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glClearColor(0.1f, 0.1f, 0.5f, 1.0f);
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glFrontFace(GL_CCW);
	glEnable(GL_CULL_FACE);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

	glutDisplayFunc(DisplayFunc);
	glutReshapeFunc(ReshapeFunc);
	glutVisibilityFunc(VisibilityFunc);
	glutKeyboardFunc(KeyboardFunc);
	glutMouseFunc(MouseFunc);
	glutMotionFunc(MotionFunc);

	MakeMenus();
	glutMainLoop();
	return 0;
}
/*==================================================================*/
