 
/*   
 * Mesa 3-D graphics library   
 * Version:2.2   
 * Copyright (C) 1995-1997Brian Paul   
 *   
 * This library is free software you can redistribute it and/or   
 * modify it under the terms of the GNU Library General Public   
 * License as published by the Free Software Foundation either   
 * version 2 of the License, or (at your option) any later version.   
 *   
 * This library is distributed in the hope that it will be useful,   
 * but WITHOUT ANY WARRANTY without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU   
 * Library General Public License for more details.   
 *   
 * You should have received a copy of the GNU Library General Public   
 * License along with this library if not, write to the Free   
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   
 */   
   
#include <GL/gl.h>   
   
   
void APIENTRY smglClearIndex( GLfloat a )   
{   
register GLfloat c	__asm("fp0");   
	glClearIndex(c);   
}   
   
void APIENTRY smglClearColor( GLclampf a,GLclampf b,GLclampf c,GLclampf d )   
{   
register GLclampf red	__asm("fp0");   
register GLclampf green	__asm("fp1");   
register GLclampf blue	__asm("fp2");   
register GLclampf alpha	__asm("fp3");   
	glClearColor(red,green,blue,alpha);   
}   
   
void APIENTRY smglClear( GLbitfield a )   
{   
register GLbitfield mask	__asm("d0");   
	glClear(mask);   
}   
   
void APIENTRY smglIndexMask( GLuint a )   
{   
register GLuint mask	__asm("d0");   
	glIndexMask(mask);   
}   
   
void APIENTRY smglColorMask( GLboolean a,GLboolean b,GLboolean c,GLboolean d )   
{   
register GLboolean red	__asm("d0");   
register GLboolean green	__asm("d1");   
register GLboolean blue	__asm("d2");   
register GLboolean alpha	__asm("d3");   
	glColorMask(red,green,blue,alpha);   
}   
   
void APIENTRY smglAlphaFunc( GLenum a,GLclampf b )   
{   
register GLenum func	__asm("d0");   
register GLclampf ref	__asm("fp0");   
	glAlphaFunc(func,ref);   
}   
   
void APIENTRY smglBlendFunc( GLenum a,GLenum b )   
{   
register GLenum sfactor	__asm("d0");   
register GLenum dfactor	__asm("d1");   
	glBlendFunc(sfactor,dfactor);   
}   
   
void APIENTRY smglLogicOp( GLenum a )   
{   
register GLenum opcode	__asm("d0");   
	glLogicOp(opcode);   
}   
   
void APIENTRY smglCullFace( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glCullFace(mode);   
}   
   
void APIENTRY smglFrontFace( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glFrontFace(mode);   
}   
   
void APIENTRY smglPointSize( GLfloat a )   
{   
register GLfloat size	__asm("fp0");   
	glPointSize(size);   
}   
   
void APIENTRY smglLineWidth( GLfloat a )   
{   
register GLfloat width	__asm("fp0");   
	glLineWidth(width);   
}   
   
void APIENTRY smglLineStipple( GLint a,GLushort b )   
{   
register GLint factor	__asm("d0");   
register GLushort pattern	__asm("d1");   
	glLineStipple(factor,pattern);   
}   
   
void APIENTRY smglPolygonMode( GLenum a,GLenum b )   
{   
register GLenum face	__asm("d0");   
register GLenum mode	__asm("d1");   
	glPolygonMode(face,mode);   
}   
   
void APIENTRY smglPolygonOffset( GLfloat a,GLfloat b )   
{   
register GLfloat factor	__asm("fp0");   
register GLfloat units	__asm("fp1");   
	glPolygonOffset(factor,units);   
}   
   
void APIENTRY smglPolygonStipple( const GLubyte *a )   
{   
register const GLubyte *mask	__asm("a0");   
	glPolygonStipple(mask);   
}   
   
void APIENTRY smglGetPolygonStipple( GLubyte *a )   
{   
register GLubyte *mask	__asm("a0");   
	glGetPolygonStipple(mask);   
}   
   
void APIENTRY smglEdgeFlag( GLboolean a )   
{   
register GLboolean flag	__asm("d0");   
	glEdgeFlag(flag);   
}   
   
void APIENTRY smglEdgeFlagv( const GLboolean *a )   
{   
register const GLboolean *flag	__asm("a0");   
	glEdgeFlagv(flag);   
}   
   
void APIENTRY smglScissor( GLint a,GLint b,GLsizei c,GLsizei d )   
{   
register  GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLsizei width	__asm("d2");   
register GLsizei height	__asm("d3");   
	glScissor(x,y,width,height);   
}   
   
void APIENTRY smglClipPlane( GLenum a,const GLdouble *b )   
{   
register GLenum plane	__asm("d0");   
register const GLdouble *equation	__asm("a0");   
	glClipPlane(plane,equation);   
}   
   
void APIENTRY smglGetClipPlane( GLenum a,GLdouble *b )   
{   
register GLenum plane	__asm("d0");   
register GLdouble *equation	__asm("a0");   
	glGetClipPlane(plane,equation);   
}   
   
void APIENTRY smglDrawBuffer( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glDrawBuffer(mode);   
}   
   
void APIENTRY smglReadBuffer( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glReadBuffer(mode);   
}   
   
void APIENTRY smglEnable( GLenum a )   
{   
register GLenum cap	__asm("d0");   
	glEnable(cap);   
}   
   
void APIENTRY smglDisable( GLenum a )   
{   
register GLenum cap	__asm("d0");   
	glDisable(cap);   
}   
   
GLboolean APIENTRY smglIsEnabled( GLenum a )   
{   
register GLenum cap	__asm("d0");   
	return(glIsEnabled(cap));   
}   
   
void APIENTRY smglEnableClientState( GLenum a )   
{   
register GLenum cap	__asm("d0");   
	glEnableClientState(cap);   
}   
   
void APIENTRY smglDisableClientState( GLenum a )   
{   
register GLenum cap	__asm("d0");   
	glDisableClientState(cap);   
}   
   
void APIENTRY smglGetBooleanv( GLenum a,GLboolean *b )   
{   
register GLenum pname	__asm("d0");   
register GLboolean *params	__asm("a0");   
	glGetBooleanv(pname,params);   
}   
   
void APIENTRY smglGetDoublev( GLenum a,GLdouble *b )   
{   
register GLenum pname	__asm("d0");   
register GLdouble *params	__asm("a0");    
	glGetDoublev(pname,params);   
}   
   
void APIENTRY smglGetFloatv( GLenum a,GLfloat *b )   
{   
register GLenum pname	__asm("d0");   
register GLfloat *params	__asm("a0");   
	glGetFloatv(pname,params);   
}   
   
void APIENTRY smglGetIntegerv( GLenum a,GLint *b )   
{   
register GLenum pname	__asm("d0");   
register GLint *params	__asm("a0");   
	glGetIntegerv(pname,params);   
}   
   
   
void APIENTRY smglPushAttrib( GLbitfield a )   
{   
register GLbitfield mask	__asm("d0");   
	glPushAttrib(mask);   
}   
   
void APIENTRY smglPopAttrib(void )   
{   
	glPopAttrib();   
}   
   
void APIENTRY smglPushClientAttrib(GLbitfield a )   
{   
register GLbitfield mask	__asm("d0");   
	glPushClientAttrib(mask);   
}   
   
void APIENTRY smglPopClientAttrib(void )   
{   
	glPopClientAttrib();   
}   
   
   
GLint APIENTRY smglRenderMode( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	return(glRenderMode(mode));   
}   
   
GLenum APIENTRY smglGetError(void )   
{   
	return(glGetError());   
}   
   
const GLubyte* APIENTRY smglGetString( GLenum a )   
{   
register GLenum name	__asm("d0");   
	return(glGetString(name));   
}   
   
void APIENTRY smglFinish(void )   
{   
	glFinish();   
}   
   
void APIENTRY smglFlush(void )   
{   
	glFlush();   
}   
   
void APIENTRY smglHint( GLenum a,GLenum b )   
{   
register GLenum target	__asm("d0");   
register GLenum mode	__asm("d1");   
	glHint(target,mode);   
}   
   
   
   
/*   
 * Depth Buffer   
 */   
   
void APIENTRY smglClearDepth( GLclampd a )   
{   
register GLclampd depth	__asm("fp0");   
	glClearDepth(depth);   
}   
   
void APIENTRY smglDepthFunc( GLenum a )   
{   
register GLenum func	__asm("d0");   
	glDepthFunc(func);   
}   
   
void APIENTRY smglDepthMask( GLboolean a )   
{   
register GLboolean flag	__asm("d0");   
	glDepthMask(flag);   
}   
   
void APIENTRY smglDepthRange( GLclampd a,GLclampd b )   
{   
register GLclampd near_val	__asm("fp0");   
register GLclampd far_val	__asm("fp1");   
	glDepthRange(near_val,far_val);   
}   
   
   
/*   
 * Accumulation Buffer   
 */   
   
void APIENTRY smglClearAccum( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat red	__asm("fp0");   
register GLfloat green	__asm("fp1");   
register GLfloat blue	__asm("fp2");   
register GLfloat alpha	__asm("fp3");   
	glClearAccum(red,green,blue,alpha);   
}   
   
void APIENTRY smglAccum( GLenum a,GLfloat b )   
{   
register GLenum op	__asm("d0");   
register GLfloat value	__asm("fp0");   
	glAccum(op,value);   
}   
   
   
/*   
 * Transformation   
 */   
   
void APIENTRY smglMatrixMode( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glMatrixMode(mode);   
}   
   
void APIENTRY smglOrtho( GLdouble a,GLdouble b,GLdouble c,GLdouble d,GLdouble e,GLdouble f )   
{   
register GLdouble left	__asm("fp0");   
register GLdouble right	__asm("fp1");   
register GLdouble bottom	__asm("fp2");   
register GLdouble top	__asm("fp3");   
register GLdouble nearval	__asm("fp4");   
register GLdouble farval	__asm("fp5");   
	glOrtho(left,right,bottom,top,nearval,farval);   
}   
   
void APIENTRY smglFrustum( GLdouble a,GLdouble b,GLdouble c,GLdouble d,GLdouble e,GLdouble f )   
{   
register GLdouble left	__asm("fp0");   
register GLdouble right	__asm("fp1");   
register GLdouble bottom	__asm("fp2");   
register GLdouble top	__asm("fp3");   
register GLdouble nearval	__asm("fp4");   
register GLdouble farval	__asm("fp5");   
	glFrustum(left,right,bottom,top,nearval,farval);   
}   
   
void APIENTRY smglViewport( GLint a,GLint b,GLsizei c,GLsizei d )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLsizei width	__asm("d2");   
register GLsizei height	__asm("d3");   
	glViewport(x,y,width,height);   
}   
   
void APIENTRY smglPushMatrix(void )   
{   
	glPushMatrix();   
}   
   
void APIENTRY smglPopMatrix(void )   
{   
	glPopMatrix();   
}   
   
void APIENTRY smglLoadIdentity(void )   
{   
	glLoadIdentity();   
}   
   
void APIENTRY smglLoadMatrixd( const GLdouble *a )   
{   
register const GLdouble *m	__asm("a0");   
	glLoadMatrixd(m);   
}   
   
void APIENTRY smglLoadMatrixf( const GLfloat *a )   
{   
register const GLfloat *m	__asm("a0");   
	glLoadMatrixf(m);   
}   
   
void APIENTRY smglMultMatrixd( const GLdouble *a )   
{   
register const GLdouble *m	__asm("a0");   
	glMultMatrixd(m);   
}   
void APIENTRY smglMultMatrixf( const GLfloat *a )   
{   
register const GLfloat *m	__asm("a0");   
	glMultMatrixf(m);   
}   
   
void APIENTRY smglRotated( GLdouble a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLdouble angle	__asm("fp0");   
register GLdouble x	__asm("fp1");   
register GLdouble y	__asm("fp2");   
register GLdouble z	__asm("fp3");   
	glRotated(angle,x,y,z);   
}   
   
void APIENTRY smglRotatef( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat angle	__asm("fp0");   
register GLfloat x	__asm("fp1");   
register GLfloat y	__asm("fp2");   
register GLfloat z	__asm("fp3");   
	glRotatef(angle,x,y,z);   
}   
   
void APIENTRY smglScaled( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
	glScaled(x,y,z);   
}   
   
void APIENTRY smglScalef( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
	glScalef(x,y,z);   
}   
   
void APIENTRY smglTranslated( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
	glTranslated(x,y,z);   
}   
   
void APIENTRY smglTranslatef( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
	glTranslatef(x,y,z);   
}   
   
   
   
/*   
 * Display Lists   
 */   
   
GLboolean APIENTRY smglIsList( GLuint a )   
{   
register GLuint list	__asm("d0");   
	return(glIsList(list));   
}   
   
void APIENTRY smglDeleteLists( GLuint a,GLsizei b )   
{   
register GLuint list	__asm("d0");   
register GLsizei range	__asm("d1");   
	glDeleteLists(list,range);   
}   
   
GLuint APIENTRY smglGenLists( GLsizei a )   
{   
register GLsizei range	__asm("d0");   
	return(glGenLists(range));   
}   
   
void APIENTRY smglNewList( GLuint a,GLenum b )   
{   
register GLuint list	__asm("d0");   
register GLenum mode	__asm("d1");   
	glNewList(list,mode);   
}   
   
void APIENTRY smglEndList(void )   
{   
	glEndList();   
}   
   
void APIENTRY smglCallList( GLuint a )   
{   
register GLuint list	__asm("d0");   
	glCallList(list);   
}   
   
void APIENTRY smglCallLists( GLsizei a,GLenum b,const GLvoid *c )   
{   
register GLsizei n	__asm("d0");   
register GLenum type	__asm("d1");   
register const GLvoid *lists	__asm("a0");   
	glCallLists(n,type,lists);   
}   
   
void APIENTRY smglListBase( GLuint a )   
{   
register GLuint base	__asm("d0");   
	glListBase(base);   
}   
   
   
   
/*   
 * Drawing Functions   
 */   
   
void APIENTRY smglBegin( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glBegin(mode);   
}   
   
void APIENTRY smglEnd(void )   
{   
	glEnd();   
}   
   
void APIENTRY smglVertex2d( GLdouble a,GLdouble b )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
	glVertex2d(x,y);   
}   
   
void APIENTRY smglVertex2f( GLfloat a,GLfloat b )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
	glVertex2f(x,y);   
}   
   
void APIENTRY smglVertex2i( GLint a,GLint b )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
	glVertex2i(x,y);   
}   
   
void APIENTRY smglVertex2s( GLshort a,GLshort b )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
	glVertex2s(x,y);   
}   
   
void APIENTRY smglVertex3d( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
	glVertex3d(x,y,z);   
}   
   
void APIENTRY smglVertex3f( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
	glVertex3f(x,y,z);   
}   
   
void APIENTRY smglVertex3i( GLint a,GLint b,GLint c )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLint z	__asm("d2");   
	glVertex3i(x,y,z);   
}   
   
void APIENTRY smglVertex3s( GLshort a,GLshort b,GLshort c )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
register GLshort z	__asm("d2");   
	glVertex3s(x,y,z);   
}   
   
void APIENTRY smglVertex4d( GLdouble a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
register GLdouble w	__asm("fp3");   
	glVertex4d(x,y,z,w);   
}   
   
void APIENTRY smglVertex4f( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
register GLfloat w	__asm("fp3");   
	glVertex4f(x,y,z,w);   
}   
   
void APIENTRY smglVertex4i( GLint a,GLint b,GLint c,GLint d )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLint z	__asm("d2");   
register GLint w	__asm("d3");   
	glVertex4i(x,y,z,w);   
}   
   
void APIENTRY smglVertex4s( GLshort a,GLshort b,GLshort c,GLshort d )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
register GLshort z	__asm("d2");   
register GLshort w	__asm("d3");   
	glVertex4s(x,y,z,w);   
}   
   
void APIENTRY smglVertex2dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glVertex2dv(v);   
}   
   
void APIENTRY smglVertex2fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glVertex2fv(v);   
}   
   
void APIENTRY smglVertex2iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glVertex2iv(v);   
}   
   
void APIENTRY smglVertex2sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glVertex2sv(v);   
}   
   
void APIENTRY smglVertex3dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glVertex3dv(v);   
}   
   
void APIENTRY smglVertex3fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glVertex3fv(v);   
}   
   
void APIENTRY smglVertex3iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glVertex3iv(v);   
}   
   
void APIENTRY smglVertex3sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glVertex3sv(v);   
}   
   
void APIENTRY smglVertex4dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glVertex4dv(v);   
}   
   
void APIENTRY smglVertex4fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glVertex4fv(v);   
}   
   
void APIENTRY smglVertex4iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glVertex4iv(v);   
}   
   
void APIENTRY smglVertex4sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glVertex4sv(v);   
}   
   
void APIENTRY smglNormal3b( GLbyte a,GLbyte b,GLbyte c )   
{   
register GLbyte nx	__asm("d0");   
register GLbyte ny	__asm("d1");   
register GLbyte nz	__asm("d2");   
	glNormal3b(nx,ny,nz);   
}   
   
void APIENTRY smglNormal3d( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble nx	__asm("fp0");   
register GLdouble ny	__asm("fp1");   
register GLdouble nz	__asm("fp2");   
	glNormal3d(nx,ny,nz);   
}   
   
void APIENTRY smglNormal3f( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat nx	__asm("fp0");   
register GLfloat ny	__asm("fp1");   
register GLfloat nz	__asm("fp2");   
	glNormal3f(nx,ny,nz);   
}   
   
void APIENTRY smglNormal3i( GLint a,GLint b,GLint c )   
{   
register GLint nx	__asm("d0");   
register GLint ny	__asm("d1");   
register GLint nz	__asm("d2");   
	glNormal3i(nx,ny,nz);   
}   
   
void APIENTRY smglNormal3s( GLshort a,GLshort b,GLshort c )   
{   
register GLshort nx	__asm("d0");   
register GLshort ny	__asm("d1");   
register GLshort nz	__asm("d2");   
	glNormal3s(nx,ny,nz);   
}   
   
void APIENTRY smglNormal3bv( const GLbyte *a )   
{   
register const GLbyte *v	__asm("a0");   
	glNormal3bv(v);   
}   
   
void APIENTRY smglNormal3dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glNormal3dv(v);   
}   
   
void APIENTRY smglNormal3fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glNormal3fv(v);   
}   
   
void APIENTRY smglNormal3iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glNormal3iv(v);   
}   
   
void APIENTRY smglNormal3sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glNormal3sv(v);   
}   
   
void APIENTRY smglIndexd( GLdouble a )   
{   
register GLdouble c	__asm("fp0");   
	glIndexd(c);   
}   
   
void APIENTRY smglIndexf( GLfloat a )   
{   
register GLfloat c	__asm("fp0");   
	glIndexf(c);   
}   
   
void APIENTRY smglIndexi( GLint a )   
{   
register GLint c	__asm("d0");   
	glIndexi(c);   
}   
   
void APIENTRY smglIndexs( GLshort a )   
{   
register GLshort c	__asm("d0");   
	glIndexs(c);   
}   
   
void APIENTRY smglIndexub( GLubyte a )   
{   
register GLubyte c	__asm("d0");   
	glIndexub(c);   
}   
   
void APIENTRY smglIndexdv( const GLdouble *a )   
{   
register const GLdouble *c	__asm("a0");   
	glIndexdv(c);   
}   
   
void APIENTRY smglIndexfv( const GLfloat *a )   
{   
register const GLfloat *c	__asm("a0");   
	glIndexfv(c);   
}   
   
void APIENTRY smglIndexiv( const GLint *a )   
{   
register const GLint *c	__asm("a0");   
	glIndexiv(c);   
}   
   
void APIENTRY smglIndexsv( const GLshort *a )   
{   
register const GLshort *c	__asm("a0");   
	glIndexsv(c);   
}   
   
void APIENTRY smglIndexubv( const GLubyte *a )   
{   
register const GLubyte *c	__asm("a0");   
	glIndexubv(c);   
}   
   
void APIENTRY smglColor3b( GLbyte a,GLbyte b,GLbyte c )   
{   
register GLbyte red	__asm("d0");   
register GLbyte green	__asm("d1");   
register GLbyte blue	__asm("d2");   
	glColor3b(red,green,blue);   
}   
   
void APIENTRY smglColor3d( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble red	__asm("fp0");   
register GLdouble green	__asm("fp1");   
register GLdouble blue	__asm("fp2");   
	glColor3d(red,green,blue);   
}   
   
void APIENTRY smglColor3f( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat red	__asm("fp0");   
register GLfloat green	__asm("fp1");   
register GLfloat blue	__asm("fp2");   
	glColor3f(red,green,blue);   
}   
   
void APIENTRY smglColor3i( GLint a,GLint b,GLint c )   
{   
register GLint red	__asm("d0");   
register GLint green	__asm("d1");   
register GLint blue	__asm("d2");   
	glColor3i(red,green,blue);   
}   
   
void APIENTRY smglColor3s( GLshort a,GLshort b,GLshort c )   
{   
register GLshort red	__asm("d0");   
register GLshort green	__asm("d1");   
register GLshort blue	__asm("d2");   
	glColor3s(red,green,blue);   
}   
   
void APIENTRY smglColor3ub( GLubyte a,GLubyte b,GLubyte c )   
{   
register GLubyte red	__asm("d0");   
register GLubyte green	__asm("d1");   
register GLubyte blue	__asm("d2");   
	glColor3ub(red,green,blue);   
}   
   
void APIENTRY smglColor3ui( GLuint a,GLuint b,GLuint c )   
{   
register GLuint red	__asm("d0");   
register GLuint green	__asm("d1");   
register GLuint blue	__asm("d2");   
	glColor3ui(red,green,blue);   
}   
   
void APIENTRY smglColor3us( GLushort a,GLushort b,GLushort c )   
{   
register GLushort red	__asm("d0");   
register GLushort green	__asm("d1");   
register GLushort blue	__asm("d2");   
	glColor3us(red,green,blue);   
}   
   
void APIENTRY smglColor4b( GLbyte a,GLbyte b,GLbyte c,GLbyte d )   
{   
register GLbyte red	__asm("d0");   
register GLbyte green	__asm("d1");   
register GLbyte blue	__asm("d2");   
register GLbyte alpha	__asm("d3");   
	glColor4b(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4d( GLdouble a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLdouble red	__asm("fp0");   
register GLdouble green	__asm("fp1");   
register GLdouble blue	__asm("fp2");   
register GLdouble alpha	__asm("fp3");   
	glColor4d(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4f( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat red	__asm("fp0");   
register GLfloat green	__asm("fp1");   
register GLfloat blue	__asm("fp2");   
register GLfloat alpha	__asm("fp3");   
	glColor4f(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4i( GLint a,GLint b,GLint c,GLint d )   
{   
register GLint red	__asm("d0");   
register GLint green	__asm("d1");   
register GLint blue	__asm("d2");   
register GLint alpha	__asm("d3");   
	glColor4i(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4s( GLshort a,GLshort b,GLshort c,GLshort d )   
{   
register GLshort red	__asm("d0");   
register GLshort green	__asm("d1");   
register GLshort blue	__asm("d2");   
register GLshort alpha	__asm("d3");   
	glColor4s(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4ub( GLubyte a,GLubyte b,GLubyte c,GLubyte d )   
{   
register GLubyte red	__asm("d0");   
register GLubyte green	__asm("d1");   
register GLubyte blue	__asm("d2");   
register GLubyte alpha	__asm("d3");   
	glColor4ub(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4ui( GLuint a,GLuint b,GLuint c,GLuint d )   
{   
register GLuint red	__asm("d0");   
register GLuint green	__asm("d1");   
register GLuint blue	__asm("d2");   
register GLuint alpha	__asm("d3");   
	glColor4ui(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor4us( GLushort a,GLushort b,GLushort c,GLushort d )   
{   
register GLushort red	__asm("d0");   
register GLushort green	__asm("d1");   
register GLushort blue	__asm("d2");   
register GLushort alpha	__asm("d3");   
	glColor4us(red,green,blue,alpha);   
}   
   
void APIENTRY smglColor3bv( const GLbyte *a )   
{   
register const GLbyte *v	__asm("a0");   
	glColor3bv(v);   
}   
   
void APIENTRY smglColor3dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glColor3dv(v);   
}   
   
void APIENTRY smglColor3fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glColor3fv(v);   
}   
   
void APIENTRY smglColor3iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glColor3iv(v);   
}   
   
void APIENTRY smglColor3sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glColor3sv(v);   
}   
   
void APIENTRY smglColor3ubv( const GLubyte *a )   
{   
register const GLubyte *v	__asm("a0");   
	glColor3ubv(v);   
}   
   
void APIENTRY smglColor3uiv( const GLuint *a )   
{   
register const GLuint *v	__asm("a0");   
	glColor3uiv(v);   
}   
   
void APIENTRY smglColor3usv( const GLushort *a )   
{   
register const GLushort *v	__asm("a0");   
	glColor3usv(v);   
}   
   
void APIENTRY smglColor4bv( const GLbyte *a )   
{   
register const GLbyte *v	__asm("a0");   
	glColor4bv(v);   
}   
   
void APIENTRY smglColor4dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glColor4dv(v);   
}   
   
void APIENTRY smglColor4fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glColor4fv(v);   
}   
   
void APIENTRY smglColor4iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glColor4iv(v);   
}   
   
void APIENTRY smglColor4sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glColor4sv(v);   
}   
   
void APIENTRY smglColor4ubv( const GLubyte *a )   
{   
register const GLubyte *v	__asm("a0");   
	glColor4ubv(v);   
}   
   
void APIENTRY smglColor4uiv( const GLuint *a )   
{   
register const GLuint *v	__asm("a0");   
	glColor4uiv(v);   
}   
   
void APIENTRY smglColor4usv( const GLushort *a )   
{   
register const GLushort *v	__asm("a0");   
	glColor4usv(v);   
}   
   
void APIENTRY smglTexCoord1d( GLdouble a )   
{   
register GLdouble s	__asm("fp0");   
	glTexCoord1d(s);   
}   
   
void APIENTRY smglTexCoord1f( GLfloat a )   
{   
register GLfloat s	__asm("fp0");   
	glTexCoord1f(s);   
}   
   
void APIENTRY smglTexCoord1i( GLint a )   
{   
register GLint s	__asm("d0");   
	glTexCoord1i(s);   
}   
   
void APIENTRY smglTexCoord1s( GLshort a )   
{   
register GLshort s	__asm("d0");   
	glTexCoord1s(s);   
}   
   
void APIENTRY smglTexCoord2d( GLdouble a,GLdouble b )   
{   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
	glTexCoord2d(s,t);   
}   
   
void APIENTRY smglTexCoord2f( GLfloat a,GLfloat b )   
{   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
	glTexCoord2f(s,t);   
}   
   
void APIENTRY smglTexCoord2i( GLint a,GLint b )   
{   
register GLint s	__asm("d0");   
register GLint t	__asm("d1");   
	glTexCoord2i(s,t);   
}   
   
void APIENTRY smglTexCoord2s( GLshort a,GLshort b )   
{   
register GLshort s	__asm("d0");   
register GLshort t	__asm("d1");   
	glTexCoord2s(s,t);   
}   
   
void APIENTRY smglTexCoord3d( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
register GLdouble r	__asm("fp2");   
	glTexCoord3d(s,t,r);   
}   
   
void APIENTRY smglTexCoord3f( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
register GLfloat r	__asm("fp2");   
	glTexCoord3f(s,t,r);   
}   
   
void APIENTRY smglTexCoord3i( GLint a,GLint b,GLint c )   
{   
register GLint s	__asm("d0");   
register GLint t	__asm("d1");   
register GLint r	__asm("d2");   
	glTexCoord3i(s,t,r);   
}   
   
void APIENTRY smglTexCoord3s( GLshort a,GLshort b,GLshort c )   
{   
register GLshort s	__asm("d0");   
register GLshort t	__asm("d1");   
register GLshort r	__asm("d2");   
	glTexCoord3s(s,t,r);   
}   
   
void APIENTRY smglTexCoord4d( GLdouble a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
register GLdouble r	__asm("fp2");   
register GLdouble q	__asm("fp3");   
	glTexCoord4d(s,t,r,q);   
}   
   
void APIENTRY smglTexCoord4f( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
register GLfloat r	__asm("fp2");   
register GLfloat q	__asm("fp3");   
	glTexCoord4f(s,t,r,q);   
}   
   
void APIENTRY smglTexCoord4i( GLint a,GLint b,GLint c,GLint d )   
{   
register GLint s	__asm("d0");   
register GLint t	__asm("d1");   
register GLint r	__asm("d2");   
register GLint q	__asm("d3");   
	glTexCoord4i(s,t,r,q);   
}   
   
void APIENTRY smglTexCoord4s( GLshort a,GLshort b,GLshort c,GLshort d )   
{   
register GLshort s	__asm("d0");   
register GLshort t	__asm("d1");   
register GLshort r	__asm("d2");   
register GLshort q	__asm("d3");   
	glTexCoord4s(s,t,r,q);   
}   
   
void APIENTRY smglTexCoord1dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glTexCoord1dv(v);   
}   
   
void APIENTRY smglTexCoord1fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glTexCoord1fv(v);   
}   
   
void APIENTRY smglTexCoord1iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glTexCoord1iv(v);   
}   
   
void APIENTRY smglTexCoord1sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glTexCoord1sv(v);   
}   
   
void APIENTRY smglTexCoord2dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glTexCoord2dv(v);   
}   
   
void APIENTRY smglTexCoord2fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glTexCoord2fv(v);   
}   
   
void APIENTRY smglTexCoord2iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glTexCoord2iv(v);   
}   
   
void APIENTRY smglTexCoord2sv(const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glTexCoord2sv(v);   
}   
   
void APIENTRY smglTexCoord3dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glTexCoord3dv(v);   
}   
   
void APIENTRY smglTexCoord3fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glTexCoord3fv(v);   
}   
   
void APIENTRY smglTexCoord3iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glTexCoord3iv(v);   
}   
   
void APIENTRY smglTexCoord3sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glTexCoord3sv(v);   
}   
   
void APIENTRY smglTexCoord4dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glTexCoord4dv(v);   
}   
   
void APIENTRY smglTexCoord4fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glTexCoord4fv(v);   
}   
   
void APIENTRY smglTexCoord4iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glTexCoord4iv(v);   
}   
   
void APIENTRY smglTexCoord4sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glTexCoord4sv(v);   
}   
   
void APIENTRY smglRasterPos2d( GLdouble a,GLdouble b )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
	glRasterPos2d(x,y);   
}   
   
void APIENTRY smglRasterPos2f( GLfloat a,GLfloat b )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
	glRasterPos2f(x,y);   
}   
   
void APIENTRY smglRasterPos2i( GLint a,GLint b )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
	glRasterPos2i(x,y);   
}   
   
void APIENTRY smglRasterPos2s( GLshort a,GLshort b )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
	glRasterPos2s(x,y);   
}   
   
void APIENTRY smglRasterPos3d( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
	glRasterPos3d(x,y,z);   
}   
   
void APIENTRY smglRasterPos3f( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
	glRasterPos3f(x,y,z);   
}   
   
void APIENTRY smglRasterPos3i( GLint a,GLint b,GLint c )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLint z	__asm("d2");   
	glRasterPos3i(x,y,z);   
}   
   
   
   
void APIENTRY smglRasterPos3s( GLshort a,GLshort b,GLshort c )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
register GLshort z	__asm("d2");   
	glRasterPos3s(x,y,z);   
}   
   
   
   
   
void APIENTRY smglRasterPos4d( GLdouble a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
register GLdouble w	__asm("fp3");   
	glRasterPos4d(x,y,z,w);   
}   
   
   
   
   
void APIENTRY smglRasterPos4f( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
register GLfloat w	__asm("fp3");   
	glRasterPos4f(x,y,z,w);   
}   
   
   
   
   
void APIENTRY smglRasterPos4i( GLint a,GLint b,GLint c,GLint d )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLint z	__asm("d2");   
register GLint w	__asm("d3");   
	glRasterPos4i(x,y,z,w);   
}   
   
   
   
   
void APIENTRY smglRasterPos4s( GLshort a,GLshort b,GLshort c,GLshort d )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
register GLshort z	__asm("d2");   
register GLshort w	__asm("d3");   
	glRasterPos4s(x,y,z,w);   
}   
   
void APIENTRY smglRasterPos2dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glRasterPos2dv(v);   
}   
   
void APIENTRY smglRasterPos2fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glRasterPos2fv(v);   
}   
   
void APIENTRY smglRasterPos2iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glRasterPos2iv(v);   
}   
   
void APIENTRY smglRasterPos2sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glRasterPos2sv(v);   
}   
   
void APIENTRY smglRasterPos3dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glRasterPos3dv(v);   
}   
   
void APIENTRY smglRasterPos3fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glRasterPos3fv(v);   
}   
   
void APIENTRY smglRasterPos3iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glRasterPos3iv(v);   
}   
   
void APIENTRY smglRasterPos3sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glRasterPos3sv(v);   
}   
   
void APIENTRY smglRasterPos4dv( const GLdouble *a )   
{   
register const GLdouble *v	__asm("a0");   
	glRasterPos4dv(v);   
}   
   
void APIENTRY smglRasterPos4fv( const GLfloat *a )   
{   
register const GLfloat *v	__asm("a0");   
	glRasterPos4fv(v);   
}   
   
void APIENTRY smglRasterPos4iv( const GLint *a )   
{   
register const GLint *v	__asm("a0");   
	glRasterPos4iv(v);   
}   
   
void APIENTRY smglRasterPos4sv( const GLshort *a )   
{   
register const GLshort *v	__asm("a0");   
	glRasterPos4sv(v);   
}   
   
   
   
   
void APIENTRY smglRectd( GLdouble a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLdouble x1	__asm("fp0");   
register GLdouble y1	__asm("fp1");   
register GLdouble x2	__asm("fp2");   
register GLdouble y2	__asm("fp3");   
	glRectd(x1,y1,x2,y2);   
}   
   
   
   
   
void APIENTRY smglRectf( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat x1	__asm("fp0");   
register GLfloat y1	__asm("fp1");   
register GLfloat x2	__asm("fp2");   
register GLfloat y2	__asm("fp3");   
	glRectf(x1,y1,x2,y2);   
}   
   
   
   
   
void APIENTRY smglRecti( GLint a,GLint b,GLint c,GLint d )   
{   
register GLint x1	__asm("d0");   
register GLint y1	__asm("d1");   
register GLint x2	__asm("d2");   
register GLint y2	__asm("d3");   
	glRecti(x1,y1,x2,y2);   
}   
   
   
   
   
void APIENTRY smglRects( GLshort a,GLshort b,GLshort c,GLshort d )   
{   
register GLshort x1	__asm("d0");   
register GLshort y1	__asm("d1");   
register GLshort x2	__asm("d2");   
register GLshort y2	__asm("d3");   
	glRects(x1,y1,x2,y2);   
}   
   
   
void APIENTRY smglRectdv( const GLdouble *a,const GLdouble *b )   
{   
register const GLdouble *v1	__asm("a0");   
register const GLdouble *v2	__asm("a1");   
	glRectdv(v1,v2);   
}   
   
   
void APIENTRY smglRectfv( const GLfloat *a,const GLfloat *b )   
{   
register const GLfloat *v1	__asm("a0");   
register const GLfloat *v2	__asm("a1");   
	glRectfv(v1,v2);   
}   
   
   
void APIENTRY smglRectiv( const GLint *a,const GLint *b )   
{   
register const GLint *v1	__asm("a0");   
register const GLint *v2	__asm("a1");   
	glRectiv(v1,v2);   
}   
   
   
void APIENTRY smglRectsv( const GLshort *a,const GLshort *b )   
{   
register const GLshort *v1	__asm("a0");   
register const GLshort *v2	__asm("a1");   
	glRectsv(v1,v2);   
}   
   
   
/*   
 * Vertex Arrays(1.1)   
 */   
   
   
   
   
   
void APIENTRY smglVertexPointer( GLint a,GLenum b,GLsizei c,const GLvoid *d )   
{   
register GLint size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLsizei stride	__asm("d2");   
register const GLvoid *ptr	__asm("a0");   
	glVertexPointer(size,type,stride,ptr);   
}   
   
   
   
void APIENTRY smglNormalPointer( GLenum a,GLsizei b,const GLvoid *c )   
{   
register GLenum type	__asm("d0");   
register GLsizei stride	__asm("d1");   
register const GLvoid *ptr	__asm("a0");   
	glNormalPointer(type,stride,ptr);   
}   
   
   
   
   
void APIENTRY smglColorPointer( GLint a,GLenum b,GLsizei c,const GLvoid *d )   
{   
register GLint size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLsizei stride	__asm("d2");   
register const GLvoid *ptr	__asm("a0");   
	glColorPointer(size,type,stride,ptr);   
}   
   
   
   
void APIENTRY smglIndexPointer( GLenum a,GLsizei b,const GLvoid *c )   
{   
register GLenum type	__asm("d0");   
register GLsizei stride	__asm("d1");   
register const GLvoid *ptr	__asm("a0");   
	glIndexPointer(type,stride,ptr);   
}   
   
   
   
   
void APIENTRY smglTexCoordPointer( GLint a,GLenum b,GLsizei c,const GLvoid *d )   
{   
register GLint size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLsizei stride	__asm("d2");   
register const GLvoid *ptr	__asm("a0");   
	glTexCoordPointer(size,type,stride,ptr);   
}   
   
   
void APIENTRY smglEdgeFlagPointer( GLsizei a,const GLboolean *b )   
{   
register GLsizei stride	__asm("d0");   
register const GLboolean *ptr	__asm("a0");   
	glEdgeFlagPointer(stride,ptr);   
}   
   
   
void APIENTRY smglGetPointerv( GLenum a,GLvoid **b )   
{   
register GLenum pname	__asm("d0");   
register GLvoid **params	__asm("a0");   
	glGetPointerv(pname,params);   
}   
   
void APIENTRY smglArrayElement( GLint a )   
{   
register GLint i	__asm("d0");   
	glArrayElement(i);   
}   
   
   
   
void APIENTRY smglDrawArrays( GLenum a,GLint b,GLsizei c )   
{   
register GLenum mode	__asm("d0");   
register GLint first	__asm("d1");   
register GLsizei count	__asm("d2");   
	glDrawArrays(mode,first,count);   
}   
   
   
   
   
void APIENTRY smglDrawElements( GLenum a,GLsizei b,GLenum c,const GLvoid *d )   
{   
register GLenum mode	__asm("d0");   
register GLsizei count	__asm("d1");   
register GLenum type	__asm("d2");   
register const GLvoid *indices	__asm("a0");   
	glDrawElements(mode,count,type,indices);   
}   
   
   
   
void APIENTRY smglInterleavedArrays( GLenum a,GLsizei b,const GLvoid *c )   
{   
register GLenum format	__asm("d0");   
register GLsizei stride	__asm("d1");   
register const GLvoid *pointer	__asm("a0");   
	glInterleavedArrays(format,stride,pointer);   
}   
   
   
/*   
 * Lighting   
 */   
   
void APIENTRY smglShadeModel( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glShadeModel(mode);   
}   
   
   
   
void APIENTRY smglLightf( GLenum a,GLenum b,GLfloat c )   
{   
register GLenum light	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat param	__asm("fp0");   
	glLightf(light,pname,param);   
}   
   
   
   
void APIENTRY smglLighti( GLenum a,GLenum b,GLint c )   
{   
register GLenum light	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint param	__asm("d2");   
	glLighti(light,pname,param);   
}   
   
   
   
void APIENTRY smglLightfv( GLenum a,GLenum b,const GLfloat *c )   
{   
register GLenum light	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLfloat *params	__asm("a0");   
	glLightfv(light,pname,params);   
}   
   
   
   
void APIENTRY smglLightiv( GLenum a,GLenum b,const GLint *c )   
{   
register GLenum light	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLint *params	__asm("a0");   
	glLightiv(light,pname,params);   
}   
   
   
   
void APIENTRY smglGetLightfv( GLenum a,GLenum b,GLfloat *c )   
{   
register GLenum light	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat *params	__asm("a0");   
	glGetLightfv(light,pname,params);   
}   
   
   
   
void APIENTRY smglGetLightiv( GLenum a,GLenum b,GLint *c )   
{   
register GLenum light	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint *params	__asm("a0");   
	glGetLightiv(light,pname,params);   
}   
   
   
void APIENTRY smglLightModelf( GLenum a,GLfloat b )   
{   
register GLenum pname	__asm("d0");   
register GLfloat param	__asm("fp0");   
	glLightModelf(pname,param);   
}   
   
   
void APIENTRY smglLightModeli( GLenum a,GLint b )   
{   
register GLenum pname	__asm("d0");   
register GLint param	__asm("d1");   
	glLightModeli(pname,param);   
}   
   
   
void APIENTRY smglLightModelfv( GLenum a,GLfloat *b )   
{   
register GLenum pname	__asm("d0");   
register const GLfloat *params	__asm("a0");   
	glLightModelfv(pname,params);   
}   
   
   
void APIENTRY smglLightModeliv( GLenum a,const GLint *b )   
{   
register GLenum pname	__asm("d0");   
register const GLint *params	__asm("a0");   
	glLightModeliv(pname,params);   
}   
   
   
   
void APIENTRY smglMaterialf( GLenum a,GLenum b,GLfloat c )   
{   
register GLenum face	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat param	__asm("fp0");   
	glMaterialf(face,pname,param);   
}   
   
   
   
void APIENTRY smglMateriali( GLenum a,GLenum b,GLint c )   
{   
register GLenum face	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint param	__asm("d2");   
	glMateriali(face,pname,param);   
}   
   
   
   
void APIENTRY smglMaterialfv( GLenum a,GLenum b,const GLfloat *c )   
{   
register GLenum face	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLfloat *params	__asm("a0");   
	glMaterialfv(face,pname,params);   
}   
   
   
   
void APIENTRY smglMaterialiv( GLenum a,GLenum b,const GLint *c )   
{   
register GLenum face	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLint *params	__asm("a0");   
	glMaterialiv(face,pname,params);   
}   
   
   
   
void APIENTRY smglGetMaterialfv( GLenum a,GLenum b,GLfloat *c )   
{   
register GLenum face	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat *params	__asm("a0");   
	glGetMaterialfv(face,pname,params);   
}   
   
   
   
void APIENTRY smglGetMaterialiv( GLenum a,GLenum b,GLint *c )    
{   
register GLenum face	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint *params	__asm("a0");   
	glGetMaterialiv(face,pname,params);   
}   
   
   
void APIENTRY smglColorMaterial( GLenum a,GLenum b )   
{   
register GLenum face	__asm("d0");   
register GLenum mode	__asm("d1");   
	glColorMaterial(face,mode);   
}   
   
   
   
   
/*   
 * Raster functions   
 */   
   
   
void APIENTRY smglPixelZoom( GLfloat a,GLfloat b )   
{   
register GLfloat xfactor	__asm("fp0");   
register GLfloat yfactor	__asm("fp1");   
	glPixelZoom(xfactor,yfactor);   
}   
   
   
void APIENTRY smglPixelStoref( GLenum a,GLfloat b )   
{   
register GLenum pname	__asm("d0");   
register GLfloat param	__asm("fp0");   
	glPixelStoref(pname,param);   
}   
   
   
void APIENTRY smglPixelStorei( GLenum a,GLint b )   
{   
register GLenum pname	__asm("d0");   
register GLint param	__asm("d1");   
	glPixelStorei(pname,param);   
}   
   
   
void APIENTRY smglPixelTransferf( GLenum a,GLfloat b )   
{   
register GLenum pname	__asm("d0");   
register GLfloat param	__asm("fp0");   
	glPixelTransferf(pname,param);   
}   
   
   
void APIENTRY smglPixelTransferi( GLenum a,GLint b )   
{   
register GLenum pname	__asm("d0");   
register GLint param	__asm("d1");   
	glPixelTransferi(pname,param);   
}   
   
   
   
void APIENTRY smglPixelMapfv( GLenum a,GLint b,const GLfloat *c )   
{   
register GLenum map	__asm("d0");   
register GLint mapsize	__asm("d1");   
register const GLfloat *values	__asm("a0");   
	glPixelMapfv(map,mapsize,values);   
}   
   
   
   
void APIENTRY smglPixelMapuiv( GLenum a,GLint b,const GLuint *c )   
{   
register GLenum map	__asm("d0");   
register GLint mapsize	__asm("d1");   
register const GLuint *values	__asm("a0");   
	glPixelMapuiv(map,mapsize,values);   
}   
   
   
   
void APIENTRY smglPixelMapusv( GLenum a,GLint b,const GLushort *c )   
{   
register GLenum map	__asm("d0");   
register GLint mapsize	__asm("d1");   
register const GLushort *values	__asm("a0");   
	glPixelMapusv(map,mapsize,values);   
}   
   
   
void APIENTRY smglGetPixelMapfv( GLenum a,GLfloat *b )   
{   
register GLenum map	__asm("d0");   
register GLfloat *values	__asm("a0");   
	glGetPixelMapfv(map,values);   
}   
   
   
void APIENTRY smglGetPixelMapuiv( GLenum a,GLuint *b )   
{   
register GLenum map	__asm("d0");   
register GLuint *values	__asm("a0");   
	glGetPixelMapuiv(map,values);   
}   
   
   
void APIENTRY smglGetPixelMapusv( GLenum a,GLushort *b )   
{   
register GLenum map	__asm("d0");   
register GLushort *values	__asm("a0");   
	glGetPixelMapusv(map,values);   
}   
   
   
   
   
   
   
   
void APIENTRY smglBitmap( GLsizei a,GLsizei b,GLfloat c,GLfloat d,GLfloat e,GLfloat f,const GLubyte *g )   
{   
register GLsizei width	__asm("d0");   
register GLsizei height	__asm("d1");   
register GLfloat xorig	__asm("fp0");   
register GLfloat yorig	__asm("fp1");   
register GLfloat xmove	__asm("fp2");   
register GLfloat ymove	__asm("fp3");   
register const GLubyte *bitmap	__asm("a0");   
	glBitmap(width,height,xorig,yorig,xmove,ymove,bitmap);   
}   
   
   
   
   
   
   
   
void APIENTRY smglReadPixels( GLint a,GLint b,GLsizei c,GLsizei d,GLenum e,GLenum f,GLvoid *g )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLsizei width	__asm("d2");   
register GLsizei height	__asm("d3");   
register GLenum format	__asm("d4");   
register GLenum type	__asm("d5");   
register GLvoid *pixels	__asm("a0");   
	glReadPixels(x,y,width,height,format,type,pixels);   
}   
   
   
   
   
   
void APIENTRY smglDrawPixels( GLsizei a,GLsizei b,GLenum c,GLenum d,const GLvoid *e )   
{   
register GLsizei width	__asm("d0");   
register GLsizei height	__asm("d1");   
register GLenum format	__asm("d2");   
register GLenum type	__asm("d3");   
register const GLvoid *pixels	__asm("a0");   
	glDrawPixels(width,height,format,type,pixels);   
}   
   
   
   
   
   
void APIENTRY smglCopyPixels( GLint a,GLint b,GLsizei c,GLsizei d,GLenum e )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLsizei width	__asm("d2");   
register GLsizei height	__asm("d3");   
register GLenum type	__asm("d4");   
	glCopyPixels(x,y,width,height,type);   
}   
   
   
   
/*   
 * Stenciling   
 */   
   
   
   
void APIENTRY smglStencilFunc( GLenum a,GLint b,GLuint c )   
{   
register GLenum func	__asm("d0");   
register GLint ref	__asm("d1");   
register GLuint mask	__asm("d2");   
	glStencilFunc(func,ref,mask);   
}   
   
void APIENTRY smglStencilMask( GLuint a )   
{   
register GLuint mask	__asm("d0");   
	glStencilMask(mask);   
}   
   
   
   
void APIENTRY smglStencilOp( GLenum a,GLenum b,GLenum c )   
{   
register GLenum fail	__asm("d0");   
register GLenum zfail	__asm("d1");   
register GLenum zpass	__asm("d2");   
	glStencilOp(fail,zfail,zpass);   
}   
   
void APIENTRY smglClearStencil( GLint a )   
{   
register GLint s	__asm("d0");   
	glClearStencil(s);   
}   
   
   
   
/*   
 * Texture mapping   
 */   
   
   
   
void APIENTRY smglTexGend( GLenum a,GLenum b,GLdouble c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLdouble param	__asm("fp0");   
	glTexGend(coord,pname,param);   
}   
   
   
   
void APIENTRY smglTexGenf( GLenum a,GLenum b,GLfloat c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat param	__asm("fp0");   
	glTexGenf(coord,pname,param);   
}   
   
   
   
void APIENTRY smglTexGeni( GLenum a,GLenum b,GLint c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint param	__asm("d2");   
	glTexGeni(coord,pname,param);   
}   
   
   
   
void APIENTRY smglTexGendv( GLenum a,GLenum b,const GLdouble *c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLdouble *params	__asm("a0");   
	glTexGendv(coord,pname,params);   
}   
   
   
   
void APIENTRY smglTexGenfv( GLenum a,GLenum b,const GLfloat *c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLfloat *params	__asm("a0");   
	glTexGenfv(coord,pname,params);   
}   
   
   
   
void APIENTRY smglTexGeniv( GLenum a,GLenum b,const GLint *c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLint *params	__asm("a0");   
	glTexGeniv(coord,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexGendv( GLenum a,GLenum b,GLdouble *c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLdouble *params	__asm("a0");   
	glGetTexGendv(coord,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexGenfv( GLenum a,GLenum b,GLfloat *c )   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat *params	__asm("a0");   
	glGetTexGenfv(coord,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexGeniv( GLenum a,GLenum b,GLint *c)   
{   
register GLenum coord	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint *params	__asm("a0");   
	glGetTexGeniv(coord,pname,params);   
}   
   
   
   
void APIENTRY smglTexEnvf( GLenum a,GLenum b,GLfloat c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat param	__asm("fp0");   
	glTexEnvf(target,pname,param);   
}   
   
   
   
void APIENTRY smglTexEnvi( GLenum a,GLenum b,GLint c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint param	__asm("d2");   
	glTexEnvi(target,pname,param);   
}   
   
   
   
void APIENTRY smglTexEnvfv( GLenum a,GLenum b,const GLfloat *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLfloat *params	__asm("a0");   
	glTexEnvfv(target,pname,params);   
}   
   
   
   
void APIENTRY smglTexEnviv( GLenum a,GLenum b,const GLint *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLint *params	__asm("a0");   
	glTexEnviv(target,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexEnvfv( GLenum a,GLenum b,GLfloat *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat *params	__asm("a0");   
	glGetTexEnvfv(target,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexEnviv( GLenum a,GLenum b,GLint *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint *params	__asm("a0");   
	glGetTexEnviv(target,pname,params);   
}   
   
   
   
void APIENTRY smglTexParameterf( GLenum a,GLenum b,GLfloat c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat param	__asm("fp0");   
	glTexParameterf(target,pname,param);   
}   
   
   
   
void APIENTRY smglTexParameteri( GLenum a,GLenum b,GLint c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint param	__asm("d2");   
	glTexParameteri(target,pname,param);   
}   
   
   
   
void APIENTRY smglTexParameterfv( GLenum a,GLenum b,const GLfloat *c )   
{   
register GLenum target		__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLfloat *params	__asm("a0");    
	glTexParameterfv(target,pname,params);   
}   
   
   
   
void APIENTRY smglTexParameteriv( GLenum a,GLenum b,const GLint *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register const GLint *params	__asm("a0");   
	glTexParameteriv(target,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexParameterfv( GLenum a,GLenum b,GLfloat *c)   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat *params	__asm("a0");   
	glGetTexParameterfv(target,pname,params);   
}   
   
   
   
void APIENTRY smglGetTexParameteriv( GLenum a,GLenum b,GLint *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint *params	__asm("a0");   
	glGetTexParameteriv(target,pname,params);   
}   
   
   
   
   
void APIENTRY smglGetTexLevelParameterfv( GLenum a,GLint b,GLenum c,GLfloat *d )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum pname	__asm("d2");   
register GLfloat *params	__asm("a0");   
	glGetTexLevelParameterfv(target,level,pname,params);   
}   
   
   
   
   
void APIENTRY smglGetTexLevelParameteriv( GLenum a,GLint b,GLenum c,GLint *d )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum pname	__asm("d2");   
register GLint *params	__asm("a0");   
	glGetTexLevelParameteriv(target,level,pname,params);   
}   
   
   
   
   
   
   
   
   
void APIENTRY smglTexImage1D( GLenum a,GLint b,GLint c,GLsizei d,GLint e,GLenum f,GLenum g,const GLvoid *h )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint components	__asm("d2");   
register GLsizei width	__asm("d3");   
register GLint border	__asm("d4");   
register GLenum format	__asm("d5");   
register GLenum type	__asm("d6");   
register const GLvoid *pixels	__asm("a0");   
	glTexImage1D(target,level,components,width,border,format,type,pixels);   
}   
   
   
   
   
   
   
   
   
   
void APIENTRY smglTexImage2D( GLenum a,GLint b,GLint c,GLsizei d,GLsizei e,GLint f,GLenum g,GLenum h,const GLvoid *i )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint components	__asm("d2");   
register GLsizei width	__asm("d3");   
register GLsizei height	__asm("d4");   
register GLint border	__asm("d5");   
register GLenum format	__asm("d6");   
register GLenum type	__asm("d7");   
register const GLvoid *pixels	__asm("a0");   
	glTexImage2D(target,level,components,width,height,border,format,type,pixels);   
}   
   
   
   
   
   
void APIENTRY smglGetTexImage( GLenum a,GLint b,GLenum c,GLenum d,GLvoid *e )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum format	__asm("d2");   
register GLenum type	__asm("d3");   
register GLvoid *pixels	__asm("a0");   
	glGetTexImage(target,level,format,type,pixels);   
}   
   
   
/*   
 * 1.1 functions   
 */   
   
   
   
void APIENTRY smglGenTextures( GLsizei a,GLuint *b )   
{   
register GLsizei n	__asm("d0");   
register GLuint *textures	__asm("a0");   
	glGenTextures(n,textures);   
}   
   
   
void APIENTRY smglDeleteTextures( GLsizei a,const GLuint *b )   
{   
register GLsizei n	__asm("d0");   
register const GLuint *textures	__asm("a0");   
	glDeleteTextures(n,textures);   
}   
   
   
void APIENTRY smglBindTexture( GLenum a,GLuint b )   
{   
register GLenum target	__asm("d0");   
register GLuint texture	__asm("d1");   
	glBindTexture(target,texture);   
}   
   
   
   
void APIENTRY smglPrioritizeTextures( GLsizei a,const GLuint *b,const GLclampf *c )   
{   
register GLsizei n	__asm("d0");   
register const GLuint *textures	__asm("a0");   
register const GLclampf *priorities	__asm("a1");   
	glPrioritizeTextures(n,textures,priorities);   
}   
   
   
   
GLboolean APIENTRY smglAreTexturesResident( GLsizei a,const GLuint *b,GLboolean *c )   
{   
register GLsizei n	__asm("d0");   
register const GLuint *textures	__asm("a0");   
register GLboolean *residences	__asm("a1");   
	return(glAreTexturesResident(n,textures,residences));   
}   
   
GLboolean APIENTRY smglIsTexture( GLuint a )   
{   
register GLuint texture	__asm("d0");   
	return(glIsTexture(texture));   
}   
   
   
   
   
   
   
   
void APIENTRY smglTexSubImage1D( GLenum a,GLint b,GLint c,GLsizei d,GLenum e,GLenum f,const GLvoid *g )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLsizei width	__asm("d3");   
register GLenum format	__asm("d4");   
register GLenum type	__asm("d5");   
register const GLvoid *pixels	__asm("a0");   
	glTexSubImage1D(target,level,xoffset,width,format,type,pixels);   
}   
   
   
   
   
   
   
   
   
   
void APIENTRY smglTexSubImage2D( GLenum a,GLint b,GLint c,GLint d,GLsizei e,GLsizei f,GLenum g,GLenum h,const GLvoid *i )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint yoffset	__asm("d3");   
register GLsizei width	__asm("d4");   
register GLsizei height	__asm("d5");   
register GLenum format	__asm("d6");   
register GLenum type	__asm("d7");   
register const GLvoid *pixels	__asm("a0");   
	glTexSubImage2D(target,level,xoffset,yoffset,width,height,format,type,pixels);   
}   
   
   
   
   
   
   
   
void APIENTRY smglCopyTexImage1D( GLenum a,GLint b,GLenum c,GLint d,GLint e,GLsizei f,GLint g )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum internalformat	__asm("d2");   
register GLint x	__asm("d3");   
register GLint y	__asm("d4");   
register GLsizei width	__asm("d5");   
register GLint border	__asm("d6");   
	glCopyTexImage1D(target,level,internalformat,x,y,width,border);   
}   
   
   
   
   
   
   
   
   
void APIENTRY smglCopyTexImage2D( GLenum a,GLint b,GLenum c,GLint d,GLint e,GLsizei f,GLsizei g,GLint h )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum internalformat	__asm("d2");   
register GLint x	__asm("d3");   
register GLint y	__asm("d4");   
register GLsizei width	__asm("d5");   
register GLsizei height	__asm("d6");   
register GLint border	__asm("d7");   
	glCopyTexImage2D(target,level,internalformat,x,y,width,height,border);   
}   
   
   
   
   
   
   
void APIENTRY smglCopyTexSubImage1D( GLenum a,GLint b,GLint c,GLint d,GLint e,GLsizei f )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint x	__asm("d3");   
register GLint y	__asm("d4");   
register GLsizei width	__asm("d5");   
	glCopyTexSubImage1D(target,level,xoffset,x,y,width);   
}   
   
   
   
   
   
   
   
   
void APIENTRY smglCopyTexSubImage2D( GLenum a,GLint b,GLint c,GLint d,GLint e,GLint f,GLsizei g,GLsizei h )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint yoffset	__asm("d3");   
register GLint x	__asm("d4");   
register GLint y	__asm("d5");   
register GLsizei width	__asm("d6");   
register GLsizei height	__asm("d7");   
	glCopyTexSubImage2D(target,level,xoffset,yoffset,x,y,width,height);   
}   
   
   
/*   
 * Evaluators   
 */   
   
   
   
   
   
   
void APIENTRY smglMap1d( GLenum a,GLdouble b,GLdouble c,GLint d,GLint e,const GLdouble *f )   
{   
register GLenum target	__asm("d0");   
register GLdouble u1	__asm("fp0");   
register GLdouble u2	__asm("fp1");   
register GLint stride	__asm("d1");   
register GLint order	__asm("d2");   
register const GLdouble *points	__asm("a0");   
	glMap1d(target,u1,u2,stride,order,points);   
}   
   
   
   
   
   
   
void APIENTRY smglMap1f( GLenum a,GLfloat b,GLfloat c,GLint d,GLint e,const GLfloat *f )   
{   
register GLenum target	__asm("d0");   
register GLfloat u1	__asm("fp0");   
register GLfloat u2	__asm("fp1");   
register GLint stride	__asm("d1");   
register GLint order	__asm("d2");   
register const GLfloat *points	__asm("a0");   
	glMap1f(target,u1,u2,stride,order,points);   
}   
   
   
   
   
   
   
   
   
   
   
void APIENTRY smglMap2d( GLenum a,GLdouble b,GLdouble c,GLint d,GLint e,GLdouble f,GLdouble g,GLint h,GLint i,const GLdouble *j )   
{   
register GLenum target	__asm("d0");   
register GLdouble u1	__asm("fp0");   
register GLdouble u2	__asm("fp1");   
register GLint ustride	__asm("d1");   
register GLint uorder	__asm("d2");   
register GLdouble v1	__asm("fp2");   
register GLdouble v2	__asm("fp3");   
register GLint vstride	__asm("d3");   
register GLint vorder	__asm("d4");   
register const GLdouble *points	__asm("a0");   
	glMap2d(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);   
}   
   
   
   
   
   
   
   
   
   
   
void APIENTRY smglMap2f( GLenum a,GLfloat b,GLfloat c,GLint d,GLint e,GLfloat f,GLfloat g,GLint h,GLint i,const GLfloat *j )   
{   
register GLenum target	__asm("d0");   
register GLfloat u1	__asm("fp0");   
register GLfloat u2	__asm("fp1");   
register GLint ustride	__asm("d1");   
register GLint uorder	__asm("d2");   
register GLfloat v1	__asm("fp2");   
register GLfloat v2	__asm("fp3");   
register GLint vstride	__asm("d3");   
register GLint vorder	__asm("d4");   
register const GLfloat *points	__asm("a0");   
	glMap2f(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);   
}   
   
   
   
void APIENTRY smglGetMapdv( GLenum a,GLenum b,GLdouble *c )   
{   
register GLenum target	__asm("d0");   
register GLenum query	__asm("d1");   
register GLdouble *v	__asm("a0");   
	glGetMapdv(target,query,v);   
}   
   
   
   
void APIENTRY smglGetMapfv( GLenum a,GLenum b,GLfloat *c )   
{   
register GLenum target	__asm("d0");   
register GLenum query	__asm("d1");   
register GLfloat *v	__asm("a0");   
	glGetMapfv(target,query,v);   
}   
   
   
   
void APIENTRY smglGetMapiv( GLenum a,GLenum b,GLint *c )   
{   
register GLenum target	__asm("d0");   
register GLenum query	__asm("d1");   
register GLint *v	__asm("a0");   
	glGetMapiv(target,query,v);   
}   
   
void APIENTRY smglEvalCoord1d( GLdouble a )   
{   
register GLdouble u	__asm("fp0");   
	glEvalCoord1d(u);   
}   
   
void APIENTRY smglEvalCoord1f( GLfloat a )   
{   
register GLfloat u	__asm("fp0");   
	glEvalCoord1f(u);   
}   
   
void APIENTRY smglEvalCoord1dv( const GLdouble *a )   
{   
register const GLdouble *u	__asm("a0");   
	glEvalCoord1dv(u);   
}   
   
void APIENTRY smglEvalCoord1fv( const GLfloat *a )   
{   
register const GLfloat *u	__asm("a0");   
	glEvalCoord1fv(u);   
}   
   
   
void APIENTRY smglEvalCoord2d( GLdouble a,GLdouble b )   
{   
register GLdouble u	__asm("fp0");   
register GLdouble v	__asm("fp1");   
	glEvalCoord2d(u,v);   
}   
   
   
void APIENTRY smglEvalCoord2f( GLfloat a,GLfloat b )   
{   
register GLfloat u	__asm("fp0");   
register GLfloat v	__asm("fp1");   
	glEvalCoord2f(u,v);   
}   
   
void APIENTRY smglEvalCoord2dv(const GLdouble *a )   
{   
register const GLdouble *u	__asm("a0");   
	glEvalCoord2dv(u);   
}   
void APIENTRY smglEvalCoord2fv( const GLfloat *a )   
{   
register const GLfloat *u	__asm("a0");   
	glEvalCoord2fv(u);   
}   
   
   
   
void APIENTRY smglMapGrid1d( GLint a,GLdouble b,GLdouble c )   
{   
register GLint un	__asm("d0");   
register GLdouble u1	__asm("fp0");   
register GLdouble u2	__asm("fp1");   
	glMapGrid1d(un,u1,u2);   
}   
   
   
void APIENTRY smglMapGrid1f( GLint a,GLfloat b,GLfloat c )   
{   
register GLint un	__asm("d0");   
register GLfloat u1	__asm("fp0");   
register GLfloat u2	__asm("fp1");   
	glMapGrid1f(un,u1,u2);   
}   
   
   
   
   
   
   
void APIENTRY smglMapGrid2d( GLint a,GLdouble b,GLdouble c,GLint d,GLdouble e,GLdouble f )   
{   
register GLint un	__asm("d0");   
register GLdouble u1	__asm("fp0");   
register GLdouble u2	__asm("fp1");   
register GLint vn	__asm("d1");   
register GLdouble v1	__asm("fp2");   
register GLdouble v2	__asm("fp3");   
	glMapGrid2d(un,u1,u2,vn,v1,v2);   
}   
   
   
   
   
   
   
void APIENTRY smglMapGrid2f( GLint a,GLfloat b,GLfloat c,GLint d,GLfloat e,GLfloat f )   
{   
register GLint un	__asm("d0");   
register GLfloat u1	__asm("fp0");   
register GLfloat u2	__asm("fp1");   
register GLint vn	__asm("d1");   
register GLfloat v1	__asm("fp2");   
register GLfloat v2	__asm("fp3");   
	glMapGrid2f(un,u1,u2,vn,v1,v2);   
}   
   
void APIENTRY smglEvalPoint1( GLint a )   
{   
register GLint i	__asm("d0");   
	glEvalPoint1(i);   
}   
   
   
void APIENTRY smglEvalPoint2( GLint a,GLint b )   
{   
register GLint i	__asm("d0");   
register GLint j	__asm("d1");   
	glEvalPoint2(i,j);   
}   
   
   
   
void APIENTRY smglEvalMesh1( GLenum a,GLint b,GLint c )   
{   
register GLenum mode	__asm("d0");   
register GLint i1	__asm("d1");   
register GLint i2	__asm("d2");   
	glEvalMesh1(mode,i1,i2);   
}   
   
   
   
   
   
void APIENTRY smglEvalMesh2( GLenum a,GLint b,GLint c,GLint d,GLint e )   
{   
register GLenum mode	__asm("d0");   
register GLint i1	__asm("d1");   
register GLint i2	__asm("d2");   
register GLint j1	__asm("d3");   
register GLint j2	__asm("d4");   
	glEvalMesh2(mode,i1,i2,j1,j2);   
}   
   
   
   
/*   
 * Fog   
 */   
   
   
void APIENTRY smglFogf( GLenum a,GLfloat b )   
{   
register GLenum pname	__asm("d0");   
register GLfloat param	__asm("fp0");   
	glFogf(pname,param);   
}   
   
   
void APIENTRY smglFogi( GLenum a,GLint b )   
{   
register GLenum pname	__asm("d0");   
register GLint param	__asm("d1");   
	glFogi(pname,param);   
}   
   
   
void APIENTRY smglFogfv( GLenum a,const GLfloat *b )   
{   
register GLenum pname	__asm("d0");   
register const GLfloat *params	__asm("a0");   
	glFogfv(pname,params);   
}   
   
   
void APIENTRY smglFogiv( GLenum a,const GLint *b )   
{   
register GLenum pname	__asm("d0");   
register const GLint *params	__asm("a0");   
	glFogiv(pname,params);   
}   
   
   
   
/*   
 * Selection and Feedback   
 */   
   
   
   
void APIENTRY smglFeedbackBuffer( GLsizei a,GLenum b,GLfloat *c )   
{   
register GLsizei size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLfloat *buffer	__asm("a0");   
	glFeedbackBuffer(size,type,buffer);   
}   
   
void APIENTRY smglPassThrough( GLfloat a )   
{   
register GLfloat token	__asm("fp0");   
	glPassThrough(token);   
}   
   
   
void APIENTRY smglSelectBuffer( GLsizei a,GLuint *b )   
{   
register GLsizei size	__asm("d0");   
register GLuint *buffer	__asm("a0");   
	glSelectBuffer(size,buffer);   
}   
   
void APIENTRY smglInitNames(void )   
{   
	glInitNames();   
}   
   
void APIENTRY smglLoadName( GLuint a )   
{   
register GLuint name	__asm("d0");   
	glLoadName(name);   
}   
   
void APIENTRY smglPushName( GLuint a )   
{   
register GLuint name	__asm("d0");   
	glPushName(name);   
}   
   
void APIENTRY smglPopName(void )   
{   
	glPopName();   
}   
   
   
   
/*   
 * 1.0 Extensions   
 */   
   
/* GL_EXT_blend_minmax */   
   
void APIENTRY smglBlendEquationEXT( GLenum a )   
{   
register GLenum mode	__asm("d0");   
	glBlendEquationEXT(mode);   
}   
   
/* GL_EXT_blend_color */   
   
   
   
   
void APIENTRY smglBlendColorEXT( GLclampf a,GLclampf b,GLclampf c,GLclampf d )   
{   
register GLclampf red	__asm("fp0");   
register GLclampf green	__asm("fp1");   
register GLclampf blue	__asm("fp2");   
register GLclampf alpha	__asm("fp3");   
	glBlendColorEXT(red,green,blue,alpha);   
}   
   
   
/* GL_EXT_polygon_offset */   
   
   
void APIENTRY smglPolygonOffsetEXT( GLfloat a,GLfloat b )   
{   
register GLfloat factor	__asm("fp0");   
register GLfloat bias	__asm("fp1");   
	glPolygonOffsetEXT(factor,bias);   
}   
   
/* GL_EXT_vertex_array */   
   
   
   
   
   
void APIENTRY smglVertexPointerEXT( GLint a,GLenum b,GLsizei c,GLsizei d,const GLvoid *e )   
{   
register GLint size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLsizei stride	__asm("d2");   
register GLsizei count	__asm("d3");   
register const GLvoid *ptr	__asm("a0");   
	glVertexPointerEXT(size,type,stride,count,ptr);   
}   
   
   
   
   
void APIENTRY smglNormalPointerEXT( GLenum a,GLsizei b,GLsizei c,const GLvoid *d )   
{   
register GLenum type	__asm("d0");   
register GLsizei stride	__asm("d1");   
register GLsizei count	__asm("d2");   
register const GLvoid *ptr	__asm("a0");   
	glNormalPointerEXT(type,stride,count,ptr);   
}   
   
   
   
   
   
void APIENTRY smglColorPointerEXT( GLint a,GLenum b,GLsizei c,GLsizei d,const GLvoid *e )   
{   
register GLint size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLsizei stride	__asm("d2");   
register GLsizei count	__asm("d3");   
register const GLvoid *ptr	__asm("a0");   
	glColorPointerEXT(size,type,stride,count,ptr);   
}   
   
   
   
   
void APIENTRY smglIndexPointerEXT( GLenum a,GLsizei b,GLsizei c,const GLvoid *d )   
{   
register GLenum type	__asm("d0");   
register GLsizei stride	__asm("d1");   
register GLsizei count	__asm("d2");   
register const GLvoid *ptr	__asm("a0");   
	glIndexPointerEXT(type,stride,count,ptr);   
}   
   
   
   
   
   
void APIENTRY smglTexCoordPointerEXT( GLint a,GLenum b,GLsizei c,GLsizei d,const GLvoid *e )   
{   
register GLint size	__asm("d0");   
register GLenum type	__asm("d1");   
register GLsizei stride	__asm("d2");   
register GLsizei count	__asm("d3");   
register const GLvoid *ptr	__asm("a0");   
	glTexCoordPointerEXT(size,type,stride,count,ptr);   
}   
   
   
   
void APIENTRY smglEdgeFlagPointerEXT( GLsizei a,GLsizei b,const GLboolean *c )   
{   
register GLsizei stride	__asm("d0");   
register GLsizei count	__asm("d1");   
register const GLboolean *ptr	__asm("a0");   
	glEdgeFlagPointerEXT(stride,count,ptr);   
}   
   
   
void APIENTRY smglGetPointervEXT( GLenum a,void **b )   
{   
register GLenum pname	__asm("d0");   
register void **params	__asm("a0");   
	glGetPointervEXT(pname,params);   
}   
   
void APIENTRY smglArrayElementEXT( GLint a )   
{   
register GLint i	__asm("d0");   
	glArrayElementEXT(i);   
}   
   
   
   
void APIENTRY smglDrawArraysEXT( GLenum a,GLint b,GLsizei c )   
{   
register GLenum mode	__asm("d0");   
register GLint first	__asm("d1");   
register GLsizei count	__asm("d2");   
	glDrawArraysEXT(mode,first,count);   
}   
   
   
/* GL_EXT_texture_object */   
   
   
void APIENTRY smglGenTexturesEXT( GLsizei a,GLuint *b )   
{   
register GLsizei n	__asm("d0");   
register GLuint *textures	__asm("a0");   
	glGenTexturesEXT(n,textures);   
}   
   
   
void APIENTRY smglDeleteTexturesEXT( GLsizei a,const GLuint *b )   
{   
register GLsizei n	__asm("d0");   
register const GLuint *textures	__asm("a0");   
	glDeleteTexturesEXT(n,textures);   
}   
   
   
void APIENTRY smglBindTextureEXT( GLenum a,GLuint b )   
{   
register GLenum target	__asm("d0");   
register GLuint texture	__asm("d1");   
	glBindTextureEXT(target,texture);   
}   
   
   
   
void APIENTRY smglPrioritizeTexturesEXT( GLsizei a,const GLuint *b,const GLclampf *c )   
{   
register GLsizei n	__asm("d0");   
register const GLuint *textures	__asm("a0");   
register const GLclampf *priorities	__asm("a1");   
	glPrioritizeTexturesEXT(n,textures,priorities);   
}   
   
   
   
GLboolean APIENTRY smglAreTexturesResidentEXT( GLsizei a,const GLuint *b,GLboolean *c )   
{   
register GLsizei n	__asm("d0");   
register const GLuint *textures	__asm("a0");   
register GLboolean *residences	__asm("a1");   
	return(glAreTexturesResidentEXT(n,textures,residences));   
}   
   
GLboolean APIENTRY smglIsTextureEXT( GLuint a )   
{   
register GLuint texture	__asm("d0");   
	return(glIsTextureEXT(texture));   
}   
   
   
   
/* GL_EXT_texture3D */   
   
   
   
   
   
   
   
   
   
   
void APIENTRY smglTexImage3DEXT( GLenum a,GLint b,GLenum c,GLsizei d,GLsizei e,GLsizei f,GLint g,GLenum h,GLenum i,const GLvoid *j )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum internalformat	__asm("d2");   
register GLsizei width	__asm("d3");   
register GLsizei height	__asm("d4");   
register GLsizei depth	__asm("d5");   
register GLint border	__asm("d6");   
register GLenum format	__asm("d7");   
register GLenum type	__asm("a0");   
register const GLvoid *pixels	__asm("a1");   
	glTexImage3DEXT(target,level,internalformat,width,height,depth,border,format,type,pixels);   
}   
   
   
   
   
   
   
   
   
   
   
   
void APIENTRY smglTexSubImage3DEXT( GLenum a,GLint b,GLint c,GLint d,GLint e,GLsizei f,GLsizei g,GLsizei h,GLenum i,GLenum j,const GLvoid *k )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint yoffset	__asm("d3");   
register GLint zoffset	__asm("d4");   
register GLsizei width	__asm("d5");   
register GLsizei height	__asm("d6");   
register GLsizei depth	__asm("d7");   
register GLenum format	__asm("a0");   
register GLenum type	__asm("a1");   
register const GLvoid *pixels	__asm("a2");   
	glTexSubImage3DEXT(target,level,xoffset,yoffset,zoffset,width,height,depth,format,type,pixels);   
}   
   
   
   
   
   
   
   
   
   
void APIENTRY smglCopyTexSubImage3DEXT( GLenum a,GLint b,GLint c,GLint d,GLint e,GLint f,GLint g,GLsizei h,GLsizei i )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint yoffset	__asm("d3");   
register GLint zoffset	__asm("d4");   
register GLint x	__asm("d5");   
register GLint y	__asm("d6");   
register GLsizei width	__asm("d7");   
register GLsizei height	__asm("a0");   
	glCopyTexSubImage3DEXT(target,level,xoffset,yoffset,zoffset,x,y,width,height);   
}   
   
/* EXT_color_table */   
   
   
   
   
   
   
void APIENTRY smglColorTableEXT( GLenum a,GLenum b,GLsizei c,GLenum d,GLenum e,const GLvoid *f )   
{   
register GLenum target	__asm("d0");   
register GLenum internalformat	__asm("d1");   
register GLsizei width	__asm("d2");   
register GLenum format	__asm("d3");   
register GLenum type	__asm("d4");   
register const GLvoid *table	__asm("a0");   
	glColorTableEXT(target,internalformat,width,format,type,table);   
}   
   
   
   
   
   
   
void APIENTRY smglColorSubTableEXT( GLenum a,GLsizei b,GLsizei c,GLenum d,GLenum e,const GLvoid *f )   
{   
register GLenum target	__asm("d0");   
register GLsizei start	__asm("d1");   
register GLsizei count	__asm("d2");   
register GLenum format	__asm("d3");   
register GLenum type	__asm("d4");   
register const GLvoid *data	__asm("a0");   
	glColorSubTableEXT(target,start,count,format,type,data);   
}   
   
   
   
   
void APIENTRY smglGetColorTableEXT( GLenum a,GLenum b,GLenum c,GLvoid *d )   
{   
register GLenum target	__asm("d0");   
register GLenum format	__asm("d1");   
register GLenum type	__asm("d2");   
register GLvoid *table	__asm("a0");   
	glGetColorTableEXT(target,format,type,table);   
}   
   
   
   
void APIENTRY smglGetColorTableParameterfvEXT( GLenum a,GLenum b,GLfloat *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLfloat *params	__asm("a0");   
	glGetColorTableParameterfvEXT(target,pname,params);   
}   
   
   
   
void APIENTRY smglGetColorTableParameterivEXT( GLenum a,GLenum b,GLint *c )   
{   
register GLenum target	__asm("d0");   
register GLenum pname	__asm("d1");   
register GLint *params	__asm("a0");   
	glGetColorTableParameterivEXT(target,pname,params);   
}   
   
   
/* GL_SGIS_multitexture */   
   
   
void APIENTRY smglMultiTexCoord1dSGIS( GLenum a,GLdouble b )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
	glMultiTexCoord1dSGIS(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1dvSGIS( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord1dvSGIS(target,v);   
}   
   
   
void APIENTRY smglMultiTexCoord1fSGIS( GLenum a,GLfloat b )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
	glMultiTexCoord1fSGIS(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1fvSGIS( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord1fvSGIS(target,v);   
}   
   
   
void APIENTRY smglMultiTexCoord1iSGIS( GLenum a,GLint b )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
	glMultiTexCoord1iSGIS(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1ivSGIS( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord1ivSGIS(target,v);   
}   
   
   
void APIENTRY smglMultiTexCoord1sSGIS( GLenum a,GLshort b )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
	glMultiTexCoord1sSGIS(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1svSGIS( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord1svSGIS(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2dSGIS( GLenum a,GLdouble b,GLdouble c )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
	glMultiTexCoord2dSGIS(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2dvSGIS( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord2dvSGIS(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2fSGIS( GLenum a,GLfloat b,GLfloat c )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
	glMultiTexCoord2fSGIS(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2fvSGIS( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord2fvSGIS(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2iSGIS( GLenum a,GLint b,GLint c )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
register GLint t	__asm("d2");   
	glMultiTexCoord2iSGIS(target,s,t);   
}    
   
   
void APIENTRY smglMultiTexCoord2ivSGIS( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord2ivSGIS(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2sSGIS( GLenum a,GLshort b,GLshort c )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
register GLshort t	__asm("d2");   
	glMultiTexCoord2sSGIS(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2svSGIS( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord2svSGIS(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3dSGIS( GLenum a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
register GLdouble r	__asm("fp2");   
	glMultiTexCoord3dSGIS(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3dvSGIS( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord3dvSGIS(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3fSGIS( GLenum a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
register GLfloat r	__asm("fp2");   
	glMultiTexCoord3fSGIS(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3fvSGIS( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord3fvSGIS(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3iSGIS( GLenum a,GLint b,GLint c,GLint d )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
register GLint t	__asm("d2");   
register GLint r	__asm("d3");   
	glMultiTexCoord3iSGIS(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3ivSGIS( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord3ivSGIS(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3sSGIS( GLenum a,GLshort b,GLshort c,GLshort d )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
register GLshort t	__asm("d2");   
register GLshort r	__asm("d3");   
	glMultiTexCoord3sSGIS(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3svSGIS( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord3svSGIS(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4dSGIS( GLenum a,GLdouble b,GLdouble c,GLdouble d,GLdouble e )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
register GLdouble r	__asm("fp2");   
register GLdouble q	__asm("fp3");   
	glMultiTexCoord4dSGIS(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4dvSGIS( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord4dvSGIS(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4fSGIS( GLenum a,GLfloat b,GLfloat c,GLfloat d,GLfloat e )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
register GLfloat r	__asm("fp2");   
register GLfloat q	__asm("fp3");   
	glMultiTexCoord4fSGIS(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4fvSGIS( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord4fvSGIS(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4iSGIS( GLenum a,GLint b,GLint c,GLint d,GLint e )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
register GLint t	__asm("d2");   
register GLint r	__asm("d3");   
register GLint q	__asm("d4");   
	glMultiTexCoord4iSGIS(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4ivSGIS( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord4ivSGIS(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4sSGIS( GLenum a,GLshort b,GLshort c,GLshort d,GLshort e )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
register GLshort t	__asm("d2");   
register GLshort r	__asm("d3");   
register GLshort q	__asm("d4");   
	glMultiTexCoord4sSGIS(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4svSGIS( GLenum a,const GLshort *b)   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord4svSGIS(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoordPointerSGIS( GLenum a,GLint b,GLenum c,GLsizei d,const GLvoid *e )   
{   
register GLenum target	__asm("d0");   
register GLint size	__asm("d1");   
register GLenum type	__asm("d2");   
register GLsizei stride	__asm("d3");   
register const GLvoid *pointer	__asm("a0");   
	glMultiTexCoordPointerSGIS(target,size,type,stride,pointer);   
}   
   
void APIENTRY smglSelectTextureSGIS( GLenum a )   
{   
register GLenum target	__asm("d0");   
	glSelectTextureSGIS(target);   
}   
   
void APIENTRY smglSelectTextureCoordSetSGIS( GLenum a)   
{   
register GLenum target	__asm("d0");   
	glSelectTextureCoordSetSGIS(target);   
}   
   
   
/* GL_EXT_multitexture */   
   
   
void APIENTRY smglMultiTexCoord1dEXT( GLenum a,GLdouble b )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
	glMultiTexCoord1dEXT(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1dvEXT( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord1dvEXT(target,v);   
}   
   
   
void APIENTRY smglMultiTexCoord1fEXT( GLenum a,GLfloat b )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
	glMultiTexCoord1fEXT(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1fvEXT( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord1fvEXT(target,v);   
}   
   
   
void APIENTRY smglMultiTexCoord1iEXT( GLenum a,GLint b )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
	glMultiTexCoord1iEXT(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1ivEXT( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord1ivEXT(target,v);   
}   
   
   
void APIENTRY smglMultiTexCoord1sEXT( GLenum a,GLshort b )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
	glMultiTexCoord1sEXT(target,s);   
}   
   
   
void APIENTRY smglMultiTexCoord1svEXT( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord1svEXT(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2dEXT( GLenum a,GLdouble b,GLdouble c )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
	glMultiTexCoord2dEXT(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2dvEXT( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord2dvEXT(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2fEXT( GLenum a,GLfloat b,GLfloat c )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
	glMultiTexCoord2fEXT(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2fvEXT( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord2fvEXT(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2iEXT( GLenum a,GLint b,GLint c )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
register GLint t	__asm("d2");   
	glMultiTexCoord2iEXT(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2ivEXT( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord2ivEXT(target,v);   
}   
   
   
   
void APIENTRY smglMultiTexCoord2sEXT( GLenum a,GLshort b,GLshort c )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
register GLshort t	__asm("d2");   
	glMultiTexCoord2sEXT(target,s,t);   
}   
   
   
void APIENTRY smglMultiTexCoord2svEXT( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord2svEXT(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3dEXT( GLenum a,GLdouble b,GLdouble c,GLdouble d )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
register GLdouble r	__asm("fp2");   
	glMultiTexCoord3dEXT(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3dvEXT( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord3dvEXT(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3fEXT( GLenum a,GLfloat b,GLfloat c,GLfloat d)   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
register GLfloat r	__asm("fp2");   
	glMultiTexCoord3fEXT(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3fvEXT( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord3fvEXT(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3iEXT( GLenum a,GLint b,GLint c,GLint d )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
register GLint t	__asm("d2");   
register GLint r	__asm("d3");   
	glMultiTexCoord3iEXT(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3ivEXT( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord3ivEXT(target,v);   
}   
   
   
   
   
void APIENTRY smglMultiTexCoord3sEXT( GLenum a,GLshort b,GLshort c,GLshort d )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
register GLshort t	__asm("d2");   
register GLshort r	__asm("d3");   
	glMultiTexCoord3sEXT(target,s,t,r);   
}   
   
   
void APIENTRY smglMultiTexCoord3svEXT( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord3svEXT(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4dEXT( GLenum a,GLdouble b,GLdouble c,GLdouble d,GLdouble e )   
{   
register GLenum target	__asm("d0");   
register GLdouble s	__asm("fp0");   
register GLdouble t	__asm("fp1");   
register GLdouble r	__asm("fp2");   
register GLdouble q	__asm("fp3");   
	glMultiTexCoord4dEXT(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4dvEXT( GLenum a,const GLdouble *b )   
{   
register GLenum target	__asm("d0");   
register const GLdouble *v	__asm("a0");   
	glMultiTexCoord4dvEXT(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4fEXT( GLenum a,GLfloat b,GLfloat c,GLfloat d,GLfloat e )   
{   
register GLenum target	__asm("d0");   
register GLfloat s	__asm("fp0");   
register GLfloat t	__asm("fp1");   
register GLfloat r	__asm("fp2");   
register GLfloat q	__asm("fp3");   
	glMultiTexCoord4fEXT(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4fvEXT( GLenum a,const GLfloat *b )   
{   
register GLenum target	__asm("d0");   
register const GLfloat *v	__asm("a0");   
	glMultiTexCoord4fvEXT(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4iEXT( GLenum a,GLint b,GLint c,GLint d,GLint e )   
{   
register GLenum target	__asm("d0");   
register GLint s	__asm("d1");   
register GLint t	__asm("d2");   
register GLint r	__asm("d3");   
register GLint q	__asm("d4");   
	glMultiTexCoord4iEXT(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4ivEXT( GLenum a,const GLint *b )   
{   
register GLenum target	__asm("d0");   
register const GLint *v	__asm("a0");   
	glMultiTexCoord4ivEXT(target,v);   
}   
   
   
   
   
   
void APIENTRY smglMultiTexCoord4sEXT( GLenum a,GLshort b,GLshort c,GLshort d,GLshort e )   
{   
register GLenum target	__asm("d0");   
register GLshort s	__asm("d1");   
register GLshort t	__asm("d2");   
register GLshort r	__asm("d3");   
register GLshort q	__asm("d4");   
	glMultiTexCoord4sEXT(target,s,t,r,q);   
}   
   
   
void APIENTRY smglMultiTexCoord4svEXT( GLenum a,const GLshort *b )   
{   
register GLenum target	__asm("d0");   
register const GLshort *v	__asm("a0");   
	glMultiTexCoord4svEXT(target,v);   
}   
   
void APIENTRY smglInterleavedTextureCoordSetsEXT( GLint a )   
{   
register GLint factor	__asm("d0");   
	glInterleavedTextureCoordSetsEXT(factor);   
}   
   
void APIENTRY smglSelectTextureEXT( GLenum a )   
{   
register GLenum target	__asm("d0");   
	glSelectTextureEXT(target);   
}   
   
void APIENTRY smglSelectTextureCoordSetEXT( GLenum a )   
{   
register GLenum target	__asm("d0");   
	glSelectTextureCoordSetEXT(target);   
}   
   
void APIENTRY smglSelectTextureTransformEXT( GLenum a )   
{   
register GLenum target	__asm("d0");   
	glSelectTextureTransformEXT(target);   
}   
   
/* GL_EXT_point_parameters */   
   
   
void APIENTRY smglPointParameterfEXT( GLenum a,GLfloat b )   
{   
register GLenum pname	__asm("d0");   
register GLfloat param	__asm("fp0");   
	glPointParameterfEXT(pname,param);   
}   
   
   
void APIENTRY smglPointParameterfvEXT( GLenum a,const GLfloat *b )   
{   
register GLenum pname	__asm("d0");   
register const GLfloat *params	__asm("a0");   
	glPointParameterfvEXT(pname,params);   
}   
   
   
   
/*   
 * GL_MESA_window_pos   
 */   
   
   
void APIENTRY smglWindowPos2iMESA( GLint a,GLint b )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
	glWindowPos2iMESA(x,y);   
}   
   
   
void APIENTRY smglWindowPos2sMESA( GLshort a,GLshort b )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
	glWindowPos2sMESA(x,y);   
}   
   
   
void APIENTRY smglWindowPos2fMESA( GLfloat a,GLfloat b )   
   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
	glWindowPos2fMESA(x,y);   
}   
   
void APIENTRY smglWindowPos2dMESA( GLdouble a,GLdouble b )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
	glWindowPos2dMESA(x,y);   
}   
   
void APIENTRY smglWindowPos2ivMESA( const GLint *a )   
{   
register const GLint *p	__asm("a0");   
	glWindowPos2ivMESA(p);   
}   
   
void APIENTRY smglWindowPos2svMESA( const GLshort *a )   
{   
register const GLshort *p	__asm("a0");   
	glWindowPos2svMESA(p);   
}   
   
void APIENTRY smglWindowPos2fvMESA( const GLfloat *a )   
{   
register const GLfloat *p	__asm("a0");   
	glWindowPos2fvMESA(p);   
}   
   
void APIENTRY smglWindowPos2dvMESA( const GLdouble *a )   
{   
register const GLdouble *p	__asm("a0");   
	glWindowPos2dvMESA(p);   
}   
   
   
   
void APIENTRY smglWindowPos3iMESA( GLint a,GLint b,GLint c )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLint z	__asm("d2");   
	glWindowPos3iMESA(x,y,z);   
}   
   
   
   
void APIENTRY smglWindowPos3sMESA( GLshort a,GLshort b,GLshort c )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
register GLshort z	__asm("d2");   
	glWindowPos3sMESA(x,y,z);   
}   
   
   
   
void APIENTRY smglWindowPos3fMESA( GLfloat a,GLfloat b,GLfloat c )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
	glWindowPos3fMESA(x,y,z);   
}   
   
   
   
void APIENTRY smglWindowPos3dMESA( GLdouble a,GLdouble b,GLdouble c )   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
	glWindowPos3dMESA(x,y,z);   
}   
   
void APIENTRY smglWindowPos3ivMESA( const GLint *a )   
{   
register const GLint *p	__asm("a0");   
	glWindowPos3ivMESA(p);   
}   
   
void APIENTRY smglWindowPos3svMESA( const GLshort *a )   
{   
register const GLshort *p	__asm("a0");   
	glWindowPos3svMESA(p);   
}   
   
void APIENTRY smglWindowPos3fvMESA( const GLfloat *a )   
{   
register const GLfloat *p	__asm("a0");   
	glWindowPos3fvMESA(p);   
}   
   
void APIENTRY smglWindowPos3dvMESA( const GLdouble *a )   
{   
register const GLdouble *p	__asm("a0");   
	glWindowPos3dvMESA(p);   
}   
   
   
   
   
void APIENTRY smglWindowPos4iMESA( GLint a,GLint b,GLint c,GLint d )   
{   
register GLint x	__asm("d0");   
register GLint y	__asm("d1");   
register GLint z	__asm("d2");   
register GLint w	__asm("d3");   
	glWindowPos4iMESA(x,y,z,w);   
}   
   
   
   
   
void APIENTRY smglWindowPos4sMESA( GLshort a,GLshort b,GLshort c,GLshort d )   
{   
register GLshort x	__asm("d0");   
register GLshort y	__asm("d1");   
register GLshort z	__asm("d2");   
register GLshort w	__asm("d3");   
	glWindowPos4sMESA(x,y,z,w);   
}   
   
   
   
   
void APIENTRY smglWindowPos4fMESA( GLfloat a,GLfloat b,GLfloat c,GLfloat d )   
{   
register GLfloat x	__asm("fp0");   
register GLfloat y	__asm("fp1");   
register GLfloat z	__asm("fp2");   
register GLfloat w	__asm("fp3");   
	glWindowPos4fMESA(x,y,z,w);   
}   
   
   
   
   
void APIENTRY smglWindowPos4dMESA( GLdouble a,GLdouble b,GLdouble c,GLdouble d)   
{   
register GLdouble x	__asm("fp0");   
register GLdouble y	__asm("fp1");   
register GLdouble z	__asm("fp2");   
register GLdouble w	__asm("fp3");   
	glWindowPos4dMESA(x,y,z,w);   
}   
   
void APIENTRY smglWindowPos4ivMESA( const GLint *a )   
{   
register const GLint *p	__asm("a0");   
	glWindowPos4ivMESA(p);   
}   
   
void APIENTRY smglWindowPos4svMESA( const GLshort *a )   
{   
register const GLshort *p	__asm("a0");   
	glWindowPos4svMESA(p);   
}   
   
void APIENTRY smglWindowPos4fvMESA( const GLfloat *a )   
{   
register const GLfloat *p	__asm("a0");   
	glWindowPos4fvMESA(p);   
}   
   
void APIENTRY smglWindowPos4dvMESA( const GLdouble *a )   
{   
register const GLdouble *p	__asm("a0");   
	glWindowPos4dvMESA(p);   
}   
   
/* GL_MESA_resize_buffers */   
   
void APIENTRY smglResizeBuffersMESA()   
{   
	glResizeBuffersMESA();   
}   
   
/* 1.2 functions */   
   
   
   
   
   
    
void APIENTRY smglDrawRangeElements( GLenum a,GLuint b,GLuint c,GLsizei d,GLenum e,const GLvoid *f )   
{   
register GLenum mode	__asm("d0");   
register GLuint start	__asm("d1");   
register GLuint end	__asm("d2");   
register GLsizei count	__asm("d3");   
register GLenum type	__asm("d4");   
register const GLvoid *indices	__asm("a0");   
	glDrawRangeElements(mode,start,end,count,type,indices);   
}   
   
   
   
   
   
   
   
   
   
   
void APIENTRY smglTexImage3D( GLenum a,GLint b,GLenum c,GLsizei d,GLsizei e,GLsizei f,GLint g,GLenum h,GLenum i,const GLvoid *j )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLenum internalFormat	__asm("d2");   
register GLsizei width	__asm("d3");   
register GLsizei height	__asm("d4");   
register GLsizei depth	__asm("d5");   
register GLint border	__asm("d5");   
register GLenum format	__asm("d7");   
register GLenum type	__asm("a0");   
register const GLvoid *pixels	__asm("a1");   
	glTexImage3D(target,level,internalFormat,width,height,depth,border,format,type,pixels);   
}   
   
   
   
   
   
   
   
   
   
   
   
void APIENTRY smglTexSubImage3D( GLenum a,GLint b,GLint c,GLint d,GLint e,GLsizei f,GLsizei g,GLsizei h,GLenum i,GLenum j,const GLvoid *k )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint yoffset	__asm("d3");   
register GLint zoffset	__asm("d4");   
register GLsizei width	__asm("d5");   
register GLsizei height	__asm("d6");   
register GLsizei depth	__asm("d7");   
register GLenum format	__asm("a0");   
register GLenum type	__asm("a1");   
register const GLvoid *pixels	__asm("a2");   
	glTexSubImage3D(target,level,xoffset,yoffset,zoffset,width,height,depth,format,type,pixels);   
}   
   
   
   
   
   
   
   
   
   
void APIENTRY smglCopyTexSubImage3D( GLenum a,GLint b,GLint c,GLint d,GLint e,GLint f,GLint g,GLsizei h,GLsizei i )   
{   
register GLenum target	__asm("d0");   
register GLint level	__asm("d1");   
register GLint xoffset	__asm("d2");   
register GLint yoffset	__asm("d3");   
register GLint zoffset	__asm("d4");   
register GLint x	__asm("d5");   
register GLint y	__asm("d6");   
register GLsizei width	__asm("d7");   
register GLsizei height	__asm("a0");   
	glCopyTexSubImage3D(target,level,xoffset,yoffset,zoffset,x,y,width,height );   
} 
