
#include "AmigaIncludes.h"
#include "AmigaPrefs.h"
#include <proto/gadtools.h>
extern BOOL LibDebug;				/* Enable Library Debugger (global)		*/

#if !defined(__AROS__) && !defined(__MORPHOS__) 
typedef ULONG IPTR; 
#endif

UBYTE StormMesaPrefsName[] = {"StormMesa Prefs.Beta 1.Roesch&Thellier&Wawa"};
IPTR StormMesaPrefsNameTag=(IPTR) StormMesaPrefsName;
struct STORMMESA_parameters StormMesa;
struct Library *GadToolsBase;
#define LIBCLOSE(Lbase)	 if(Lbase!=NULL)	{CloseLibrary( ((struct Library *)Lbase) );Lbase=NULL;}


static struct TextAttr MyFont = { "courier.font", 13, 0, 0, };
/*
static struct TextAttr MyFont = { "topaz.font", 8, 0, 0, };
*/
#define NLOOP(nbre) for(n=0;n<nbre;n++)
#define STORMMESADEBUG 1

static void process_window_events(struct Window *mywin,struct button3D *ButtonList)
{
struct IntuiMessage *imsg;
struct Gadget *gad;
BOOL  terminated = FALSE;

while (!terminated)
    {
    Wait (1 << mywin->UserPort->mp_SigBit);

    /* Use GT_GetIMsg() and GT_ReplyIMsg() for handling */
    /* IntuiMessages with GadTools gadgets.             */
    while ((!terminated) && (imsg = GT_GetIMsg(mywin->UserPort)))
        {
        /* GT_ReplyIMsg() at end of loop */

        switch (imsg->Class)
            {
            case IDCMP_GADGETUP:       /* Buttons only report GADGETUP */
                gad = (struct Gadget *)imsg->IAddress;
            ButtonList[gad->GadgetID].ON=!ButtonList[gad->GadgetID].ON;
                break;
            case IDCMP_CLOSEWINDOW:
                terminated = TRUE;
                break;
            case IDCMP_REFRESHWINDOW:
                /* This handling is REQUIRED with GadTools. */
                GT_BeginRefresh(mywin);
                GT_EndRefresh(mywin, TRUE);
                break;
            }
        /* Use the toolkit message-replying function here... */
        GT_ReplyIMsg(imsg);
        }
    }
}

void
LibSettings(struct button3D *ButtonList,WORD ButtonCount)
{
struct Screen    *mysc;
struct Window    *mywin;
struct Gadget    *glist, *gad;
struct NewGadget ng;
void             *vi;
WORD n,x,y;
glist = NULL;


	GadToolsBase =			 OpenLibrary("gadtools.library", 37);
	if(GadToolsBase==NULL) return;

if ( (mysc = LockPubScreen(NULL)) != NULL )
    {
    if ( (vi = GetVisualInfo(mysc, TAG_END)) != NULL )
        {
        /* GadTools gadgets require this step to be taken */
        gad = CreateContext(&glist);

NLOOP(ButtonCount)
{
	x=220 + mysc->WBorLeft;
	y=12*n + 6 + mysc->WBorTop + (mysc->Font->ta_YSize + 1);
	if((ButtonCount/2) < n)
		{x=x+220; y=y-ButtonCount/2*12;}

        /* create a button gadget centered below the window title */
        ng.ng_TextAttr   = &MyFont;
        ng.ng_VisualInfo = vi;
        ng.ng_LeftEdge   = x;
        ng.ng_TopEdge    = y;
        ng.ng_Width      = 24;
        ng.ng_Height     = 12;
        ng.ng_GadgetText = ButtonList[n].name;
        ng.ng_GadgetID   = n;
        ng.ng_Flags      = 0;
	gad = CreateGadget(CHECKBOX_KIND, gad, &ng, GT_Underscore, '_',  GTCB_Scaled, TRUE,GTCB_Checked,ButtonList[n].ON,TAG_DONE);
}

        if (gad != NULL)
            {
            if ( (mywin = OpenWindowTags(NULL,
                    WA_Title,  StormMesaPrefsNameTag ,
                    WA_Gadgets, (ULONG)  glist,      WA_AutoAdjust,    TRUE,
                    WA_InnerWidth,       260+220,      WA_InnerHeight,    20+12*ButtonCount/2,
                    WA_DragBar,    TRUE,      WA_DepthGadget,   TRUE,
                    WA_Activate,   TRUE,      WA_CloseGadget,   TRUE,
                    WA_IDCMP, IDCMP_CLOSEWINDOW |IDCMP_REFRESHWINDOW | BUTTONIDCMP,
                    WA_PubScreen,  (ULONG) mysc,
                    TAG_END)) != NULL )
                {
                GT_RefreshWindow(mywin, NULL);

                process_window_events(mywin,ButtonList);

                CloseWindow(mywin);
                }
            }
        /* FreeGadgets() must be called after the context has been
        ** created.  It does nothing if glist is NULL
        */
        FreeGadgets(glist);
        FreeVisualInfo(vi);
        }

    UnlockPubScreen(NULL, mysc);
    }

	CloseLibrary( ((struct Library *)GadToolsBase) );
}
/*=================================================================*/
void STORMMESA_Settings()
{
WORD ButtonCount;

#ifdef STORMMESADEBUG
	ButtonCount=((LONG)&StormMesa.ChangePrimitiveFuncs  - (LONG)&StormMesa.NOHW)/sizeof(struct button3D)+1;
#else
	ButtonCount=((LONG)&StormMesa.DebugStormMesa  - (LONG)&StormMesa.NOHW)/sizeof(struct button3D)+1;
#endif
	StormMesa.DebugStormMesa.ON=LibDebug;
	LibSettings(&StormMesa.NOHW,ButtonCount);
	LibDebug=StormMesa.DebugStormMesa.ON;
}
/*==================================================================================*/
void STORMMESA_Init()
{

	REM(STORMMESA_Init)
	Libstrcpy(StormMesa.NOHW.name,"NOHW");
	Libstrcpy(StormMesa.DIRECT.name,"DIRECT");
	Libstrcpy(StormMesa.FAST.name,"FAST");
	Libstrcpy(StormMesa.VERYFAST.name,"VERYFAST");
	Libstrcpy(StormMesa.SYNC.name,"SYNC");
	Libstrcpy(StormMesa.TRIPLE.name,"TRIPLE");
	Libstrcpy(StormMesa.STATS.name,"STATS");
	Libstrcpy(StormMesa.NOCLAMP.name,"NOCLAMP");
	Libstrcpy(StormMesa.NICETEX.name,"NICETEX");
	Libstrcpy(StormMesa.NICEFOG.name,"NICEFOG");
	Libstrcpy(StormMesa.NOHWLINES.name,"NOHWLINES");
	Libstrcpy(StormMesa.LOCKMODE1.name,"LOCKMODE1");
	Libstrcpy(StormMesa.LOCKMODE2.name,"LOCKMODE2");
	Libstrcpy(StormMesa.LOCKMODE3.name,"LOCKMODE3");
	Libstrcpy(StormMesa.PROFILE.name,"PROFILE");
	Libstrcpy(StormMesa.NORASTER.name,"NORASTER");
	Libstrcpy(StormMesa.NODITHER.name,"NODITHER");
	Libstrcpy(StormMesa.NOZB.name,"NOZB");
	Libstrcpy(StormMesa.NOZBU.name,"NOZBU");
	Libstrcpy(StormMesa.LIN.name,"LIN");
	Libstrcpy(StormMesa.DebugStormMesa.name,">>> Enable Debugger >>>");
	Libstrcpy(StormMesa.DebugFunction.name,"Debug Function");	
	Libstrcpy(StormMesa.StepFunction.name,"Step Function");		
	Libstrcpy(StormMesa.ChangePrimitiveFuncs.name,"Change Primitive Funcs");

}
/*==================================================================================*/
void STORMMESA_Close()
{
	return;
}
/*==================================================================================*/
/*
MESA_DEBUG:     Enables the output of detailled error messages. This is
                used for debugging of OpenGL programs.
MESA/DIRECT:    Forces the application to run in 'direct render' mode,
                even if the application attempted to run in the
                'indirect render' mode. The use of 3D hardware is only
                possible in 'direct render' mode.
MESA/NOHW:      Forces the graphics to be drawn by the CPU, the 3D
                hardware is not touched.
MESA/SYNC:      Enforces synchronized refreshing of the graphics in window
                mode. Since StormMesa 3.1 no synchronisation is done
                by default in window mode.
MESA/TRIPLE:    Enables triple buffering. This leads for fast applications
                to better performance in fullscreen mode and to a more
                constant animation. The disadvantage is the much bigger
                video memory usage.
MESA/NOCLAMP

If this option is activated, then 'texture wrapping' is also used,
if the application wants to use 'texture clamping'. This option
should be used when a Virge 3D processor is used, because the
amount of demos capable of running 3D hardware accelerated grows
a lot.

MESA/NICETEX

Cares, that the graphics quality concerning textures is as good as
possible, even if the overall graphics quality was reduced using
the variables FAST and VERYFAST.

MESA/NICEFOG

Cares, that the graphics quality concerning fogging is as good as
possible, even if the overall graphics quality was reduced using
the variables FAST and VERYFAST.

MESA/NOHWLINES

Forbids the use of 3D hardware rendering for line drawing.

0 : The graphics isn't drawn directly, an 'indirect context' of the
    Warp3D software is used. The drawing operations are collected
    in a buffer and drawn later, by enclosing such drawing operations
    by an lock/unlock call.
    This mode is the most system friendly mode and also works for
    applications, that call system functions during OpenGL drawing
    which might also cause graphical output.
    The disadvantage of this mode is the low performance.
1 : All objects are drawn directly and every begin-end-block is
    enclosed by a lock/unlock call. This mode is right now useless,
    since it's performance is very low due to massive lock/unlock
    call overhead.
2 : All objects are drawn directly and the lock is held during the
    whole display function. This is the fastest mode, but very
    system unfriendly, because it freezes the system very much.
3 : This mode works very similar to mode 2, but here the lock is
    broken in periodic intervals to let the system 'breathe air'.
    Practice has shown, that the performance usually isn't
    noticeable lower than for the mode 2, but the system
    friendliness is much better.
*/