/*
* Mesa 3-D graphics library)
* Version:2.2)
* Copyright (C) 1995-1997Brian Paul)
*
* This library is free software you can redistribute it and/or)
* modify it under the terms of the GNU Library General Public)
* License as published by the Free Software Foundation either)
* version 2 of the License, or (at your option) any later version.
*
* but WITHOUT ANY WARRANTY without even the implied warranty of)
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU)
* Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public)
* License along with this library if not, write to the Free)
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <GL/gl.h>

/* registers definitions for GCC */
#define D0(var) register var	__asm("d0")
#define D1(var) register var	__asm("d1")
#define D2(var) register var	__asm("d2")
#define D3(var) register var	__asm("d3")

#define D4(var) register var	__asm("d4")
#define D5(var) register var	__asm("d5")
#define D6(var) register var	__asm("d6")
#define D7(var) register var	__asm("d7")

#define A0(var) register var	__asm("a0")
#define A1(var) register var	__asm("a1")
#define A2(var) register var	__asm("a2")
#define A3(var) register var	__asm("a3")

#define A4(var) register var	__asm("a4")
#define A5(var) register var	__asm("a5")
#define A6(var) register var	__asm("a6")
#define A7(var) register var	__asm("a7")

#define FP0(var) register var	__asm("fp0")
#define FP1(var) register var	__asm("fp1")
#define FP2(var) register var	__asm("fp2")
#define FP3(var) register var	__asm("fp3")

#define FP4(var) register var	__asm("fp4")
#define FP5(var) register var	__asm("fp5")
#define FP6(var) register var	__asm("fp6")
#define FP7(var) register var	__asm("fp7")


void APIENTRY smglClearIndex(GLfloat a)
{ FP0(GLfloat c);
glClearIndex(c);
}

void APIENTRY smglClearColor(GLclampf a,GLclampf b,GLclampf c,GLclampf d)
{ FP0(GLclampf red); FP1(GLclampf green); FP2(GLclampf blue); FP3(GLclampf alpha);
glClearColor(red,green,blue,alpha);
}

void APIENTRY smglClear(GLbitfield a)
{ D0(GLbitfield mask);
glClear(mask);
}

void APIENTRY smglIndexMask(GLuint a)
{ D0(GLuint mask);
glIndexMask(mask);
}

void APIENTRY smglColorMask(GLboolean a,GLboolean b,GLboolean c,GLboolean d)
{ D0(GLboolean red); D1(GLboolean green); D2(GLboolean blue); D3(GLboolean alpha);
glColorMask(red,green,blue,alpha);
}

void APIENTRY smglAlphaFunc(GLenum a,GLclampf b)
{ D0(GLenum func); FP0(GLclampf ref);
glAlphaFunc(func,ref);
}

void APIENTRY smglBlendFunc(GLenum a,GLenum b)
{ D0(GLenum sfactor); D1(GLenum dfactor);
glBlendFunc(sfactor,dfactor);
}

void APIENTRY smglLogicOp(GLenum a)
{ D0(GLenum opcode);
glLogicOp(opcode);
}

void APIENTRY smglCullFace(GLenum a)
{ D0(GLenum mode);
glCullFace(mode);
}

void APIENTRY smglFrontFace(GLenum a)
{ D0(GLenum mode);
glFrontFace(mode);
}

void APIENTRY smglPointSize(GLfloat a)
{ FP0(GLfloat size);
glPointSize(size);
}

void APIENTRY smglLineWidth(GLfloat a)
{ FP0(GLfloat width);
glLineWidth(width);
}
void APIENTRY smglLineStipple(GLint a,GLushort b)
{ D0(GLint factor); D1(GLushort pattern);
glLineStipple(factor,pattern);
}

void APIENTRY smglPolygonMode(GLenum a,GLenum b)
{ D0(GLenum face); D1(GLenum mode);
glPolygonMode(face,mode);
}

void APIENTRY smglPolygonOffset(GLfloat a,GLfloat b)
{ FP0(GLfloat factor); FP1(GLfloat units);
glPolygonOffset(factor,units);
}

void APIENTRY smglPolygonStipple(const GLubyte* a)
{ A0(const GLubyte* mask);
glPolygonStipple(mask);
}

void APIENTRY smglGetPolygonStipple(GLubyte* a)
{ A0(GLubyte* mask);
glGetPolygonStipple(mask);
}

void APIENTRY smglEdgeFlag(GLboolean a)
{ D0(GLboolean flag);
glEdgeFlag(flag);
}

void APIENTRY smglEdgeFlagv(const GLboolean* a)
{ A0(const GLboolean* flag);
glEdgeFlagv(flag);
}

void APIENTRY smglScissor(GLint a,GLint b,GLsizei c,GLsizei d)
{ D0(GLint x); D1(GLint y); D2(GLsizei width); D3(GLsizei height);
glScissor(x,y,width,height);
}

void APIENTRY smglClipPlane(GLenum a,const GLdouble* b)
{ D0(GLenum plane); A0(const GLdouble* equation);
glClipPlane(plane,equation);
}

void APIENTRY smglGetClipPlane(GLenum a,GLdouble* b)
{ D0(GLenum plane); A0(GLdouble* equation);
glGetClipPlane(plane,equation);
}

void APIENTRY smglDrawBuffer(GLenum a)
{ D0(GLenum mode);
glDrawBuffer(mode);
}

void APIENTRY smglReadBuffer(GLenum a)
{ D0(GLenum mode);
glReadBuffer(mode);
}

void APIENTRY smglEnable(GLenum a)
{ D0(GLenum cap);
glEnable(cap);
}

void APIENTRY smglDisable(GLenum a)
{ D0(GLenum cap);
glDisable(cap);
}

GLboolean APIENTRY smglIsEnabled(GLenum a)
{ D0(GLenum cap);
return(glIsEnabled(cap));
}

void APIENTRY smglEnableClientState(GLenum a)
{ D0( GLenum cap);
glEnableClientState(cap);
}

void APIENTRY smglDisableClientState(GLenum a)
{ D0( GLenum cap);
glDisableClientState(cap);
}

void APIENTRY smglGetBooleanv(GLenum a,GLboolean* b)
{ D0(GLenum pname); A0(GLboolean* params);
glGetBooleanv(pname,params);
}

void APIENTRY smglGetDoublev(GLenum a,GLdouble* b)
{ D0(GLenum pname); A0(GLdouble* params);
glGetDoublev(pname,params);
}

void APIENTRY smglGetFloatv(GLenum a,GLfloat* b)
{ D0(GLenum pname); A0(GLfloat* params);
glGetFloatv(pname,params);
}

void APIENTRY smglGetIntegerv(GLenum a,GLint* b)
{ D0(GLenum pname); A0(GLint* params);
glGetIntegerv(pname,params);
}

void APIENTRY smglPushAttrib(GLbitfield a)
{ D0(GLbitfield mask);
glPushAttrib(mask);
}

void APIENTRY smglPopAttrib(void)
{
glPopAttrib();
}

void APIENTRY smglPushClientAttrib(GLbitfield a)
{ D0( GLbitfield mask);
glPushClientAttrib(mask);
}

void APIENTRY smglPopClientAttrib(void)
{
glPopClientAttrib();
}

GLint APIENTRY smglRenderMode(GLenum a)
{ D0(GLenum mode);
return(glRenderMode(mode));
}

GLenum APIENTRY smglGetError(void)
{
return(glGetError());
}

const GLubyte* APIENTRY smglGetString(GLenum a)
{ D0(GLenum name);
return(glGetString(name));
}

void APIENTRY smglFinish(void)
{
glFinish();
}

void APIENTRY smglFlush(void)
{
glFlush();
}

void APIENTRY smglHint(GLenum a,GLenum b)
{ D0(GLenum target); D1(GLenum mode);
glHint(target,mode);
}

void APIENTRY smglClearDepth(GLclampd a)
{ FP0(GLclampd depth);
glClearDepth(depth);
}

void APIENTRY smglDepthFunc(GLenum a)
{ D0(GLenum func);
glDepthFunc(func);
}

void APIENTRY smglDepthMask(GLboolean a)
{ D0(GLboolean flag);
glDepthMask(flag);
}

void APIENTRY smglDepthRange(GLclampd a,GLclampd b)
{ FP0(GLclampd near_val); FP1(GLclampd far_val);
glDepthRange(near_val,far_val);
}

void APIENTRY smglClearAccum(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat red); FP1(GLfloat green); FP2(GLfloat blue); FP3(GLfloat alpha);
glClearAccum(red,green,blue,alpha);
}

void APIENTRY smglAccum(GLenum a,GLfloat b)
{ D0(GLenum op); FP0(GLfloat value);
glAccum(op,value);
}

void APIENTRY smglMatrixMode(GLenum a)
{ D0(GLenum mode);
glMatrixMode(mode);
}

void APIENTRY smglOrtho(GLdouble a,GLdouble b,GLdouble c,GLdouble d,GLdouble e,GLdouble f)
{ FP0(GLdouble left); FP1(GLdouble right); FP2(GLdouble bottom); FP3(GLdouble top); FP4(GLdouble nearval); FP5(GLdouble farval);
glOrtho(left,right,bottom,top,nearval,farval);
}

void APIENTRY smglFrustum(GLdouble a,GLdouble b,GLdouble c,GLdouble d,GLdouble e,GLdouble f)
{ FP0(GLdouble left); FP1(GLdouble right); FP2(GLdouble bottom); FP3(GLdouble top); FP4(GLdouble nearval); FP5(GLdouble farval);
glFrustum(left,right,bottom,top,nearval,farval);
}

void APIENTRY smglViewport(GLint a,GLint b,GLsizei c,GLsizei d)
{ D0(GLint x); D1(GLint y); D2(GLsizei width); D3(GLsizei height);
glViewport(x,y,width,height);
}

void APIENTRY smglPushMatrix(void)
{
glPushMatrix();
}

void APIENTRY smglPopMatrix(void)
{
glPopMatrix();
}

void APIENTRY smglLoadIdentity(void)
{
glLoadIdentity();
}

void APIENTRY smglLoadMatrixd(const GLdouble* a)
{ A0(const GLdouble* m);
glLoadMatrixd(m);
}

void APIENTRY smglLoadMatrixf(const GLfloat* a)
{ A0(const GLfloat* m);
glLoadMatrixf(m);
}

void APIENTRY smglMultMatrixd(const GLdouble* a)
{ A0(const GLdouble* m);
glMultMatrixd(m);
}

void APIENTRY smglMultMatrixf(const GLfloat* a)
{ A0(const GLfloat* m);
glMultMatrixf(m);
}

void APIENTRY smglRotated(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble angle); FP1(GLdouble x); FP2(GLdouble y); FP3(GLdouble z);
glRotated(angle,x,y,z);
}

void APIENTRY smglRotatef(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat angle); FP1(GLfloat x); FP2(GLfloat y); FP3(GLfloat z);
glRotatef(angle,x,y,z);
}

void APIENTRY smglScaled(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z);
glScaled(x,y,z);
}

void APIENTRY smglScalef(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z);
glScalef(x,y,z);
}

void APIENTRY smglTranslated(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z);
glTranslated(x,y,z);
}

void APIENTRY smglTranslatef(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z);
glTranslatef(x,y,z);
}

GLboolean APIENTRY smglIsList(GLuint a)
{ D0(GLuint list);
return(glIsList(list));
}

void APIENTRY smglDeleteLists(GLuint a,GLsizei b)
{ D0(GLuint list); D1(GLsizei range);
glDeleteLists(list,range);
}

GLuint APIENTRY smglGenLists(GLsizei a)
{ D0(GLsizei range);
return(glGenLists(range));
}

void APIENTRY smglNewList(GLuint a,GLenum b)
{ D0(GLuint list); D1(GLenum mode);
glNewList(list,mode);
}

void APIENTRY smglEndList(void)
{
glEndList();
}

void APIENTRY smglCallList(GLuint a)
{ D0(GLuint list);
glCallList(list);
}

void APIENTRY smglCallLists(GLsizei a,GLenum b,const GLvoid* c)
{ D0(GLsizei n); D1(GLenum type); A0(const GLvoid* lists);
glCallLists(n,type,lists);
}

void APIENTRY smglListBase(GLuint a)
{ D0(GLuint base);
glListBase(base);
}

void APIENTRY smglBegin(GLenum a)
{ D0(GLenum mode);
glBegin(mode);
}

void APIENTRY smglEnd(void)
{
glEnd();
}

void APIENTRY smglVertex2d(GLdouble a,GLdouble b)
{ FP0(GLdouble x); FP1(GLdouble y);
glVertex2d(x,y);
}

void APIENTRY smglVertex2f(GLfloat a,GLfloat b)
{ FP0(GLfloat x); FP1(GLfloat y);
glVertex2f(x,y);
}

void APIENTRY smglVertex2i(GLint a,GLint b)
{ D0(GLint x); D1(GLint y);
glVertex2i(x,y);
}

void APIENTRY smglVertex2s(GLshort a,GLshort b)
{ D0(GLshort x); D1(GLshort y);
glVertex2s(x,y);
}

void APIENTRY smglVertex3d(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z);
glVertex3d(x,y,z);
}

void APIENTRY smglVertex3f(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z);
glVertex3f(x,y,z);
}

void APIENTRY smglVertex3i(GLint a,GLint b,GLint c)
{ D0(GLint x); D1(GLint y); D2(GLint z);
glVertex3i(x,y,z);
}

void APIENTRY smglVertex3s(GLshort a,GLshort b,GLshort c)
{ D0(GLshort x); D1(GLshort y); D2(GLshort z);
glVertex3s(x,y,z);
}

void APIENTRY smglVertex4d(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z); FP3(GLdouble w);
glVertex4d(x,y,z,w);
}

void APIENTRY smglVertex4f(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z); FP3(GLfloat w);
glVertex4f(x,y,z,w);
}

void APIENTRY smglVertex4i(GLint a,GLint b,GLint c,GLint d)
{ D0(GLint x); D1(GLint y); D2(GLint z); D3(GLint w);
glVertex4i(x,y,z,w);
}

void APIENTRY smglVertex4s(GLshort a,GLshort b,GLshort c,GLshort d)
{ D0(GLshort x); D1(GLshort y); D2(GLshort z); D3(GLshort w);
glVertex4s(x,y,z,w);
}

void APIENTRY smglVertex2dv(const GLdouble* a)
{ A0(const GLdouble* v);
glVertex2dv(v);
}

void APIENTRY smglVertex2fv(const GLfloat* a)
{ A0(const GLfloat* v);
glVertex2fv(v);
}

void APIENTRY smglVertex2iv(const GLint* a)
{ A0(const GLint* v);
glVertex2iv(v);
}

void APIENTRY smglVertex2sv(const GLshort* a)
{ A0(const GLshort* v);
glVertex2sv(v);
}

void APIENTRY smglVertex3dv(const GLdouble* a)
{ A0(const GLdouble* v);
glVertex3dv(v);
}

void APIENTRY smglVertex3fv(const GLfloat* a)
{ A0(const GLfloat* v);
glVertex3fv(v);
}

void APIENTRY smglVertex3iv(const GLint* a)
{ A0(const GLint* v);
glVertex3iv(v);
}

void APIENTRY smglVertex3sv(const GLshort* a)
{ A0(const GLshort* v);
glVertex3sv(v);
}

void APIENTRY smglVertex4dv(const GLdouble* a)
{ A0(const GLdouble* v);
glVertex4dv(v);
}

void APIENTRY smglVertex4fv(const GLfloat* a)
{ A0(const GLfloat* v);
glVertex4fv(v);
}

void APIENTRY smglVertex4iv(const GLint* a)
{ A0(const GLint* v);
glVertex4iv(v);
}

void APIENTRY smglVertex4sv(const GLshort* a)
{ A0(const GLshort* v);
glVertex4sv(v);
}

void APIENTRY smglNormal3b(GLbyte a,GLbyte b,GLbyte c)
{ D0(GLbyte nx); D1(GLbyte ny); D2(GLbyte nz);
glNormal3b(nx,ny,nz);
}

void APIENTRY smglNormal3d(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble nx); FP1(GLdouble ny); FP2(GLdouble nz);
glNormal3d(nx,ny,nz);
}

void APIENTRY smglNormal3f(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat nx); FP1(GLfloat ny); FP2(GLfloat nz);
glNormal3f(nx,ny,nz);
}

void APIENTRY smglNormal3i(GLint a,GLint b,GLint c)
{ D0(GLint nx); D1(GLint ny); D2(GLint nz);
glNormal3i(nx,ny,nz);
}

void APIENTRY smglNormal3s(GLshort a,GLshort b,GLshort c)
{ D0(GLshort nx); D1(GLshort ny); D2(GLshort nz);
glNormal3s(nx,ny,nz);
}

void APIENTRY smglNormal3bv(const GLbyte* a)
{ A0(const GLbyte* v);
glNormal3bv(v);
}

void APIENTRY smglNormal3dv(const GLdouble* a)
{ A0(const GLdouble* v);
glNormal3dv(v);
}

void APIENTRY smglNormal3fv(const GLfloat* a)
{ A0(const GLfloat* v);
glNormal3fv(v);
}

void APIENTRY smglNormal3iv(const GLint* a)
{ A0(const GLint* v);
glNormal3iv(v);
}

void APIENTRY smglNormal3sv(const GLshort* a)
{ A0(const GLshort* v);
glNormal3sv(v);
}

void APIENTRY smglIndexd(GLdouble a)
{ FP0(GLdouble c);
glIndexd(c);
}

void APIENTRY smglIndexf(GLfloat a)
{ FP0(GLfloat c);
glIndexf(c);
}

void APIENTRY smglIndexi(GLint a)
{ D0(GLint c);
glIndexi(c);
}

void APIENTRY smglIndexs(GLshort a)
{ D0(GLshort c);
glIndexs(c);
}

void APIENTRY smglIndexub(GLubyte a)
{ D0(GLshort c);
glIndexub(c);
}

void APIENTRY smglIndexdv(const GLdouble* a)
{ A0(const GLdouble* c);
glIndexdv(c);
}

void APIENTRY smglIndexfv(const GLfloat* a)
{ A0(const GLfloat* c);
glIndexfv(c);
}

void APIENTRY smglIndexiv(const GLint* a)
{ A0(const GLint* c);
glIndexiv(c);
}

void APIENTRY smglIndexsv(const GLshort* a)
{ A0(const GLshort* c);
glIndexsv(c);
}

void APIENTRY smglIndexubv(GLubyte *a)
{ A0(const GLubyte* c);
glIndexubv(c);
}

void APIENTRY smglColor3b(GLbyte a,GLbyte b,GLbyte c)
{ D0(GLbyte red); D1(GLbyte green); D2(GLbyte blue);
glColor3b(red,green,blue);
}

void APIENTRY smglColor3d(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble red); FP1(GLdouble green); FP2(GLdouble blue);
glColor3d(red,green,blue);
}

void APIENTRY smglColor3f(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat red); FP1(GLfloat green); FP2(GLfloat blue);
glColor3f(red,green,blue);
}

void APIENTRY smglColor3i(GLint a,GLint b,GLint c)
{ D0(GLint red); D1(GLint green); D2(GLint blue);
glColor3i(red,green,blue);
}

void APIENTRY smglColor3s(GLshort a,GLshort b,GLshort c)
{ D0(GLshort red); D1(GLshort green); D2(GLshort blue);
glColor3s(red,green,blue);
}

void APIENTRY smglColor3ub(GLubyte a,GLubyte b,GLubyte c)
{ D0(GLubyte red); D1(GLubyte green); D2(GLubyte blue);
glColor3ub(red,green,blue);
}

void APIENTRY smglColor3ui(GLuint a,GLuint b,GLuint c)
{ D0(GLuint red); D1(GLuint green); D2(GLuint blue);
glColor3ui(red,green,blue);
}

void APIENTRY smglColor3us(GLushort a,GLushort b,GLushort c)
{ D0(GLushort red); D1(GLushort green); D2(GLushort blue);
glColor3us(red,green,blue);
}

void APIENTRY smglColor4b(GLbyte a,GLbyte b,GLbyte c,GLbyte d)
{ D0(GLbyte red); D1(GLbyte green); D2(GLbyte blue); D3(GLbyte alpha);
glColor4b(red,green,blue,alpha);
}

void APIENTRY smglColor4d(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble red); FP1(GLdouble green); FP2(GLdouble blue); FP3(GLdouble alpha);
glColor4d(red,green,blue,alpha);
}

void APIENTRY smglColor4f(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat red); FP1(GLfloat green); FP2(GLfloat blue); FP3(GLfloat alpha);
glColor4f(red,green,blue,alpha);
}

void APIENTRY smglColor4i(GLint a,GLint b,GLint c,GLint d)
{ D0(GLint red); D1(GLint green); D2(GLint blue); D3(GLint alpha);
glColor4i(red,green,blue,alpha);
}

void APIENTRY smglColor4s(GLshort a,GLshort b,GLshort c,GLshort d)
{ D0(GLshort red); D1(GLshort green); D2(GLshort blue); D3(GLshort alpha);
glColor4s(red,green,blue,alpha);
}

void APIENTRY smglColor4ub(GLubyte a,GLubyte b,GLubyte c,GLubyte d)
{ D0(GLubyte red); D1(GLubyte green); D2(GLubyte blue); D3(GLubyte alpha);
glColor4ub(red,green,blue,alpha);
}

void APIENTRY smglColor4ui(GLuint a,GLuint b,GLuint c,GLuint d)
{ D0(GLuint red); D1(GLuint green); D2(GLuint blue); D3(GLuint alpha);
glColor4ui(red,green,blue,alpha);
}

void APIENTRY smglColor4us(GLushort a,GLushort b,GLushort c,GLushort d)
{ D0(GLushort red); D1(GLushort green); D2(GLushort blue); D3(GLushort alpha);
glColor4us(red,green,blue,alpha);
}

void APIENTRY smglColor3bv(const GLbyte* a)
{ A0(const GLbyte* v);
glColor3bv(v);
}

void APIENTRY smglColor3dv(const GLdouble* a)
{ A0(const GLdouble* v);
glColor3dv(v);
}

void APIENTRY smglColor3fv(const GLfloat* a)
{ A0(const GLfloat* v);
glColor3fv(v);
}

void APIENTRY smglColor3iv(const GLint* a)
{ A0(const GLint* v);
glColor3iv(v);
}

void APIENTRY smglColor3sv(const GLshort* a)
{ A0(const GLshort* v);
glColor3sv(v);
}

void APIENTRY smglColor3ubv(const GLubyte* a)
{ A0(const GLubyte* v);
glColor3ubv(v);
}

void APIENTRY smglColor3uiv(const GLuint* a)
{ A0(const GLuint* v);
glColor3uiv(v);
}

void APIENTRY smglColor3usv(const GLushort* a)
{ A0(const GLushort* v);
glColor3usv(v);
}

void APIENTRY smglColor4bv(const GLbyte* a)
{ A0(const GLbyte* v);
glColor4bv(v);
}

void APIENTRY smglColor4dv(const GLdouble* a)
{ A0(const GLdouble* v);
glColor4dv(v);
}

void APIENTRY smglColor4fv(const GLfloat* a)
{ A0(const GLfloat* v);
glColor4fv(v);
}

void APIENTRY smglColor4iv(const GLint* a)
{ A0(const GLint* v);
glColor4iv(v);
}

void APIENTRY smglColor4sv(const GLshort* a)
{ A0(const GLshort* v);
glColor4sv(v);
}

void APIENTRY smglColor4ubv(const GLubyte* a)
{ A0(const GLubyte* v);
glColor4ubv(v);
}

void APIENTRY smglColor4uiv(const GLuint* a)
{ A0(const GLuint* v);
glColor4uiv(v);
}

void APIENTRY smglColor4usv(const GLushort* a)
{ A0(const GLushort* v);
glColor4usv(v);
}

void APIENTRY smglTexCoord1d(GLdouble a)
{ FP0(GLdouble s);
glTexCoord1d(s);
}

void APIENTRY smglTexCoord1f(GLfloat a)
{ FP0(GLfloat s);
glTexCoord1f(s);
}

void APIENTRY smglTexCoord1i(GLint a)
{ D0(GLint s);
glTexCoord1i(s);
}

void APIENTRY smglTexCoord1s(GLshort a)
{ D0(GLshort s);
glTexCoord1s(s);
}

void APIENTRY smglTexCoord2d(GLdouble a,GLdouble b)
{ FP0(GLdouble s); FP1(GLdouble t);
glTexCoord2d(s,t);
}

void APIENTRY smglTexCoord2f(GLfloat a,GLfloat b)
{ FP0(GLfloat s); FP1(GLfloat t);
glTexCoord2f(s,t);
}

void APIENTRY smglTexCoord2i(GLint a,GLint b)
{ D0(GLint s); D1(GLint t);
glTexCoord2i(s,t);
}

void APIENTRY smglTexCoord2s(GLshort a,GLshort b)
{ D0(GLshort s); D1(GLshort t);
glTexCoord2s(s,t);
}

void APIENTRY smglTexCoord3d(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble s); FP1(GLdouble t); FP2(GLdouble r);
glTexCoord3d(s,t,r);
}

void APIENTRY smglTexCoord3f(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat s); FP1(GLfloat t); FP2(GLfloat r);
glTexCoord3f(s,t,r);
}

void APIENTRY smglTexCoord3i(GLint a,GLint b,GLint c)
{ D0(GLint s); D1(GLint t); D2(GLint r);
glTexCoord3i(s,t,r);
}
void APIENTRY smglTexCoord3s(GLshort a,GLshort b,GLshort c)
{ D0(GLshort s); D1(GLshort t); D2(GLshort r);
glTexCoord3s(s,t,r);
}

void APIENTRY smglTexCoord4d(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble s); FP1(GLdouble t); FP2(GLdouble r); FP3(GLdouble q);
glTexCoord4d(s,t,r,q);
}

void APIENTRY smglTexCoord4f(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat s); FP1(GLfloat t); FP2(GLfloat r); FP3(GLfloat q);
glTexCoord4f(s,t,r,q);
}

void APIENTRY smglTexCoord4i(GLint a,GLint b,GLint c,GLint d)
{ D0(GLint s); D1(GLint t); D2(GLint r); D3(GLint q);
glTexCoord4i(s,t,r,q);
}

void APIENTRY smglTexCoord4s(GLshort a,GLshort b,GLshort c,GLshort d)
{ D0(GLshort s); D1(GLshort t); D2(GLshort r); D3(GLshort q);
glTexCoord4s(s,t,r,q);
}

void APIENTRY smglTexCoord1dv(const GLdouble* a)
{ A0(const GLdouble* v);
glTexCoord1dv(v);
}

void APIENTRY smglTexCoord1fv(const GLfloat* a)
{ A0(const GLfloat* v);
glTexCoord1fv(v);
}

void APIENTRY smglTexCoord1iv(const GLint* a)
{ A0(const GLint* v);
glTexCoord1iv(v);
}

void APIENTRY smglTexCoord1sv(const GLshort* a)
{ A0(const GLshort* v);
glTexCoord1sv(v);
}

void APIENTRY smglTexCoord2dv(const GLdouble* a)
{ A0(const GLdouble* v);
glTexCoord2dv(v);
}

void APIENTRY smglTexCoord2fv(const GLfloat* a)
{ A0(const GLfloat* v);
glTexCoord2fv(v);
}

void APIENTRY smglTexCoord2iv(const GLint* a)
{ A0(const GLint* v);
glTexCoord2iv(v);
}

void APIENTRY smglTexCoord2sv(const GLshort* a)
{ A0(const GLshort* v);
glTexCoord2sv(v);
}

void APIENTRY smglTexCoord3dv(const GLdouble* a)
{ A0(const GLdouble* v);
glTexCoord3dv(v);
}

void APIENTRY smglTexCoord3fv(const GLfloat* a)
{ A0(const GLfloat* v);
glTexCoord3fv(v);
}

void APIENTRY smglTexCoord3iv(const GLint* a)
{ A0(const GLint* v);
glTexCoord3iv(v);
}

void APIENTRY smglTexCoord3sv(const GLshort* a)
{ A0(const GLshort* v);
glTexCoord3sv(v);
}

void APIENTRY smglTexCoord4dv(const GLdouble* a)
{ A0(const GLdouble* v);
glTexCoord4dv(v);
}

void APIENTRY smglTexCoord4fv(const GLfloat* a)
{ A0(const GLfloat* v);
glTexCoord4fv(v);
}

void APIENTRY smglTexCoord4iv(const GLint* a)
{ A0(const GLint* v);
glTexCoord4iv(v);
}

void APIENTRY smglTexCoord4sv(const GLshort* a)
{ A0(const GLshort* v);
glTexCoord4sv(v);
}

void APIENTRY smglRasterPos2d(GLdouble a,GLdouble b)
{ FP0(GLdouble x); FP1(GLdouble y);
glRasterPos2d(x,y);
}

void APIENTRY smglRasterPos2f(GLfloat a,GLfloat b)
{ FP0(GLfloat x); FP1(GLfloat y);
glRasterPos2f(x,y);
}

void APIENTRY smglRasterPos2i(GLint a,GLint b)
{ D0(GLint x); D1(GLint y);
glRasterPos2i(x,y);
}

void APIENTRY smglRasterPos2s(GLshort a,GLshort b)
{ D0(GLshort x); D1(GLshort y);
glRasterPos2s(x,y);
}

void APIENTRY smglRasterPos3d(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z);
glRasterPos3d(x,y,z);
}

void APIENTRY smglRasterPos3f(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z);
glRasterPos3f(x,y,z);
}

void APIENTRY smglRasterPos3i(GLint a,GLint b,GLint c)
{ D0(GLint x); D1(GLint y); D2(GLint z);
glRasterPos3i(x,y,z);
}

void APIENTRY smglRasterPos3s(GLshort a,GLshort b,GLshort c)
{ D0(GLshort x); D1(GLshort y); D2(GLshort z);
glRasterPos3s(x,y,z);
}

void APIENTRY smglRasterPos4d(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z); FP3(GLdouble w);
glRasterPos4d(x,y,z,w);
}

void APIENTRY smglRasterPos4f(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z); FP3(GLfloat w);
glRasterPos4f(x,y,z,w);
}

void APIENTRY smglRasterPos4i(GLint a,GLint b,GLint c,GLint d)
{ D0(GLint x); D1(GLint y); D2(GLint z); D3(GLint w);
glRasterPos4i(x,y,z,w);
}

void APIENTRY smglRasterPos4s(GLshort a,GLshort b,GLshort c,GLshort d)
{ D0(GLshort x); D1(GLshort y); D2(GLshort z); D3(GLshort w);
glRasterPos4s(x,y,z,w);
}

void APIENTRY smglRasterPos2dv(const GLdouble* a)
{ A0(const GLdouble* v);
glRasterPos2dv(v);
}

void APIENTRY smglRasterPos2fv(const GLfloat* a)
{ A0(const GLfloat* v);
glRasterPos2fv(v);
}

void APIENTRY smglRasterPos2iv(const GLint* a)
{ A0(const GLint* v);
glRasterPos2iv(v);
}

void APIENTRY smglRasterPos2sv(const GLshort* a)
{ A0(const GLshort* v);
glRasterPos2sv(v);
}

void APIENTRY smglRasterPos3dv(const GLdouble* a)
{ A0(const GLdouble* v);
glRasterPos3dv(v);
}

void APIENTRY smglRasterPos3fv(const GLfloat* a)
{ A0(const GLfloat* v);
glRasterPos3fv(v);
}

void APIENTRY smglRasterPos3iv(const GLint* a)
{ A0(const GLint* v);
glRasterPos3iv(v);
}

void APIENTRY smglRasterPos3sv(const GLshort* a)
{ A0(const GLshort* v);
glRasterPos3sv(v);
}

void APIENTRY smglRasterPos4dv(const GLdouble* a)
{ A0(const GLdouble* v);
glRasterPos4dv(v);
}

void APIENTRY smglRasterPos4fv(const GLfloat* a)
{ A0(const GLfloat* v);
glRasterPos4fv(v);
}

void APIENTRY smglRasterPos4iv(const GLint* a)
{ A0(const GLint* v);
glRasterPos4iv(v);
}

void APIENTRY smglRasterPos4sv(const GLshort* a)
{ A0(const GLshort* v);
glRasterPos4sv(v);
}

void APIENTRY smglRectd(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble x1); FP1(GLdouble y1); FP2(GLdouble x2); FP3(GLdouble y2);
glRectd(x1,y1,x2,y2);
}

void APIENTRY smglRectf(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat x1); FP1(GLfloat y1); FP2(GLfloat x2); FP3(GLfloat y2);
glRectf(x1,y1,x2,y2);
}

void APIENTRY smglRecti(GLint a,GLint b,GLint c,GLint d)
{ D0(GLint x1); D1(GLint y1); D2(GLint x2); D3(GLint y2);
glRecti(x1,y1,x2,y2);
}

void APIENTRY smglRects(GLshort a,GLshort b,GLshort c,GLshort d)
{ D0(GLshort x1); D1(GLshort y1); D2(GLshort x2); D3(GLshort y2);
glRects(x1,y1,x2,y2);
}

void APIENTRY smglRectdv(const GLdouble* a,const GLdouble* b)
{ A0(const GLdouble* v1); A1(const GLdouble* v2);
glRectdv(v1,v2);
}

void APIENTRY smglRectfv(const GLfloat* a,const GLfloat* b)
{ A0(const GLfloat* v1); A1(const GLfloat* v2);
glRectfv(v1,v2);
}

void APIENTRY smglRectiv(const GLint* a,const GLint* b)
{ A0(const GLint* v1); A1(const GLint* v2);
glRectiv(v1,v2);
}

void APIENTRY smglRectsv(const GLshort* a,const GLshort* b)
{ A0(const GLshort* v1); A1(const GLshort* v2);
glRectsv(v1,v2);
}

void APIENTRY smglVertexPointer(GLint a,GLenum b,GLsizei c,const GLvoid* d)
{ D0(GLint size); D1(GLenum type); D2(GLsizei stride); A0(const GLvoid* ptr);
glVertexPointer(size,type,stride,ptr);
}

void APIENTRY smglNormalPointer(GLenum a,GLsizei b,const GLvoid* c)
{ D0(GLenum type); D1(GLsizei stride); A0(const GLvoid* ptr);
glNormalPointer(type,stride,ptr);
}

void APIENTRY smglColorPointer(GLint a,GLenum b,GLsizei c,const GLvoid* d)
{ D0(GLint size); D1(GLenum type); D2(GLsizei stride); A0(const GLvoid* ptr);
glColorPointer(size,type,stride,ptr);
}

void APIENTRY smglIndexPointer(GLenum a,GLsizei b,const GLvoid* c)
{ D0(GLenum type); D1(GLsizei stride); A0(const GLvoid* ptr);
glIndexPointer(type,stride,ptr);
}

void APIENTRY smglTexCoordPointer(GLint a,GLenum b,GLsizei c,const GLvoid* d)
{ D0(GLint size); D1(GLenum type); D2(GLsizei stride); A0(const GLvoid* ptr);
glTexCoordPointer(size,type,stride,ptr);
}

void APIENTRY smglEdgeFlagPointer(GLsizei a,const GLboolean* b)
{ D0(GLsizei stride); A0(const GLboolean* ptr);
glEdgeFlagPointer(stride,ptr);
}

void APIENTRY smglGetPointerv(GLenum a,GLvoid* b)
{ D0(GLenum pname); A0(GLvoid* *params);
glGetPointerv(pname,params);
}

void APIENTRY smglArrayElement(GLint a)
{ D0(GLint i);
glArrayElement(i);
}

void APIENTRY smglDrawArrays(GLenum a,GLint b,GLsizei c)
{ D0(GLenum mode); D1(GLint first); D2(GLsizei count);
glDrawArrays(mode,first,count);
}

void APIENTRY smglDrawElements(GLenum a,GLsizei b,GLenum c,const GLvoid* d)
{ D0(GLenum mode); D1(GLsizei count); D2(GLenum type); A0(const GLvoid* indices);
glDrawElements(mode,count,type,indices);
}

void APIENTRY smglInterleavedArrays(GLenum a,GLsizei b,const GLvoid* c)
{ D0(GLenum format); D1(GLsizei stride); A0(const GLvoid* pointer);
glInterleavedArrays(format,stride,pointer);
}

void APIENTRY smglShadeModel(GLenum a)
{ D0(GLenum mode);
glShadeModel(mode);
}

void APIENTRY smglLightf(GLenum a,GLenum b,GLfloat c)
{ D0(GLenum light); D1(GLenum pname); FP0(GLfloat param);
glLightf(light,pname,param);
}

void APIENTRY smglLighti(GLenum a,GLenum b,GLint c)
{ D0(GLenum light); D1(GLenum pname); D2(GLint param);
glLighti(light,pname,param);
}

void APIENTRY smglLightfv(GLenum a,GLenum b,const GLfloat* c)
{ D0(GLenum light); D1(GLenum pname); A0(const GLfloat* params);
glLightfv(light,pname,params);
}

void APIENTRY smglLightiv(GLenum a,GLenum b,const GLint* c)
{ D0(GLenum light); D1(GLenum pname); A0(const GLint* params);
glLightiv(light,pname,params);
}

void APIENTRY smglGetLightfv(GLenum a,GLenum b,GLfloat* c)
{ D0(GLenum light); D1(GLenum pname); A0(GLfloat* params);
glGetLightfv(light,pname,params);
}

void APIENTRY smglGetLightiv(GLenum a,GLenum b,GLint* c)
{ D0(GLenum light); D1(GLenum pname); A0(GLint* params);
glGetLightiv(light,pname,params);
}

void APIENTRY smglLightModelf(GLenum a,GLfloat b)
{ D0(GLenum pname); FP0(GLfloat param);
glLightModelf(pname,param);
}

void APIENTRY smglLightModeli(GLenum a,GLint b)
{ D0(GLenum pname); D1(GLint param);
glLightModeli(pname,param);
}

void APIENTRY smglLightModelfv(GLenum a,const GLfloat* b)
{ D0(GLenum pname); A0(const GLfloat* params);
glLightModelfv(pname,params);
}

void APIENTRY smglLightModeliv(GLenum a,const GLint* b)
{ D0(GLenum pname); A0(const GLint* params);
glLightModeliv(pname,params);
}

void APIENTRY smglMaterialf(GLenum a,GLenum b,GLfloat c)
{ D0(GLenum face); D1(GLenum pname); FP0(GLfloat param);
glMaterialf(face,pname,param);
}

void APIENTRY smglMateriali(GLenum a,GLenum b,GLint c)
{ D0(GLenum face); D1(GLenum pname); D2(GLint param);
glMateriali(face,pname,param);
}

void APIENTRY smglMaterialfv(GLenum a,GLenum b,const GLfloat* c)
{ D0(GLenum face); D1(GLenum pname); A0(const GLfloat* params);
glMaterialfv(face,pname,params);
}

void APIENTRY smglMaterialiv(GLenum a,GLenum b,const GLint* c)
{ D0(GLenum face); D1(GLenum pname); A0(const GLint* params);
glMaterialiv(face,pname,params);
}

void APIENTRY smglGetMaterialfv(GLenum a,GLenum b,GLfloat* c)
{ D0(GLenum face); D1(GLenum pname); A0(GLfloat* params);
glGetMaterialfv(face,pname,params);
}

void APIENTRY smglGetMaterialiv(GLenum a,GLenum b,GLint* c)
{ D0(GLenum face); D1(GLenum pname); A0(GLint* params);
glGetMaterialiv(face,pname,params);
}

void APIENTRY smglColorMaterial(GLenum a,GLenum b)
{ D0(GLenum face); D1(GLenum mode);
glColorMaterial(face,mode);
}

void APIENTRY smglPixelZoom(GLfloat a,GLfloat b)
{ FP0(GLfloat xfactor); FP1(GLfloat yfactor);
glPixelZoom(xfactor,yfactor);
}

void APIENTRY smglPixelStoref(GLenum a,GLfloat b)
{ D0(GLenum pname); FP0(GLfloat param);
glPixelStoref(pname,param);
}

void APIENTRY smglPixelStorei(GLenum a,GLint b)
{ D0(GLenum pname); D1(GLint param);
glPixelStorei(pname,param);
}

void APIENTRY smglPixelTransferf(GLenum a,GLfloat b)
{ D0(GLenum pname); FP0(GLfloat param);
glPixelTransferf(pname,param);
}

void APIENTRY smglPixelTransferi(GLenum a,GLint b)
{ D0(GLenum pname); D1(GLint param);
glPixelTransferi(pname,param);
}

void APIENTRY smglPixelMapfv(GLenum a,GLint b,const GLfloat* c)
{ D0(GLenum map); D1(GLint mapsize); A0(const GLfloat* values);
glPixelMapfv(map,mapsize,values);
}

void APIENTRY smglPixelMapuiv(GLenum a,GLint b,const GLuint* c)
{ D0(GLenum map); D1(GLint mapsize); A0(const GLuint* values);
glPixelMapuiv(map,mapsize,values);
}

void APIENTRY smglPixelMapusv(GLenum a,GLint b,const GLushort* c)
{ D0(GLenum map); D1(GLint mapsize); A0(const GLushort* values);
glPixelMapusv(map,mapsize,values);
}

void APIENTRY smglGetPixelMapfv(GLenum a,GLfloat* b)
{ D0(GLenum map); A0(GLfloat* values);
glGetPixelMapfv(map,values);
}

void APIENTRY smglGetPixelMapuiv(GLenum a,GLuint* b)
{ D0(GLenum map); A0(GLuint* values);
glGetPixelMapuiv(map,values);
}

void APIENTRY smglGetPixelMapusv(GLenum a,GLushort* b)
{ D0(GLenum map); A0(GLushort* values);
glGetPixelMapusv(map,values);
}

void APIENTRY smglBitmap(GLsizei a,GLsizei b,GLfloat c,GLfloat d,GLfloat e,GLfloat f,const GLubyte* g)
{ D0(GLsizei width); D1(GLsizei height); FP0(GLfloat xorig); FP1(GLfloat yorig); FP2(GLfloat xmove); FP3(GLfloat ymove); A0(const GLubyte* bitmap);
glBitmap(width,height,xorig,yorig,xmove,ymove,bitmap);
}

void APIENTRY smglReadPixels(GLint a,GLint b,GLsizei c,GLsizei d,GLenum e,GLenum f,GLvoid* g)
{ D0(GLint x); D1(GLint y); D2(GLsizei width); D3(GLsizei height); D4(GLenum format); D5(GLenum type); A0(GLvoid* pixels);
glReadPixels(x,y,width,height,format,type,pixels);
}

void APIENTRY smglDrawPixels(GLsizei a,GLsizei b,GLenum c,GLenum d,const GLvoid* e)
{ D0(GLsizei width); D1(GLsizei height); D2(GLenum format); D3(GLenum type); A0(const GLvoid* pixels);
glDrawPixels(width,height,format,type,pixels);
}

void APIENTRY smglCopyPixels(GLint a,GLint b,GLsizei c,GLsizei d,GLenum e)
{ D0(GLint x); D1(GLint y); D2(GLsizei width); D3(GLsizei height); D4(GLenum type);
glCopyPixels(x,y,width,height,type);
}

void APIENTRY smglStencilFunc(GLenum a,GLint b,GLuint c)
{ D0(GLenum func); D1(GLint ref); D2(GLuint mask);
glStencilFunc(func,ref,mask);
}

void APIENTRY smglStencilMask(GLuint a)
{ D0(GLuint mask);
glStencilMask(mask);
}

void APIENTRY smglStencilOp(GLenum a,GLenum b,GLenum c)
{ D0(GLenum fail); D1(GLenum zfail); D2(GLenum zpass);
glStencilOp(fail,zfail,zpass);
}

void APIENTRY smglClearStencil(GLint a)
{ D0(GLint s);
glClearStencil(s);
}

void APIENTRY smglTexGend(GLenum a,GLenum b,GLdouble c)
{ D0(GLenum coord); D1(GLenum pname); FP0(GLdouble param);
glTexGend(coord,pname,param);
}

void APIENTRY smglTexGenf(GLenum a,GLenum b,GLfloat c)
{ D0(GLenum coord); D1(GLenum pname); FP0(GLfloat param);
glTexGenf(coord,pname,param);
}

void APIENTRY smglTexGeni(GLenum a,GLenum b,GLint c)
{ D0(GLenum coord); D1(GLenum pname); D2(GLint param);
glTexGeni(coord,pname,param);
}

void APIENTRY smglTexGendv(GLenum a,GLenum b,const GLdouble* c)
{ D0(GLenum coord); D1(GLenum pname); A0(const GLdouble* params);
glTexGendv(coord,pname,params);
}

void APIENTRY smglTexGenfv(GLenum a,GLenum b,const GLfloat* c)
{ D0(GLenum coord); D1(GLenum pname); A0(const GLfloat* params);
glTexGenfv(coord,pname,params);
}

void APIENTRY smglTexGeniv(GLenum a,GLenum b,const GLint* c)
{ D0(GLenum coord); D1(GLenum pname); A0(const GLint* params);
glTexGeniv(coord,pname,params);
}

void APIENTRY smglGetTexGendv(GLenum a,GLenum b,GLdouble* c)
{ D0(GLenum coord); D1(GLenum pname); A0(GLdouble* params);
glGetTexGendv(coord,pname,params);
}

void APIENTRY smglGetTexGenfv(GLenum a,GLenum b,GLfloat* c)
{ D0(GLenum coord); D1(GLenum pname); A0(GLfloat* params);
glGetTexGenfv(coord,pname,params);
}

void APIENTRY smglGetTexGeniv(GLenum a,GLenum b,GLint* c)
{ D0(GLenum coord); D1(GLenum pname); A0(GLint* params);
glGetTexGeniv(coord,pname,params);
}

void APIENTRY smglTexEnvf(GLenum a,GLenum b,GLfloat c)
{ D0(GLenum target); D1(GLenum pname); FP0(GLfloat param);
glTexEnvf(target,pname,param);
}

void APIENTRY smglTexEnvi(GLenum a,GLenum b,GLint c)
{ D0(GLenum target); D1(GLenum pname); D2(GLint param);
glTexEnvi(target,pname,param);
}

void APIENTRY smglTexEnvfv(GLenum a,GLenum b,const GLfloat* c)
{ D0(GLenum target); D1(GLenum pname); A0(const GLfloat* params);
glTexEnvfv(target,pname,params);
}

void APIENTRY smglTexEnviv(GLenum a,GLenum b,const GLint* c)
{ D0(GLenum target); D1(GLenum pname); A0(const GLint* params);
glTexEnviv(target,pname,params);
}

void APIENTRY smglGetTexEnvfv(GLenum a,GLenum b,GLfloat* c)
{ D0(GLenum target); D1(GLenum pname); A0(GLfloat* params);
glGetTexEnvfv(target,pname,params);
}

void APIENTRY smglGetTexEnviv(GLenum a,GLenum b,GLint* c)
{ D0(GLenum target); D1(GLenum pname); A0(GLint* params);
glGetTexEnviv(target,pname,params);
}

void APIENTRY smglTexParameterf(GLenum a,GLenum b,GLfloat c)
{ D0(GLenum target); D1(GLenum pname); FP0(GLfloat param);
glTexParameterf(target,pname,param);
}

void APIENTRY smglTexParameteri(GLenum a,GLenum b,GLint c)
{ D0(GLenum target); D1(GLenum pname); D2(GLint param);
glTexParameteri(target,pname,param);
}

void APIENTRY smglTexParameterfv(GLenum a,GLenum b,const GLfloat* c)
{ D0(GLenum target); D1(GLenum pname); A0(const GLfloat* params);
glTexParameterfv(target,pname,params);
}

void APIENTRY smglTexParameteriv(GLenum a,GLenum b,const GLint* c)
{ D0(GLenum target); D1(GLenum pname); A0(const GLint* params);
glTexParameteriv(target,pname,params);
}

void APIENTRY smglGetTexParameterfv(GLenum a,GLenum b,GLfloat* c)
{ D0(GLenum target); D1(GLenum pname); A0(GLfloat* params);
glGetTexParameterfv(target,pname,params);
}

void APIENTRY smglGetTexParameteriv(GLenum a,GLenum b,GLint* c)
{ D0(GLenum target); D1(GLenum pname); A0(GLint* params);
glGetTexParameteriv(target,pname,params);
}

void APIENTRY smglGetTexLevelParameterfv(GLenum a,GLint b,GLenum c,GLfloat* d)
{ D0(GLenum target); D1(GLint level); D2(GLenum pname); A0(GLfloat* params);
glGetTexLevelParameterfv(target,level,pname,params);
}

void APIENTRY smglGetTexLevelParameteriv(GLenum a,GLint b,GLenum c,GLint* d)
{ D0(GLenum target); D1(GLint level); D2(GLenum pname); A0(GLint* params);
glGetTexLevelParameteriv(target,level,pname,params);
}

void APIENTRY smglTexImage1D(GLenum a,GLint b,GLint c,GLsizei d,GLint e,GLenum f,GLenum g,const GLvoid* h)
{ D0(GLenum target); D1(GLint level); D2(GLint components); D3(GLsizei width); D4(GLint border); D5(GLenum format); D6(GLenum type); A0(const GLvoid* pixels);
glTexImage1D(target,level,components,width,border,format,type,pixels);
}

void APIENTRY smglTexImage2D(GLenum a,GLint b,GLint c,GLsizei d,GLsizei e,GLint f,GLenum g,GLenum h,const GLvoid* i)
{ D0(GLenum target); D1(GLint level); D2(GLint components); D3(GLsizei width); D4(GLsizei height); D5(GLint border); D6(GLenum format); D7(GLenum type); A0(const GLvoid *pixels);
glTexImage2D(target,level,components,width,height,border,format,type,pixels);
}

void APIENTRY smglGetTexImage(GLenum a,GLint b,GLenum c,GLenum d,GLvoid* e)
{ D0(GLenum target); D1(GLint level); D2(GLenum format); D3(GLenum type); A0(GLvoid* pixels);
glGetTexImage(target,level,format,type,pixels);
}

void APIENTRY smglGenTextures(GLsizei a,GLuint* b)
{ D0(GLsizei n); A0(GLuint* textures);
glGenTextures(n,textures);
}

void APIENTRY smglDeleteTextures(GLsizei a,const GLuint* b)
{ D0(GLsizei n); A0(const GLuint* textures);
glDeleteTextures(n,textures);
}

void APIENTRY smglBindTexture(GLenum a,GLuint b)
{ D0(GLenum target); D1(GLuint texture);
glBindTexture(target,texture);
}

void APIENTRY smglPrioritizeTextures(GLsizei a,const GLuint* b,const GLclampf* c)
{ D0(GLsizei n); A0(const GLuint* textures); A1(const GLclampf* priorities);
glPrioritizeTextures(n,textures,priorities);
}

GLboolean APIENTRY smglAreTexturesResident(GLsizei a,const GLuint* b,GLboolean* c)
{ D0(GLsizei n); A0(const GLuint* textures); A1(GLboolean* residences);
return(glAreTexturesResident(n,textures,residences));
}

GLboolean APIENTRY smglIsTexture(GLuint a)
{ D0(GLuint texture);
return(glIsTexture(texture));
}

void APIENTRY smglTexSubImage1D(GLenum a,GLint b,GLint c,GLsizei d,GLenum e,GLenum f,const GLvoid* g)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLsizei width); D4(GLenum format); D5(GLenum type); A0(const GLvoid* pixels);
glTexSubImage1D(target,level,xoffset,width,format,type,pixels);
}

void APIENTRY smglTexSubImage2D(GLenum a,GLint b,GLint c,GLint d,GLsizei e,GLsizei f,GLenum g,GLenum h,const GLvoid* i)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint yoffset); D4(GLsizei width); D5(GLsizei height); D6(GLenum format); D7(GLenum type); A0(GLvoid *pixels);
glTexSubImage2D(target,level,xoffset,yoffset,width,height,format,type,pixels);
}

void APIENTRY smglCopyTexImage1D(GLenum a,GLint b,GLenum c,GLint d,GLint e,GLsizei f,GLint g)
{ D0(GLenum target); D1(GLint level); D2(GLenum internalformat); D3(GLint x); D4(GLint y); D5(GLsizei width); D6(GLint border);
glCopyTexImage1D(target,level,internalformat,x,y,width,border);
}

void APIENTRY smglCopyTexImage2D(GLenum a,GLint b,GLenum c,GLint d,GLint e,GLsizei f,GLsizei g,GLint h)
{ D0(GLenum target); D1(GLint level); D2(GLenum internalformat); D3(GLint x); D4(GLint y); D5(GLsizei width); D6(GLsizei height); D7(GLint border);
glCopyTexImage2D(target,level,internalformat,x,y,width,height,border);
}

void APIENTRY smglCopyTexSubImage1D(GLenum a,GLint b,GLint c,GLint d,GLint e,GLsizei f)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint x); D4(GLint y); D5(GLsizei width);
glCopyTexSubImage1D(target,level,xoffset,x,y,width);
}

void APIENTRY smglCopyTexSubImage2D(GLenum a,GLint b,GLint c,GLint d,GLint e,GLint f,GLsizei g,GLsizei h)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint yoffset); D4(GLint x); D5(GLint y); D6(GLsizei width); D7(GLsizei height);
glCopyTexSubImage2D(target,level,xoffset,yoffset,x,y,width,height);
}

void APIENTRY smglMap1d(GLenum a,GLdouble b,GLdouble c,GLint d,GLint e,const GLdouble* f)
{ D0(GLenum target); FP0(GLdouble u1); FP1(GLdouble u2); D1(GLint stride); D2(GLint order); A0(const GLdouble* points);
glMap1d(target,u1,u2,stride,order,points);
}

void APIENTRY smglMap1f(GLenum a,GLfloat b,GLfloat c,GLint d,GLint e,const GLfloat* f)
{ D0(GLenum target); FP0(GLfloat u1); FP1(GLfloat u2); D1(GLint stride); D2(GLint order); A0(const GLfloat* points);
glMap1f(target,u1,u2,stride,order,points);
}

void APIENTRY smglMap2d(GLenum a,GLdouble b,GLdouble c,GLint d,GLint e,GLdouble f,GLdouble g,GLint h,GLint i,const GLdouble* j)
{ D0(GLenum target); FP0(GLdouble u1); FP1(GLdouble u2); D1(GLint ustride); D2(GLint uorder); FP2(GLdouble v1); FP3(GLdouble v2); D3(GLint vstride); D4(GLint vorder); A0(const GLdouble* points);
glMap2d(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);
}

void APIENTRY smglMap2f(GLenum a,GLfloat b,GLfloat c,GLint d,GLint e,GLfloat f,GLfloat g,GLint h,GLint i,const GLfloat* j)
{ D0(GLenum target); FP0(GLfloat u1); FP1(GLfloat u2); D1(GLint ustride); D2(GLint uorder); FP2(GLfloat v1); FP3(GLfloat v2); D3(GLint vstride); D4(GLint vorder); A0(GLfloat* points);
glMap2f(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);
}

void APIENTRY smglGetMapdv(GLenum a,GLenum b,GLdouble* c)
{ D0(GLenum target); D1(GLenum query); A0(GLdouble* v);
glGetMapdv(target,query,v);
}

void APIENTRY smglGetMapfv(GLenum a,GLenum b,GLfloat* c)
{ D0(GLenum target); D1(GLenum query); A0(GLfloat* v);
glGetMapfv(target,query,v);
}

void APIENTRY smglGetMapiv(GLenum a,GLenum b,GLint* c)
{ D0(GLenum target); D1(GLenum query); A0(GLint* v);
glGetMapiv(target,query,v);
}

void APIENTRY smglEvalCoord1d(GLdouble a)
{ FP0(GLdouble u);
glEvalCoord1d(u);
}

void APIENTRY smglEvalCoord1f(GLfloat a)
{ FP0(GLfloat u);
glEvalCoord1f(u);
}

void APIENTRY smglEvalCoord1dv(const GLdouble* a)
{ A0(const GLdouble* u);
glEvalCoord1dv(u);
}

void APIENTRY smglEvalCoord1fv(const GLfloat* a)
{ A0(const GLfloat* u);
glEvalCoord1fv(u);
}

void APIENTRY smglEvalCoord2d(GLdouble a,GLdouble b)
{ FP0(GLdouble u); FP1(GLdouble v);
glEvalCoord2d(u,v);
}

void APIENTRY smglEvalCoord2f(GLfloat a,GLfloat v)
{ FP0(GLfloat u); FP1(GLfloat v);
glEvalCoord2f(u,v);
}

void APIENTRY smglEvalCoord2dv(const GLdouble* a)
{ A0(const GLdouble* u);
glEvalCoord2dv(u);
}

void APIENTRY smglEvalCoord2fv(const GLfloat* a)
{ A0(const GLfloat* u);
glEvalCoord2fv(u);
}

void APIENTRY smglMapGrid1d(GLint a,GLdouble b,GLdouble c)
{ D0(GLint un); FP0(GLdouble u1); FP1(GLdouble u2);
glMapGrid1d(un,u1,u2);
}

void APIENTRY smglMapGrid1f(GLint a,GLfloat b,GLfloat c)
{ D0(GLint un); FP0(GLfloat u1); FP1(GLfloat u2);
glMapGrid1f(un,u1,u2);
}

void APIENTRY smglMapGrid2d(GLint a,GLdouble b,GLdouble c,GLint d,GLdouble e,GLdouble f)
{ D0(GLint un); FP0(GLdouble u1); FP1(GLdouble u2); D1(GLint vn); FP2(GLdouble v1); FP3(GLdouble v2);
glMapGrid2d(un,u1,u2,vn,v1,v2);
}

void APIENTRY smglMapGrid2f(GLint a,GLfloat b,GLfloat c,GLint d,GLfloat e,GLfloat f)
{ D0(GLint un); FP0(GLfloat u1); FP1(GLfloat u2); D1(GLint vn); FP2(GLfloat v1); FP3(GLfloat v2);
glMapGrid2f(un,u1,u2,vn,v1,v2);
}

void APIENTRY smglEvalPoint1(GLint a)
{ D0(GLint i);
glEvalPoint1(i);
}

void APIENTRY smglEvalPoint2(GLint a,GLint b)
{ D0(GLint i); D1(GLint j);
glEvalPoint2(i,j);
}

void APIENTRY smglEvalMesh1(GLenum a,GLint b,GLint c)
{ D0(GLenum mode); D1(GLint i1); D2(GLint i2);
glEvalMesh1(mode,i1,i2);
}

void APIENTRY smglEvalMesh2(GLenum a,GLint b,GLint c,GLint d,GLint e)
{ D0(GLenum mode); D1(GLint i1); D2(GLint i2); D3(GLint j1); D4(GLint j2);
glEvalMesh2(mode,i1,i2,j1,j2);
}

void APIENTRY smglFogf(GLenum a,GLfloat b)
{ D0(GLenum pname); FP0(GLfloat param);
glFogf(pname,param);
}

void APIENTRY smglFogi(GLenum a,GLint b)
{ D0(GLenum pname); D1(GLint param);
glFogi(pname,param);
}

void APIENTRY smglFogfv(GLenum a,const GLfloat* b)
{ D0(GLenum pname); A0(const GLfloat* params);
glFogfv(pname,params);
}

void APIENTRY smglFogiv(GLenum a,const GLint* b)
{ D0(GLenum pname); A0(const GLint* params);
glFogiv(pname,params);
}

void APIENTRY smglFeedbackBuffer(GLsizei a,GLenum b,GLfloat* c)
{ D0(GLsizei size); D1(GLenum type); A0(GLfloat* buffer);
glFeedbackBuffer(size,type,buffer);
}

void APIENTRY smglPassThrough(GLfloat a)
{ FP0(GLfloat token);
glPassThrough(token);
}

void APIENTRY smglSelectBuffer(GLsizei a,GLuint* b)
{ D0(GLsizei size); A0(GLuint* buffer);
glSelectBuffer(size,buffer);
}

void APIENTRY smglInitNames(void)
{
glInitNames();
}

void APIENTRY smglLoadName(GLuint a)
{ D0(GLuint name);
glLoadName(name);
}

void APIENTRY smglPushName(GLuint a)
{ D0(GLuint name);
glPushName(name);
}

void APIENTRY smglPopName(void)
{
glPopName();
}

void APIENTRY smglBlendEquationEXT(GLenum a)
{ D0(GLenum mode);
glBlendEquationEXT(mode);
}

void APIENTRY smglBlendColorEXT(GLclampf a,GLclampf b,GLclampf c,GLclampf d)
{ FP0(GLclampf red); FP1(GLclampf green); FP2(GLclampf blue); FP3(GLclampf alpha);
glBlendColorEXT(red,green,blue,alpha);
}

void APIENTRY smglPolygonOffsetEXT(GLfloat a,GLfloat b)
{ FP0(GLfloat factor); FP1(GLfloat bias);
glPolygonOffsetEXT(factor,bias);
}

void APIENTRY smglVertexPointerEXT(GLint a,GLenum b,GLsizei c,GLsizei d,const GLvoid* e)
{ D0(GLint size); D1(GLenum type); D2(GLsizei stride); D3(GLsizei count); A0(const GLvoid* ptr);
glVertexPointerEXT(size,type,stride,count,ptr);
}

void APIENTRY smglNormalPointerEXT(GLenum a,GLsizei b,GLsizei c,const GLvoid* d)
{ D0(GLenum type); D1(GLsizei stride); D2(GLsizei count); A0(const GLvoid* ptr);
glNormalPointerEXT(type,stride,count,ptr);
}

void APIENTRY smglColorPointerEXT(GLint a,GLenum b,GLsizei c,GLsizei d,const GLvoid* e)
{ D0(GLint size); D1(GLenum type); D2(GLsizei stride); D3(GLsizei count); A0(const GLvoid* ptr);
glColorPointerEXT(size,type,stride,count,ptr);
}

void APIENTRY smglIndexPointerEXT(GLenum a,GLsizei b,GLsizei c,const GLvoid* d)
{ D0(GLenum type); D1(GLsizei stride); D2(GLsizei count); A0(const GLvoid* ptr);
glIndexPointerEXT(type,stride,count,ptr);
}

void APIENTRY smglTexCoordPointerEXT(GLint a,GLenum b,GLsizei c,GLsizei d,const GLvoid* e)
{ D0(GLint size); D1(GLenum type); D2(GLsizei stride); D3(GLsizei count); A0(const GLvoid* ptr);
glTexCoordPointerEXT(size,type,stride,count,ptr);
}

void APIENTRY smglEdgeFlagPointerEXT(GLsizei a,GLsizei b,const GLboolean* c)
{ D0(GLsizei stride); D1(GLsizei count); A0(const GLboolean* ptr);
glEdgeFlagPointerEXT(stride,count,ptr);
}

void APIENTRY smglGetPointervEXT(GLenum a,void* b)
{ D0(GLenum pname); A0(void* *params);
glGetPointervEXT(pname,params);
}

void APIENTRY smglArrayElementEXT(GLint a)
{ D0(GLint i);
glArrayElementEXT(i);
}

void APIENTRY smglDrawArraysEXT(GLenum a,GLint b,GLsizei c)
{ D0(GLenum mode); D1(GLint first); D2(GLsizei count);
glDrawArraysEXT(mode,first,count);
}

void APIENTRY smglGenTexturesEXT(GLsizei a,GLuint* b)
{ D0(GLsizei n); A0(GLuint* textures);
glGenTexturesEXT(n,textures);
}

void APIENTRY smglDeleteTexturesEXT(GLsizei a,const GLuint* b)
{ D0(GLsizei n); A0(const GLuint* textures);
glDeleteTexturesEXT(n,textures);
}

void APIENTRY smglBindTextureEXT(GLenum  a,GLuint b)
{ D0(GLenum target); D1(GLuint texture);
glBindTextureEXT(target,texture);
}

void APIENTRY smglPrioritizeTexturesEXT(GLsizei a,const GLuint*  b,const GLclampf* c)
{ D0(GLsizei n); A0(const GLuint* textures); A1(const GLclampf* priorities);
glPrioritizeTexturesEXT(n,textures,priorities);
}

GLboolean APIENTRY smglAreTexturesResidentEXT(GLsizei a,const GLuint* b,GLboolean* c)
{ D0(GLsizei n); A0(const GLuint* textures); A1(GLboolean* residences);
return(glAreTexturesResidentEXT(n,textures,residences));
}

GLboolean APIENTRY smglIsTextureEXT( GLuint a )
{ D0(GLuint texture);
	return(glIsTextureEXT(texture));
}

void APIENTRY smglTexImage3DEXT(GLenum a,GLint b,GLenum c,GLsizei d,GLsizei e,GLsizei f,GLint g,GLenum h,GLenum i,const GLvoid* j)
{ D0(GLenum target); D1(GLint level); D2(GLenum internalformat); D3(GLsizei width); D4(GLsizei height); D5(GLsizei depth); D6(GLint border); D7(GLenum format); A0(GLenum type); A1(const GLvoid *pixels);
glTexImage3DEXT(target,level,internalformat,width,height,depth,border,format,type,pixels);
}

void APIENTRY smglTexSubImage3DEXT(GLenum a,GLint b,GLint c,GLint d,GLint e,GLsizei f,GLsizei g,GLsizei h,GLenum i,GLenum j,const GLvoid* k)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint yoffset); D4(GLint zoffset); D5(GLsizei width); D6(GLsizei height); D7(GLsizei depth); A0(GLenum format); A1(GLenum type); A2(const GLvoid *pixels);
glTexSubImage3DEXT(target,level,xoffset,yoffset,zoffset,width,height,depth,format,type,pixels);
}

void APIENTRY smglCopyTexSubImage3DEXT(GLenum a,GLint b,GLint c,GLint d,GLint e,GLint f,GLint g,GLsizei h,GLsizei i)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint yoffset); D4(GLint zoffset); D5(GLint x); D6(GLint y); D7(GLsizei width); A0(GLsizei height);
glCopyTexSubImage3DEXT(target,level,xoffset,yoffset,zoffset,x,y,width,height);
}

void APIENTRY smglColorTableEXT(GLenum a,GLenum b,GLsizei c,GLenum d,GLenum e,const GLvoid* f)
{ D0( GLenum target); D1(GLenum internalformat); D2(GLsizei width); D3(GLenum format); D4(GLenum type); A0(const GLvoid* table);
glColorTableEXT(target,internalformat,width,format,type,table);
}

void APIENTRY smglColorSubTableEXT(GLenum a,GLsizei b,GLsizei c,GLenum d,GLenum e,const GLvoid* f)
{ D0( GLenum target); D1(GLsizei start); D2(GLsizei count); D3(GLenum format); D4(GLenum type); A0(const GLvoid* data);
glColorSubTableEXT(target,start,count,format,type,data);
}

void APIENTRY smglGetColorTableEXT(GLenum a,GLenum b,GLenum c,GLvoid* d)
{ D0( GLenum target); D1(GLenum format); D2(GLenum type); A0(GLvoid* table);
glGetColorTableEXT(target,format,type,table);
}

void APIENTRY smglGetColorTableParameterfvEXT(GLenum a,GLenum b,GLfloat* c)
{ D0( GLenum target); D1(GLenum pname); A0(GLfloat* params);
glGetColorTableParameterfvEXT(target,pname,params);
}

void APIENTRY smglGetColorTableParameterivEXT(GLenum a,GLenum b,GLint* c)
{ D0( GLenum target); D1(GLenum pname); A0(GLint* params);
glGetColorTableParameterivEXT(target,pname,params);
}

void APIENTRY smglMultiTexCoord1dSGIS(GLenum a,GLdouble b)
{ D0(GLenum target); FP0(GLdouble s);
glMultiTexCoord1dSGIS(target,s);
}

void APIENTRY smglMultiTexCoord1dvSGIS(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord1dvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord1fSGIS(GLenum a,GLfloat b)
{ D0(GLenum target); FP0(GLfloat s);
glMultiTexCoord1fSGIS(target,s);
}

void APIENTRY smglMultiTexCoord1fvSGIS(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord1fvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord1iSGIS(GLenum a,GLint b)
{ D0(GLenum target); D1(GLint s);
glMultiTexCoord1iSGIS(target,s);
}

void APIENTRY smglMultiTexCoord1ivSGIS(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord1ivSGIS(target,v);
}

void APIENTRY smglMultiTexCoord1sSGIS(GLenum a,GLshort b)
{ D0(GLenum target); D1(GLshort s);
glMultiTexCoord1sSGIS(target,s);
}

void APIENTRY smglMultiTexCoord1svSGIS(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord1svSGIS(target,v);
}

void APIENTRY smglMultiTexCoord2dSGIS(GLenum a,GLdouble b,GLdouble c)
{ D0(GLenum target); FP0(GLdouble s); FP1(GLdouble t);
glMultiTexCoord2dSGIS(target,s,t);
}

void APIENTRY smglMultiTexCoord2dvSGIS(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord2dvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord2fSGIS(GLenum a,GLfloat b,GLfloat c)
{ D0(GLenum target); FP0(GLfloat s); FP1(GLfloat t);
glMultiTexCoord2fSGIS(target,s,t);
}

void APIENTRY smglMultiTexCoord2fvSGIS(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord2fvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord2iSGIS(GLenum a,GLint b,GLint c)
{ D0(GLenum target); D1(GLint s); D2(GLint t);
glMultiTexCoord2iSGIS(target,s,t);
}

void APIENTRY smglMultiTexCoord2ivSGIS(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord2ivSGIS(target,v);
}

void APIENTRY smglMultiTexCoord2sSGIS(GLenum a,GLshort b,GLshort c)
{ D0(GLenum target); D1(GLshort s); D2(GLshort t);
glMultiTexCoord2sSGIS(target,s,t);
}

void APIENTRY smglMultiTexCoord2svSGIS(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord2svSGIS(target,v);
}

void APIENTRY smglMultiTexCoord3dSGIS(GLenum a,GLdouble b,GLdouble c,GLdouble d)
{ D0(GLenum target); FP0(GLdouble s); FP1(GLdouble t); FP2(GLdouble r);
glMultiTexCoord3dSGIS(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3dvSGIS(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord3dvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord3fSGIS(GLenum a,GLfloat b,GLfloat c,GLfloat d)
{ D0(GLenum target); FP0(GLfloat s); FP1(GLfloat t); FP2(GLfloat r);
glMultiTexCoord3fSGIS(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3fvSGIS(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord3fvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord3iSGIS(GLenum a,GLint b,GLint c,GLint d)
{ D0(GLenum target); D1(GLint s); D2(GLint t); D3(GLint r);
glMultiTexCoord3iSGIS(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3ivSGIS(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord3ivSGIS(target,v);
}

void APIENTRY smglMultiTexCoord3sSGIS(GLenum a,GLshort b,GLshort c,GLshort d)
{ D0(GLenum target); D1(GLshort s); D2(GLshort t); D3(GLshort r);
glMultiTexCoord3sSGIS(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3svSGIS(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord3svSGIS(target,v);
}

void APIENTRY smglMultiTexCoord4dSGIS(GLenum a,GLdouble b,GLdouble c,GLdouble d,GLdouble e)
{ D0(GLenum target); FP0(GLdouble s); FP1(GLdouble t); FP2(GLdouble r); FP3(GLdouble q);
glMultiTexCoord4dSGIS(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4dvSGIS(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord4dvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord4fSGIS(GLenum a,GLfloat b,GLfloat c,GLfloat d,GLfloat e)
{ D0(GLenum target); FP0(GLfloat s); FP1(GLfloat t); FP2(GLfloat r); FP3(GLfloat q);
glMultiTexCoord4fSGIS(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4fvSGIS(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord4fvSGIS(target,v);
}

void APIENTRY smglMultiTexCoord4iSGIS(GLenum a,GLint b,GLint c,GLint d,GLint e)
{ D0(GLenum target); D1(GLint s); D2(GLint t); D3(GLint r); D4(GLint q);
glMultiTexCoord4iSGIS(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4ivSGIS(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord4ivSGIS(target,v);
}

void APIENTRY smglMultiTexCoord4sSGIS(GLenum a,GLshort b,GLshort c,GLshort d,GLshort e)
{ D0(GLenum target); D1(GLshort s); D2(GLshort t); D3(GLshort r); D4(GLshort q);
glMultiTexCoord4sSGIS(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4svSGIS(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord4svSGIS(target,v);
}

void APIENTRY smglMultiTexCoordPointerSGIS(GLenum a,GLint b,GLenum c,GLsizei d,const GLvoid* e)
{ D0(GLenum target); D1(GLint size); D2(GLenum type); D3(GLsizei stride); A0(const GLvoid* pointer);
glMultiTexCoordPointerSGIS(target,size,type,stride,pointer);
}

void APIENTRY smglSelectTextureSGIS(GLenum a)
{ D0(GLenum target);
glSelectTextureSGIS(target);
}

void APIENTRY smglSelectTextureCoordSetSGIS(GLenum a)
{ D0(GLenum target);
glSelectTextureCoordSetSGIS(target);
}

void APIENTRY smglMultiTexCoord1dEXT(GLenum a,GLdouble b)
{ D0(GLenum target); FP0(GLdouble s);
glMultiTexCoord1dEXT(target,s);
}

void APIENTRY smglMultiTexCoord1dvEXT(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord1dvEXT(target,v);
}

void APIENTRY smglMultiTexCoord1fEXT(GLenum a,GLfloat b)
{ D0(GLenum target); FP0(GLfloat s);
glMultiTexCoord1fEXT(target,s);
}

void APIENTRY smglMultiTexCoord1fvEXT(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord1fvEXT(target,v);
}

void APIENTRY smglMultiTexCoord1iEXT(GLenum a,GLint b)
{ D0(GLenum target); D1(GLint s);
glMultiTexCoord1iEXT(target,s);
}

void APIENTRY smglMultiTexCoord1ivEXT(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord1ivEXT(target,v);
}

void APIENTRY smglMultiTexCoord1sEXT(GLenum a,GLshort b)
{ D0(GLenum target); D1(GLshort s);
glMultiTexCoord1sEXT(target,s);
}

void APIENTRY smglMultiTexCoord1svEXT(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord1svEXT(target,v);
}

void APIENTRY smglMultiTexCoord2dEXT(GLenum a,GLdouble b,GLdouble c)
{ D0(GLenum target); FP0(GLdouble s); FP1(GLdouble t);
glMultiTexCoord2dEXT(target,s,t);
}

void APIENTRY smglMultiTexCoord2dvEXT(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord2dvEXT(target,v);
}

void APIENTRY smglMultiTexCoord2fEXT(GLenum a,GLfloat b,GLfloat c)
{ D0(GLenum target); FP0(GLfloat s); FP1(GLfloat t);
glMultiTexCoord2fEXT(target,s,t);
}

void APIENTRY smglMultiTexCoord2fvEXT(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord2fvEXT(target,v);
}

void APIENTRY smglMultiTexCoord2iEXT(GLenum a,GLint b,GLint c)
{ D0(GLenum target); D1(GLint s); D2(GLint t);
glMultiTexCoord2iEXT(target,s,t);
}

void APIENTRY smglMultiTexCoord2ivEXT(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord2ivEXT(target,v);
}

void APIENTRY smglMultiTexCoord2sEXT(GLenum a,GLshort b,GLshort c)
{ D0(GLenum target); D1(GLshort s); D2(GLshort t);
glMultiTexCoord2sEXT(target,s,t);
}

void APIENTRY smglMultiTexCoord2svEXT(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord2svEXT(target,v);
}

void APIENTRY smglMultiTexCoord3dEXT(GLenum a,GLdouble b,GLdouble c,GLdouble d)
{ D0(GLenum target); FP0(GLdouble s); FP1(GLdouble t); FP2(GLdouble r);
glMultiTexCoord3dEXT(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3dvEXT(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord3dvEXT(target,v);
}

void APIENTRY smglMultiTexCoord3fEXT(GLenum a,GLfloat b,GLfloat c,GLfloat d)
{ D0(GLenum target); FP0(GLfloat s); FP1(GLfloat t); FP2(GLfloat r);
glMultiTexCoord3fEXT(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3fvEXT(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord3fvEXT(target,v);
}

void APIENTRY smglMultiTexCoord3iEXT(GLenum a,GLint b,GLint c,GLint d)
{ D0(GLenum target); D1(GLint s); D2(GLint t); D3(GLint r);
glMultiTexCoord3iEXT(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3ivEXT(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord3ivEXT(target,v);
}

void APIENTRY smglMultiTexCoord3sEXT(GLenum a,GLshort b,GLshort c,GLshort d)
{ D0(GLenum target); D1(GLshort s); D2(GLshort t); D3(GLshort r);
glMultiTexCoord3sEXT(target,s,t,r);
}

void APIENTRY smglMultiTexCoord3svEXT(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord3svEXT(target,v);
}

void APIENTRY smglMultiTexCoord4dEXT(GLenum a,GLdouble b,GLdouble c,GLdouble d,GLdouble e)
{ D0(GLenum target); FP0(GLdouble s); FP1(GLdouble t); FP2(GLdouble r); FP3(GLdouble q);
glMultiTexCoord4dEXT(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4dvEXT(GLenum a,const GLdouble* b)
{ D0(GLenum target); A0(const GLdouble* v);
glMultiTexCoord4dvEXT(target,v);
}

void APIENTRY smglMultiTexCoord4fEXT(GLenum a,GLfloat b,GLfloat c,GLfloat d,GLfloat e)
{ D0(GLenum target); FP0(GLfloat s); FP1(GLfloat t); FP2(GLfloat r); FP3(GLfloat q);
glMultiTexCoord4fEXT(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4fvEXT(GLenum a,const GLfloat* b)
{ D0(GLenum target); A0(const GLfloat* v);
glMultiTexCoord4fvEXT(target,v);
}

void APIENTRY smglMultiTexCoord4iEXT(GLenum a,GLint b,GLint c,GLint d,GLint e)
{ D0(GLenum target); D1(GLint s); D2(GLint t); D3(GLint r); D4(GLint q);
glMultiTexCoord4iEXT(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4ivEXT(GLenum a,const GLint* b)
{ D0(GLenum target); A0(const GLint* v);
glMultiTexCoord4ivEXT(target,v);
}

void APIENTRY smglMultiTexCoord4sEXT(GLenum a,GLshort b,GLshort c,GLshort d,GLshort e)
{ D0(GLenum target); D1(GLshort s); D2(GLshort t); D3(GLshort r); D4(GLshort q);
glMultiTexCoord4sEXT(target,s,t,r,q);
}

void APIENTRY smglMultiTexCoord4svEXT(GLenum a,const GLshort* b)
{ D0(GLenum target); A0(const GLshort* v);
glMultiTexCoord4svEXT(target,v);
}

void APIENTRY smglInterleavedTextureCoordSetsEXT(GLint a)
{ D0(GLint factor);
glInterleavedTextureCoordSetsEXT(factor);
}

void APIENTRY smglSelectTextureEXT(GLenum a)
{ D0(GLenum target);
glSelectTextureEXT(target);
}

void APIENTRY smglSelectTextureCoordSetEXT(GLenum a)
{ D0(GLenum target);
glSelectTextureCoordSetEXT(target);
}

void APIENTRY smglSelectTextureTransformEXT(GLenum a)
{ D0(GLenum target);
glSelectTextureTransformEXT(target);
}

void APIENTRY smglPointParameterfEXT(GLenum a,GLfloat b)
{ D0( GLenum pname); FP0(GLfloat param);
glPointParameterfEXT(pname,param);
}

void APIENTRY smglPointParameterfvEXT(GLenum a,const GLfloat* b)
{ D0( GLenum pname); A0(const GLfloat* params);
glPointParameterfvEXT(pname,params);
}

void APIENTRY smglWindowPos2iMESA(GLint a,GLint b)
{ D0(GLint x); D1(GLint y);
glWindowPos2iMESA(x,y);
}

void APIENTRY smglWindowPos2sMESA(GLshort a,GLshort b)
{ D0(GLshort x); D1(GLshort y);
glWindowPos2sMESA(x,y);
}

void APIENTRY smglWindowPos2fMESA(GLfloat a,GLfloat b)
{ FP0(GLfloat x); FP1(GLfloat y);
glWindowPos2fMESA(x,y);
}

void APIENTRY smglWindowPos2dMESA(GLdouble a,GLdouble b)
{ FP0(GLdouble x); FP1(GLdouble y);
glWindowPos2dMESA(x,y);
}

void APIENTRY smglWindowPos2ivMESA(const GLint* a)
{ A0(const GLint* p);
glWindowPos2ivMESA(p);
}

void APIENTRY smglWindowPos2svMESA(const GLshort* a)
{ A0(const GLshort* p);
glWindowPos2svMESA(p);
}

void APIENTRY smglWindowPos2fvMESA(const GLfloat* a)
{ A0(const GLfloat* p);
glWindowPos2fvMESA(p);
}

void APIENTRY smglWindowPos2dvMESA(const GLdouble* a)
{ A0(const GLdouble* p);
glWindowPos2dvMESA(p);
}

void APIENTRY smglWindowPos3iMESA(GLint a,GLint b,GLint c)
{ D0(GLint x); D1(GLint y); D2(GLint z);
glWindowPos3iMESA(x,y,z);
}

void APIENTRY smglWindowPos3sMESA(GLshort a,GLshort b,GLshort c)
{ D0(GLshort x); D1(GLshort y); D2(GLshort z);
glWindowPos3sMESA(x,y,z);
}

void APIENTRY smglWindowPos3fMESA(GLfloat a,GLfloat b,GLfloat c)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z);
glWindowPos3fMESA(x,y,z);
}

void APIENTRY smglWindowPos3dMESA(GLdouble a,GLdouble b,GLdouble c)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z);
glWindowPos3dMESA(x,y,z);
}

void APIENTRY smglWindowPos3ivMESA(const GLint* a)
{ A0(const GLint* p);
glWindowPos3ivMESA(p);
}

void APIENTRY smglWindowPos3svMESA(const GLshort* a)
{ A0(const GLshort* p);
glWindowPos3svMESA(p);
}

void APIENTRY smglWindowPos3fvMESA(const GLfloat* a)
{ A0(const GLfloat* p);
glWindowPos3fvMESA(p);
}

void APIENTRY smglWindowPos3dvMESA(const GLdouble* a)
{ A0(const GLdouble* p);
glWindowPos3dvMESA(p);
}

void APIENTRY smglWindowPos4iMESA(GLint a,GLint b,GLint c,GLint d)
{ D0(GLint x); D1(GLint y); D2(GLint z); D3(GLint w);
glWindowPos4iMESA(x,y,z,w);
}

void APIENTRY smglWindowPos4sMESA(GLshort a,GLshort b,GLshort c,GLshort d)
{ D0(GLshort x); D1(GLshort y); D2(GLshort z); D3(GLshort w);
glWindowPos4sMESA(x,y,z,w);
}

void APIENTRY smglWindowPos4fMESA(GLfloat a,GLfloat b,GLfloat c,GLfloat d)
{ FP0(GLfloat x); FP1(GLfloat y); FP2(GLfloat z); FP3(GLfloat w);
glWindowPos4fMESA(x,y,z,w);
}

void APIENTRY smglWindowPos4dMESA(GLdouble a,GLdouble b,GLdouble c,GLdouble d)
{ FP0(GLdouble x); FP1(GLdouble y); FP2(GLdouble z); FP3(GLdouble w);
glWindowPos4dMESA(x,y,z,w);
}

void APIENTRY smglWindowPos4ivMESA(const GLint* a)
{ A0(const GLint* p);
glWindowPos4ivMESA(p);
}

void APIENTRY smglWindowPos4svMESA(const GLshort* a)
{ A0(const GLshort* p);
glWindowPos4svMESA(p);
}

void APIENTRY smglWindowPos4fvMESA(const GLfloat* a)
{ A0(const GLfloat* p);
glWindowPos4fvMESA(p);
}

void APIENTRY smglWindowPos4dvMESA(const GLdouble* a)
{ A0(const GLdouble* p);
glWindowPos4dvMESA(p);
}

void APIENTRY smglResizeBuffersMESA()
{
glResizeBuffersMESA();
}

void APIENTRY smglDrawRangeElements(GLenum a,GLuint b,GLuint c,GLsizei d,GLenum e,const GLvoid* f)
{ D0(GLenum mode); D1(GLuint start); D2(GLuint end); D3(GLsizei count); D4(GLenum type); A0(const GLvoid* indices);
glDrawRangeElements(mode,start,end,count,type,indices);
}

void APIENTRY smglTexImage3D(GLenum a,GLint b,GLenum c,GLsizei d,GLsizei e,GLsizei f,GLint g,GLenum h,GLenum i,const GLvoid* j)
{ D0(GLenum target); D1(GLint level); D2(GLenum internalFormat); D3(GLsizei width); D4(GLsizei height); D5(GLsizei depth); D6(GLint border); D7(GLenum format); A0(GLenum type); A1(const GLvoid *pixels);
glTexImage3D(target,level,internalFormat,width,height,depth,border,format,type,pixels);
}

void APIENTRY smglTexSubImage3D(GLenum a,GLint b,GLint c,GLint d,GLint e,GLsizei f,GLsizei g,GLsizei h,GLenum i,GLenum j,const GLvoid* k)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint yoffset); D4(GLint zoffset); D5(GLsizei width); D6(GLsizei height); D7(GLsizei depth); A0(GLenum format); A1(GLenum type); A2(const GLvoid *pixels);
glTexSubImage3D(target,level,xoffset,yoffset,zoffset,width,height,depth,format,type,pixels);
}

void APIENTRY smglCopyTexSubImage3D(GLenum a,GLint b,GLint c,GLint d,GLint e,GLint f,GLint g,GLsizei h,GLsizei i)
{ D0(GLenum target); D1(GLint level); D2(GLint xoffset); D3(GLint yoffset); D4(GLint zoffset); D5(GLint x); D6(GLint y); D7(GLsizei width); A0(GLsizei height);
glCopyTexSubImage3D(target,level,xoffset,yoffset,zoffset,x,y,width,height);
}
